'交差自動メッシュ生成の計算実行ﾌﾟﾛｸﾞﾗﾑ

Public Class MeshAuc5M
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(64, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(160, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "交差メッシュ生成の計算"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(16, 40)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'MeshAuc5M
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "MeshAuc5M"
        Me.Text = "MeshAuc5M"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim Nelemb As Integer       '断面の要素数
    Dim Npointb As Integer      '断面の節点数
    Dim Npv As Integer          '断面の頂点節点数
    Dim NRb As Integer          '右端面のﾍﾞｰｽ節点数
    Dim Ns2 As Integer          '両端面間の総ﾒｯｼｭ数（含中間節点ﾒｯｼｭ）

    Dim Jpoint() As Integer     '節点ﾌﾗｯｸﾞ（0:頂点ﾌﾗｯｸﾞ、1:中間節点）
    Dim NLelem(,) As Integer    '左端断面の要素ﾃﾞｰﾀ
    Dim NumMatL() As Integer    '左端断面要素の材料番号（右端面は自動的に同一）
    Dim NumNodeV() As Integer   '面内の頂点節点順位

    Dim CosXb(3), CosYb(3) As Single  '断面X,Y軸の全体X,Y,Z軸に対する方向余弦
    Dim XL(), YL() As Single  '左端断面における節点座標

    Private Sub CrossPlaneCalF()
        '交差面の計算（角柱用）
        Dim ip As Single
        Dim angleb, cosb, sinb, xb, yb, zb As Single

        angleb = Pai * AngleMesh / 180
        sinb = Math.Sin(angleb)
        cosb = Math.Cos(angleb)
        For ip = 1 To Npointb
            xb = Xdata(ip)
            yb = Ydata(ip)
            zb = Zdata(ip)
            Ymodel(ip) = Vbase
            If AngleMesh = 90 Then
                Xmodel(ip) = xb
            Else
                Xmodel(ip) = xb - Math.Abs((yb - Vbase) / sinb) * cosb
            End If
            Zmodel(ip) = zb
        Next ip

        NRb = (Npointb + Npv) * Nsect   '右端面のﾍﾞｰｽ節点数
        Call SectStore(NRb, Npointb)  '断面の座標データ保存

    End Sub

    Private Sub CrossPlaneCalR()
        '交差面の計算（円柱用）
        Dim ip As Single
        Dim angleb, b1, cosb, sinb, xb, yb, zb As Single

        angleb = Pai * AngleMesh / 180
        sinb = Math.Sin(angleb)
        cosb = Math.Cos(angleb)
        For ip = 1 To Npointb
            xb = Xdata(ip)
            yb = Ydata(ip)
            zb = Zdata(ip)
            b1 = Vbase * Vbase - zb * zb
            If b1 < 0 Then
                b1 = 0
                If zb > 0 Then
                    Zmodel(ip) = Vbase
                Else
                    Zmodel(ip) = -Vbase
                End If
            Else
                b1 = -Math.Sqrt(b1)
                Zmodel(ip) = zb
            End If
            Ymodel(ip) = b1
            If AngleMesh = 90 Then
                Xmodel(ip) = xb
            Else
                Xmodel(ip) = xb - Math.Abs((yb - b1) / sinb) * cosb
            End If
        Next ip

        NRb = (Npointb + Npv) * Nsect   '右端面のﾍﾞｰｽ節点数
        Call SectStore(NRb, Npointb)  '断面の座標データ保存

    End Sub

    Private Sub Debug2()
        '要素データと節点データを出力して停止
        Dim aa$, fxx$
        Dim ie, ip, j, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\MeshAuz5debug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "要素データ（要素番号、8節点番号）"
        For ie = 1 To Nelem
            aa$ = Str$(ie)
            For j = 1 To 10
                aa$ = aa$ + "," + Str$(NNelem(ie, j))
            Next j
            PrintLine(ii, aa$)
            aa$ = "  " + Str$(NNelem(ie, 11))
            For j = 12 To 20
                aa$ = aa$ + "," + Str$(NNelem(ie, j))
            Next j
            PrintLine(ii, aa$)
        Next ie
        aa$ = "節点データ（節点番号、Ｘ、Ｙ、Ｚ）"
        For ip = 1 To Npoint
            aa$ = Str$(ip)
            aa$ = aa$ + ",  " + Str$(Xdata(ip))
            aa$ = aa$ + ",  " + Str$(Ydata(ip))
            aa$ = aa$ + ",  " + Str$(Zdata(ip))
            PrintLine(ii, aa$)
        Next ip
        FileClose(ii)
        Stop
    End Sub

    Private Sub ElemGene()
        '六面体要素の作成
        Dim ie, ielem, isect, j, jj, nb0, nb1, nb2, nset As Integer
        Dim kbuf(8), kvbuf(8) As Integer
        ielem = 0
        nset = Npointb + Npv
        For isect = 1 To Nsect
            nb0 = nset * (isect - 1)
            nb1 = nb0 + Npointb
            nb2 = nb1 + Npv
            For ie = 1 To Nelemb
                For j = 1 To 8
                    kbuf(j) = NLelem(ie, j)
                    kvbuf(j) = NumNodeV(kbuf(j))
                Next j
                ielem = ielem + 1
                NumMat(ielem) = NumMatL(ie)
                For j = 1 To 8
                    NNelem(ielem, j) = kbuf(j) + nb0
                    NNelem(ielem, j + 12) = kbuf(j) + nb2
                Next j
                For j = 1 To 4
                    jj = 2 * j - 1
                    NNelem(ielem, j + 8) = kvbuf(jj) + nb1
                Next j
            Next ie
        Next isect

    End Sub

    Private Sub LeftPlaneCalc()
        '左端面の座標計算
        Dim ip As Integer
        For ip = 1 To Npointb
            Xmodel(ip) = XL(ip) * CosLX(1) + YL(ip) * CosLY(1) + Xsect(0)
            Ymodel(ip) = XL(ip) * CosLX(2) + YL(ip) * CosLY(2) + Ysect(0)
            Zmodel(ip) = XL(ip) * CosLX(3) + YL(ip) * CosLY(3) + Zsect(0)
        Next ip
        Call SectStore(0, Npointb)  '断面の座標データ保存

    End Sub

    Private Sub LeftPlaneData()
        '左端断面のﾃﾞｰﾀ設定
        Dim aa$
        Dim ie, ip, j, kh As Integer

        kh = 0
        Try
            Call SfileInputU(Faum$)    '断面ﾃﾞｰﾀﾌｧｲﾙの読み込み
        Catch ex As Exception
            kh = -1
        End Try
        If kh < 0 Then
            aa$ = "左端断面データファイルを読み込めません！"
            MsgBox(aa$, 0, "ファイルエラー")
            Me.Close()
        End If
        ReDim Jpoint(Npoint), NumNodeV(Npoint)
        ReDim NLelem(Nelem, 8), NumMatL(Nelem), XL(Npoint), YL(Npoint)
        ReDim Xmodel(Npoint), Ymodel(Npoint), Zmodel(Npoint)

        Ns2 = 2 * Nsect
        For ie = 1 To Nelem
            NumMatL(ie) = NumMat(ie)
            For j = 1 To 8
                NLelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie
        For ip = 1 To Npoint
            XL(ip) = X(ip) - XBL
            YL(ip) = Y(ip) - YBL
        Next ip
        Nelemb = Nelem
        Npointb = Npoint

    End Sub

    Private Sub MeshPlaneCalc()
        '各ﾒｯｼｭ面の座標計算2
        Dim ic, ii, ip, isect, j, nb, nn As Integer
        Dim b1, b2, b3 As Single
        Dim buf(3) As Single

        b1 = Ns2
        nn = Npointb
        ic = 1
        For isect = 1 To Ns2 - 1
            b2 = isect / b1
            b3 = 1 - b2
            If ic = 0 Then  '主ﾒｯｼｭ面の場合
                nb = Npointb
                For ip = 1 To Npointb
                    j = NRb + ip
                    Xmodel(ip) = Xdata(ip) * b3 + Xdata(j) * b2
                    Ymodel(ip) = Ydata(ip) * b3 + Ydata(j) * b2
                    Zmodel(ip) = Zdata(ip) * b3 + Zdata(j) * b2
                Next ip
            Else    '中間ﾒｯｼｭ面の場合
                nb = Npv
                ii = 0
                For ip = 1 To Npointb
                    If Jpoint(ip) = 0 Then
                        ii = ii + 1
                        j = NRb + ip
                        Xmodel(ii) = Xdata(ip) * b3 + Xdata(j) * b2
                        Ymodel(ii) = Ydata(ip) * b3 + Ydata(j) * b2
                        Zmodel(ii) = Zdata(ip) * b3 + Zdata(j) * b2
                    End If
                Next ip
            End If
            Call SectStore(nn, nb)  '断面の座標データ保存
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
            nn = nn + nb
        Next isect

    End Sub

    Private Sub NodeCount()
        '面内の頂点節点の個数算出
        Dim ib, ie, ip, j, nb As Integer
        Dim kbuf(Npointb) As Integer
        Npv = 0
        For ie = 1 To Nelemb
            For j = 1 To 7 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    Npv = Npv + 1
                    kbuf(ib) = 1
                    Jpoint(ib) = 0
                End If
            Next j
            For j = 2 To 8 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    kbuf(ib) = 1
                    Jpoint(ib) = 1
                End If
            Next j
        Next ie
        nb = 0
        For ip = 1 To Npointb
            If Jpoint(ip) = 0 Then
                nb = nb + 1
                NumNodeV(ip) = nb
            End If
        Next ip

    End Sub

    Private Sub SectStore(ByVal ib As Integer, ByVal nb As Integer)
        '断面の座標データ保存
        'ib･･･ﾍﾞｰｽ節点数
        'nb･･･節点数
        Dim ii, ip As Integer
        For ip = 1 To nb
            ii = ib + ip
            Xdata(ii) = Xmodel(ip)
            Ydata(ii) = Ymodel(ip)
            Zdata(ii) = Zmodel(ip)
        Next ip

    End Sub

    Private Sub MeshAuc5M_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, fb$, titleb$
        Dim ix, kh As Integer

        fb$ = ""
        titleb$ = Title$
        Me.Show()

        Label2.Text = "計算中！ しばらくお待ちください。"

        Call LeftPlaneData() '左端断面のﾃﾞｰﾀ設定

        Nelem = Nelemb * Nsect
        Call NodeCount() '面内の頂点節点の個数算出
        Npoint = Npointb * (Nsect + 1) + Npv * Nsect
        ReDim NNelem(Nelem, 20), NumMat(Nelem)
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)

        Call LeftPlaneCalc() '左端面の座標計算

        If KindBase = 0 Then
            Call CrossPlaneCalR()   '交差面の計算（円柱用）
        Else
            Call CrossPlaneCalF()   '交差面の計算（角柱用）
        End If

        Call MeshPlaneCalc() '各ﾒｯｼｭ面の座標計算

        Call ElemGene()     '六面体要素の作成
        NEcross = Nelemb
        Title$ = titleb$

        Call DataCheckS(kh)    '入力ﾃﾞｰﾀのｴﾗｰﾁｪｯｸ
        If kh < 0 Then
            aa$ = "生成したメッシュデータにエラーがありました！"
            MsgBox(aa$, 0, "メッシュ生成エラー")
        Else
            KdataChange5 = 2
            Label2.Text = "計算終了！"
            aa$ = "交差柱状体を構造データファイルへ出力しますか？"
            Me.BringToFront()
            ix = MsgBox(aa$, 4, "計算終了確認")
            If ix = 6 Then
                If Fauc$ <> "" Then
                    Call FileName(Fauc$, fb$)
                    'ﾌｧｲﾙ名Fauc$から拡張子なしの部分fb$を取得
                    Fm$ = fb$ + ".au3"
                End If
                InOut = 1
                Dim frm As Form = New SolDDat6() '3D構造ﾃﾞｰﾀﾌｧｲﾙ出力
                frm.Show()
            End If
        End If

        Me.Close()

    End Sub
End Class
