'自動メッシュ生成の計算実行ﾌﾟﾛｸﾞﾗﾑ
'材料番号入り断面ﾃﾞｰﾀに対応

Public Class MeshAuz5M
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(64, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(160, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "自動メッシュ生成の計算"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(16, 40)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'MeshAuz5M
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "MeshAuz5M"
        Me.Text = "MeshAuz5M"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim KindRad As Integer      '放射ﾒｯｼｭの種類（0:全周、1:部分周）
    Dim Ncenter As Integer      '軸回転体の軸上の節点数
    Dim Nelemb As Integer       '断面の要素数
    Dim Npadd As Integer        '中心穴なしの軸回転体で断面の追加節点数
    Dim Npbase As Integer       '軸回転体で中心穴なしの基本節点数
    Dim Npointb As Integer      '断面の節点数
    Dim Npv As Integer          '断面の頂点節点数
    Dim NRb As Integer          '右端面のﾍﾞｰｽ節点数
    Dim Ns2 As Integer          '両端面間の総ﾒｯｼｭ数（含中間節点ﾒｯｼｭ）

    Dim Jpoint() As Integer     '節点ﾌﾗｯｸﾞ（0:頂点ﾌﾗｯｸﾞ、1:中間節点）
    Dim NLadd(,) As Integer     '端面要素の追加節点番号
    Dim NLelem(,) As Integer    '左端断面の要素ﾃﾞｰﾀ
    Dim NRelem(,) As Integer    '右端断面の要素ﾃﾞｰﾀ
    Dim NumMatL() As Integer    '左端断面要素の材料番号（右端面は自動的に同一）
    Dim NumNodeV() As Integer   '面内の頂点節点順位

    Dim CosXb(3), CosYb(3) As Single  '断面X,Y軸の全体X,Y,Z軸に対する方向余弦
    Dim XLadd(), YLadd() As Single '中心穴なしの軸回転体で断面追加節点の端面座標
    Dim XL(), YL() As Single  '左端断面における節点座標
    Dim XLdat(), YLdat(), ZLdat() As Single '左端面節点の全体座標
    Dim XM(), YM() As Single  '中間断面における節点座標
    Dim XR(), YR() As Single  '右端断面における節点座標
    Dim XRdat(), YRdat(), ZRdat() As Single '右端面節点の全体座標

    Private Sub AddPoint(ByVal i1 As Integer, ByVal i2 As Integer, _
        ByVal i3 As Integer)
        '追加節点の座標計算
        'i1,i2,i3･･･3節点番号
        'ie･･･要素番号
        'k･･･操作辺番号(1または2)
        Dim area, b1, b2, b3, eps, rc, th1, th2, th3 As Single
        Dim x1, x2, x3, xc, y1, y2, y3, yc As Single
        x1 = XL(i1) : y1 = YL(i1)
        x2 = XL(i2) : y2 = YL(i2)
        x3 = XL(i3) : y3 = YL(i3)
        b1 = x3 - x1
        b2 = y3 - y1
        b3 = b1 * b1 + b2 * b2
        eps = 0.001 * b3
        Call AreaCalc(area, x1, y1, x3, y3, x2, y2) '三角形の符号付き面積算出
        If Math.Abs(area) < eps Then    '直線辺の場合
            Npadd = Npadd + 1
            XLadd(Npadd) = 0.5 * (x1 + x2)
            YLadd(Npadd) = 0.5 * (y1 + y2)
            Npadd = Npadd + 1
            XLadd(Npadd) = 0.5 * (x3 + x2)
            YLadd(Npadd) = 0.5 * (y3 + y2)
        Else    '円弧辺の場合
            Call CircleData(x1, y1, x2, y2, x3, y3, xc, yc, rc, th1, th2, th3)
            '円弧ﾃﾞｰﾀ計算

            Npadd = Npadd + 1
            b1 = 0.5 * (th1 + th2)
            XLadd(Npadd) = rc * Math.Cos(b1)
            YLadd(Npadd) = rc * Math.Sin(b1)
            Npadd = Npadd + 1
            b1 = 0.5 * (th3 + th2)
            XLadd(Npadd) = rc * Math.Cos(b1)
            YLadd(Npadd) = rc * Math.Sin(b1)
        End If

    End Sub

    Private Sub AreaCalc(ByRef area As Single, ByVal x1 As Single, _
    ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, _
    ByVal xb As Single, ByVal yb As Single)
        '三角形の符号付き面積算出（最初の2点に対して左側は正、右側は負）
        'area･･･符号付き面積、三角形の2倍
        'x1,y1,x2,y2･･･2点の座標
        'xb,yb･･･対象点の座標
        area = x1 * y2 - y1 * x2 + x2 * yb - y2 * xb + xb * y1 - yb * x1
    End Sub

    Private Sub CircleData(ByVal x1 As Single, ByVal y1 As Single, _
        ByVal x2 As Single, ByVal y2 As Single, ByVal x3 As Single, _
        ByRef y3 As Single, ByRef xc As Single, ByRef yc As Single, _
        ByVal rc As Single, ByRef th1 As Single, ByRef th2 As Single, _
        ByRef th3 As Single)
        '円弧ﾃﾞｰﾀ計算
        'ie･･･線分番号
        'i,j,k･･･3点の番号
        Dim ic, ii As Integer
        Dim a1, a2, area, b1, b2, b3, b4, c1, c2 As Single
        Dim hpai, xx, yy As Single
        Dim buf(3) As Single

        hpai = 1.570796
        a1 = 2 * (x1 - x2)
        b1 = 2 * (y1 - y2)
        c1 = (x1 * x1 - x2 * x2) + (y1 * y1 - y2 * y2)
        a2 = 2 * (x1 - x3)
        b2 = 2 * (y1 - y3)
        c2 = (x1 * x1 - x3 * x3) + (y1 * y1 - y3 * y3)
        xx = a1 * b2 - a2 * b1
        yy = c1 * b2 - c2 * b1
        xc = yy / xx
        yy = a1 * c2 - a2 * c1
        yc = yy / xx
        b1 = x1 - xc
        b2 = y1 - yc
        rc = Math.Sqrt(b1 * b1 + b2 * b2)

        For ii = 1 To 3
            Select Case ii
                Case 1
                    b1 = x1 : b2 = y1
                Case 2
                    b1 = x2 : b2 = y2
                Case 3
                    b1 = x3 : b2 = y3
            End Select
            b3 = b1 - xc
            b4 = b2 - yc
            If b3 = 0 Then
                If b4 > 0 Then
                    buf(ii) = hpai
                Else
                    buf(ii) = -hpai
                End If
            ElseIf b4 = 0 Then
                If b3 > 0 Then
                    buf(ii) = 0
                Else
                    buf(ii) = Pai
                End If
            Else
                buf(ii) = Math.Atan(b4 / b3)
                If b3 < 0 Then
                    buf(ii) = buf(ii) + Pai
                End If
            End If
        Next ii
        th1 = buf(1)
        th2 = buf(2)
        th3 = buf(3)

        Call AreaCalc(area, x1, y1, x2, y2, xc, yc) '三角形の符号付き面積算出
        If area > 0 Then '左回り
            Do
                ic = 0
                If th2 < th1 Then
                    ic = 1
                    th2 = th2 + Dpai
                End If
                If th3 < th2 Then
                    ic = 1
                    th3 = th3 + Dpai
                End If
            Loop While ic = 0
        Else    '右回り
            Do
                ic = 0
                If th2 < th3 Then
                    ic = 1
                    th2 = th2 + Dpai
                End If
                If th1 < th2 Then
                    ic = 1
                    th1 = th1 + Dpai
                End If
            Loop While ic = 0
        End If

    End Sub

    Private Sub Debug2()
        '要素データと節点データを出力して停止
        Dim aa$, fxx$
        Dim ie, ip, j, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\MeshAuz5debug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "要素データ（要素番号、8節点番号）"
        For ie = 1 To Nelem
            aa$ = Str$(ie)
            For j = 1 To 10
                aa$ = aa$ + "," + Str$(NNelem(ie, j))
            Next j
            PrintLine(ii, aa$)
            aa$ = "  " + Str$(NNelem(ie, 11))
            For j = 12 To 20
                aa$ = aa$ + "," + Str$(NNelem(ie, j))
            Next j
            PrintLine(ii, aa$)
        Next ie
        aa$ = "節点データ（節点番号、Ｘ、Ｙ、Ｚ）"
        For ip = 1 To Npoint
            aa$ = Str$(ip)
            aa$ = aa$ + ",  " + Str$(Xdata(ip))
            aa$ = aa$ + ",  " + Str$(Ydata(ip))
            aa$ = aa$ + ",  " + Str$(Zdata(ip))
            PrintLine(ii, aa$)
        Next ip
        FileClose(ii)
        Stop
    End Sub

    Private Sub ElemGene()
        '六面体要素の作成
        Dim ie, ielem, isect, j, jj, nb0, nb1, nb2, nset As Integer
        Dim kbuf(8), kvbuf(8) As Integer
        ielem = 0
        nset = Npointb + Npv
        For isect = 1 To Nsect
            nb0 = nset * (isect - 1)
            nb1 = nb0 + Npointb
            nb2 = nb1 + Npv
            For ie = 1 To Nelemb
                For j = 1 To 8
                    kbuf(j) = NLelem(ie, j)
                    kvbuf(j) = NumNodeV(kbuf(j))
                Next j
                ielem = ielem + 1
                NumMat(ielem) = NumMatL(ie)
                For j = 1 To 8
                    NNelem(ielem, j) = kbuf(j) + nb0
                    NNelem(ielem, j + 12) = kbuf(j) + nb2
                Next j
                For j = 1 To 4
                    jj = 2 * j - 1
                    NNelem(ielem, j + 8) = kvbuf(jj) + nb1
                Next j
            Next ie
        Next isect

    End Sub

    Private Sub ElemGeneR()
        '軸回転体の六面体要素の作成
        Dim ib, ic, ie, ielem, iex, ii, isect As Integer
        Dim j, jj, nb0, nb1, nb2, nset As Integer
        Dim kbuf(8), kvbuf(8) As Integer
        ielem = 0
        nset = Npointb + Npv
        For isect = 1 To Nsect
            ib = isect Mod 2
            nb0 = nset * (isect - 1)
            If isect > 2 Then
                nb0 = nb0 + Int((isect - 1) / 2) * Npadd
            End If
            nb1 = nb0 + Npointb
            If ib = 0 Then
                nb1 = nb1 + Npadd
            End If
            If KindRad = 0 And isect = Nsect Then
                nb2 = 0
            Else
                nb2 = nb1 + Npv
            End If
            For ie = 1 To Nelemb    '半断面の要素順に六面体要素を作成
                ic = 0
                For j = 1 To 8
                    kbuf(j) = NLelem(ie, j)
                    kvbuf(j) = NumNodeV(kbuf(j))
                    If kbuf(j) <= Ncenter Then
                        ic = 1
                    End If
                Next j
                ielem = ielem + 1
                NumMat(ielem) = NumMatL(ie)
                If ic = 0 Then  '回転軸に節点がない場合
                    For j = 1 To 8
                        NNelem(ielem, j) = kbuf(j) + nb0
                        NNelem(ielem, j + 12) = kbuf(j) + nb2
                    Next j
                    For j = 1 To 4
                        jj = 2 * j - 1
                        NNelem(ielem, j + 8) = kvbuf(jj) + nb1
                    Next j
                Else    '回転軸に節点がある場合
                    ii = NLadd(ie, 0)
                    jj = 2 * ii - 1
                    For j = 1 To 3
                        NNelem(ielem, jj) = kbuf(jj)
                        jj = jj + 1
                        If jj > 8 Then
                            jj = 1
                        End If
                    Next
                    If ib = 1 Then '奇数ﾒｯｼｭの場合
                        For j = 1 To 5
                            NNelem(ielem, jj) = kbuf(jj) + nb0
                            jj = jj + 1
                            If jj > 8 Then
                                jj = 1
                            End If
                        Next j
                        Select Case ii
                            Case 1
                                NNelem(ielem, 9) = Npointb + NLadd(ie, 4) + nb2
                                NNelem(ielem, 10) = Npointb + NLadd(ie, 1) + nb2
                                NNelem(ielem, 11) = kvbuf(5) + nb1
                                NNelem(ielem, 12) = kvbuf(7) + nb1
                                NNelem(ielem, 13) = kbuf(8) + nb2
                                NNelem(ielem, 14) = Npointb + NLadd(ie, 5) + nb2
                                NNelem(ielem, 15) = kbuf(4) + nb2
                                NNelem(ielem, 16) = Npointb + NLadd(ie, 2) + nb2
                                NNelem(ielem, 17) = kbuf(5) + nb2
                                NNelem(ielem, 18) = kbuf(6) + nb2
                                NNelem(ielem, 19) = kbuf(7) + nb2
                                NNelem(ielem, 20) = Npointb + NLadd(ie, 3) + nb2
                            Case 2
                                NNelem(ielem, 9) = kvbuf(1) + nb1
                                NNelem(ielem, 10) = Npointb + NLadd(ie, 4) + nb2
                                NNelem(ielem, 11) = Npointb + NLadd(ie, 1) + nb2
                                NNelem(ielem, 12) = kvbuf(7) + nb1
                                NNelem(ielem, 13) = kbuf(1) + nb2
                                NNelem(ielem, 14) = Npointb + NLadd(ie, 3) + nb2
                                NNelem(ielem, 15) = kbuf(2) + nb2
                                NNelem(ielem, 16) = Npointb + NLadd(ie, 5) + nb2
                                NNelem(ielem, 17) = kbuf(6) + nb2
                                NNelem(ielem, 18) = Npointb + NLadd(ie, 2) + nb2
                                NNelem(ielem, 19) = kbuf(7) + nb2
                                NNelem(ielem, 20) = kbuf(8) + nb2
                            Case 3
                                NNelem(ielem, 9) = kvbuf(1) + nb1
                                NNelem(ielem, 10) = kvbuf(3) + nb1
                                NNelem(ielem, 11) = Npointb + NLadd(ie, 4) + nb2
                                NNelem(ielem, 12) = Npointb + NLadd(ie, 1) + nb2
                                NNelem(ielem, 13) = kbuf(1) + nb2
                                NNelem(ielem, 14) = kbuf(2) + nb2
                                NNelem(ielem, 15) = kbuf(3) + nb2
                                NNelem(ielem, 16) = Npointb + NLadd(ie, 3) + nb2
                                NNelem(ielem, 17) = kbuf(4) + nb2
                                NNelem(ielem, 18) = Npointb + NLadd(ie, 5) + nb2
                                NNelem(ielem, 19) = kbuf(8) + nb2
                                NNelem(ielem, 20) = Npointb + NLadd(ie, 2) + nb2
                            Case 4
                                NNelem(ielem, 9) = Npointb + NLadd(ie, 1) + nb2
                                NNelem(ielem, 10) = kvbuf(3) + nb1
                                NNelem(ielem, 11) = kvbuf(5) + nb1
                                NNelem(ielem, 12) = Npointb + NLadd(ie, 4) + nb2
                                NNelem(ielem, 13) = kbuf(2) + nb2
                                NNelem(ielem, 14) = Npointb + NLadd(ie, 2) + nb2
                                NNelem(ielem, 15) = kbuf(3) + nb2
                                NNelem(ielem, 16) = kbuf(4) + nb2
                                NNelem(ielem, 17) = kbuf(5) + nb2
                                NNelem(ielem, 18) = Npointb + NLadd(ie, 3) + nb2
                                NNelem(ielem, 19) = kbuf(6) + nb2
                                NNelem(ielem, 20) = Npointb + NLadd(ie, 5) + nb2
                        End Select
                    Else    '偶数ﾒｯｼｭの場合
                        iex = ielem - Nelemb
                        Select Case ii
                            Case 1
                                jj = 17
                            Case 2
                                jj = 19
                            Case 3
                                jj = 13
                            Case 4
                                jj = 15
                        End Select
                        For j = 1 To 3
                            NNelem(ielem, jj) = NNelem(iex, jj)
                            jj = jj + 1
                            If jj > 20 Then
                                jj = 13
                            End If
                        Next
                        Select Case ii
                            Case 1
                                NNelem(ielem, 4) = NNelem(iex, 10)
                                NNelem(ielem, 5) = NNelem(iex, 15)
                                NNelem(ielem, 6) = NNelem(iex, 14)
                                NNelem(ielem, 7) = NNelem(iex, 13)
                                NNelem(ielem, 8) = NNelem(iex, 9)
                                NNelem(ielem, 9) = kbuf(8) + nb2
                                NNelem(ielem, 10) = kbuf(4) + nb2
                                NNelem(ielem, 11) = NNelem(iex, 16)
                                NNelem(ielem, 12) = NNelem(iex, 20)
                                NNelem(ielem, 13) = kbuf(7) + nb2
                                NNelem(ielem, 14) = kbuf(6) + nb2
                                NNelem(ielem, 15) = kbuf(5) + nb2
                                NNelem(ielem, 16) = kvbuf(5) + nb1
                                NNelem(ielem, 20) = kvbuf(7) + nb1
                            Case 2
                                NNelem(ielem, 6) = NNelem(iex, 11)
                                NNelem(ielem, 7) = NNelem(iex, 17)
                                NNelem(ielem, 8) = NNelem(iex, 16)
                                NNelem(ielem, 1) = NNelem(iex, 15)
                                NNelem(ielem, 2) = NNelem(iex, 10)
                                NNelem(ielem, 9) = NNelem(iex, 14)
                                NNelem(ielem, 10) = kbuf(2) + nb2
                                NNelem(ielem, 11) = kbuf(6) + nb2
                                NNelem(ielem, 12) = NNelem(iex, 18)
                                NNelem(ielem, 14) = kvbuf(1) + nb1
                                NNelem(ielem, 15) = kbuf(1) + nb2
                                NNelem(ielem, 16) = kbuf(8) + nb2
                                NNelem(ielem, 17) = kbuf(7) + nb2
                                NNelem(ielem, 18) = kvbuf(7) + nb1
                            Case 3
                                NNelem(ielem, 8) = NNelem(iex, 12)
                                NNelem(ielem, 1) = NNelem(iex, 19)
                                NNelem(ielem, 2) = NNelem(iex, 18)
                                NNelem(ielem, 3) = NNelem(iex, 17)
                                NNelem(ielem, 4) = NNelem(iex, 11)
                                NNelem(ielem, 9) = NNelem(iex, 20)
                                NNelem(ielem, 10) = NNelem(iex, 16)
                                NNelem(ielem, 11) = kbuf(4) + nb2
                                NNelem(ielem, 12) = kbuf(8) + nb2
                                NNelem(ielem, 16) = kvbuf(3) + nb1
                                NNelem(ielem, 17) = kbuf(3) + nb2
                                NNelem(ielem, 18) = kbuf(2) + nb2
                                NNelem(ielem, 19) = kbuf(1) + nb2
                                NNelem(ielem, 20) = kvbuf(1) + nb1
                            Case 4
                                NNelem(ielem, 2) = NNelem(iex, 9)
                                NNelem(ielem, 3) = NNelem(iex, 13)
                                NNelem(ielem, 4) = NNelem(iex, 20)
                                NNelem(ielem, 5) = NNelem(iex, 19)
                                NNelem(ielem, 6) = NNelem(iex, 12)
                                NNelem(ielem, 9) = kbuf(2) + nb2
                                NNelem(ielem, 10) = NNelem(iex, 14)
                                NNelem(ielem, 11) = NNelem(iex, 18)
                                NNelem(ielem, 12) = kbuf(6) + nb2
                                NNelem(ielem, 13) = kbuf(3) + nb2
                                NNelem(ielem, 14) = kvbuf(3) + nb1
                                NNelem(ielem, 18) = kvbuf(5) + nb1
                                NNelem(ielem, 19) = kbuf(5) + nb2
                                NNelem(ielem, 20) = kbuf(4) + nb2
                        End Select
                    End If
                End If
            Next ie
        Next isect

    End Sub

    Private Sub LeftPlaneCalc()
        '左端面の座標計算
        Dim ip, nx As Integer
        Dim c1, s1, theta0, xb, yb As Single

        If KindBody = 0 Then    '柱状体の場合
            For ip = 1 To Npointb
                Xmodel(ip) = XL(ip) * CosLX(1) + YL(ip) * CosLY(1) + Xsect(0)
                Ymodel(ip) = XL(ip) * CosLX(2) + YL(ip) * CosLY(2) + Ysect(0)
                Zmodel(ip) = XL(ip) * CosLX(3) + YL(ip) * CosLY(3) + Zsect(0)
            Next ip
        Else    '軸回転体の場合
            If Ncenter > 0 Then '中心穴なしの場合
                Dim xbuf(Npointb), ybuf(Npointb) As Single
                For ip = 1 To Npointb
                    xbuf(ip) = XL(ip)
                    ybuf(ip) = YL(ip)
                Next ip
                nx = Npointb + Npadd
                ReDim XL(nx), YL(nx)
                ReDim Xmodel(nx), Ymodel(nx), Zmodel(nx)
                For ip = 1 To Npointb
                    XL(ip) = xbuf(ip)
                    YL(ip) = ybuf(ip)
                Next ip
                For ip = 1 To Npadd
                    XL(Npointb + ip) = XLadd(ip)
                    YL(Npointb + ip) = YLadd(ip)
                Next ip
            End If
            theta0 = Pai * AngleMesh / 180
            c1 = Math.Cos(theta0)
            s1 = Math.Sin(theta0)
            For ip = 1 To Npointb
                xb = XL(ip)
                yb = YL(ip)
                Xmodel(ip) = xb * c1
                Ymodel(ip) = xb * s1
                Zmodel(ip) = yb
            Next ip
        End If
        Call SectStore(0, Npointb)  '断面の座標データ保存

    End Sub

    Private Sub LeftPlaneData()
        '左端断面のﾃﾞｰﾀ設定
        Dim aa$
        Dim ie, ip, j, kb, kh, nb, num As Integer

        kh = 0
        Try
            Call SfileInputU(Faum$)    '断面ﾃﾞｰﾀﾌｧｲﾙの読み込み
        Catch ex As Exception
            kh = -1
        End Try
        If kh < 0 Then
            aa$ = "左端断面データファイルを読み込めません！"
            MsgBox(aa$, 0, "ファイルエラー")
            Me.Close()
        End If
        Dim nbuf(Npoint) As Integer
        Dim xbuf(Npoint), ybuf(Npoint) As Single
        ReDim Jpoint(Npoint), NumNodeV(Npoint)
        ReDim NLelem(Nelem, 8), NumMatL(Nelem), XL(Npoint), YL(Npoint)
        ReDim NRelem(Nelem, 8), XR(Npoint), YR(Npoint)
        ReDim XLdat(Npoint), YLdat(Npoint), ZLdat(Npoint)
        ReDim XRdat(Npoint), YRdat(Npoint), ZRdat(Npoint)
        ReDim Xmodel(Npoint), Ymodel(Npoint), Zmodel(Npoint)

        Ns2 = 2 * Nsect
        For ie = 1 To Nelem
            NumMatL(ie) = NumMat(ie)
            For j = 1 To 8
                NLelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie
        For ip = 1 To Npoint
            XL(ip) = X(ip) - XBL
            YL(ip) = Y(ip) - YBL
        Next ip
        Nelemb = Nelem
        Npointb = Npoint

        If KindBody > 0 Then    '軸回転体の場合
            Ncenter = 0
            For ip = 1 To Npoint
                If XL(ip) = 0 Then
                    Ncenter = Ncenter + 1
                    nbuf(ip) = Ncenter
                End If
            Next ip
            If Ncenter > 0 Then '中心軸節点ありの場合に節点番号変更
                num = Ncenter
                For ip = 1 To Npoint
                    If XL(ip) <> 0 Then
                        num = num + 1
                        nbuf(ip) = num
                    End If
                Next ip
                For ip = 1 To Npoint
                    xbuf(ip) = XL(ip)
                    ybuf(ip) = YL(ip)
                Next ip
                For ip = 1 To Npoint
                    nb = nbuf(ip)
                    XL(nb) = xbuf(ip)
                    YL(nb) = ybuf(ip)
                Next ip
                For ie = 1 To Nelem
                    For j = 1 To 8
                        kb = NLelem(ie, j)
                        nb = nbuf(kb)
                        NLelem(ie, j) = nb
                    Next j
                Next ie
            End If
        End If

    End Sub

    Private Sub MeshPlaneCalc()
        '各ﾒｯｼｭ面の座標計算2
        Dim ic, ii, imax, ip, isect, j, kcos, nb, nn As Integer
        Dim b1, b2, b3, b4, cosb, sinb, ratiob, theta As Single
        Dim xb, xbb, yb, ybb As Single
        Dim buf(3) As Single
        Dim thetaXBL(3), thetaXBR(3), thetaYBL(3), thetaYBR(3) As Single

        theta = -Pai * AngleMesh / 180
        imax = Ns2 - 1
        b1 = Ns2
        kcos = 0     '両端面の方向余弦が同一に仮設定
        For j = 1 To 3
            If CosLX(j) <> CosRX(j) Then
                kcos = 1
                Exit For
            End If
            If CosLY(j) <> CosRY(j) Then
                kcos = 1
                Exit For
            End If
        Next j
        If kcos > 0 Then
            Call StdAngle(1, thetaXBL, thetaYBL)   '断面基準軸の角度計算
            Call StdAngle(2, thetaXBR, thetaYBR)   '断面基準軸の角度計算
        End If

        ic = 1  'ﾒｯｼｭ面区分（0:主ﾒｯｼｭ面、1:中間ﾒｯｼｭ面）
        nn = Npointb
        If KindConnect = 0 Then     '両端面の直線接続の場合
            For isect = 1 To imax
                b2 = isect / b1
                b3 = 1 - b2
                Xsect(isect) = b3 * Xsect(0) + b2 * Xsect(Ns2)
                Ysect(isect) = b3 * Ysect(0) + b2 * Ysect(Ns2)
                Zsect(isect) = b3 * Zsect(0) + b2 * Zsect(Ns2)
            Next isect
        End If
        ratiob = 1
        cosb = 1
        sinb = 0
        For isect = 1 To Ns2
            b2 = isect / b1
            b3 = 1 - b2
            If kcos = 0 Then
                For j = 1 To 3
                    CosXb(j) = CosLX(j)
                    CosYb(j) = CosLY(j)
                Next j
            Else
                For j = 1 To 3
                    b4 = b3 * thetaXBL(j) + b2 * thetaXBR(j)
                    CosXb(j) = Math.Cos(b4)
                    b4 = b3 * thetaYBL(j) + b2 * thetaYBR(j)
                    CosYb(j) = Math.Cos(b4)
                Next j
            End If

            If RatioSim <> 1 Then
                ratiob = b3 + b2 * RatioSim
            End If
            If AngleMesh <> 0 Then
                b4 = b2 * theta
                cosb = Math.Cos(b4)
                sinb = Math.Sin(b4)
            End If
            If ic = 0 Then  '主ﾒｯｼｭ面の場合
                nb = Npointb
                If KindSect < 2 Then
                    For ip = 1 To Npointb
                        xb = XL(ip) * cosb - YL(ip) * sinb
                        yb = XL(ip) * sinb + YL(ip) * cosb
                        For j = 1 To 3
                            buf(j) = xb * CosXb(j) + yb * CosYb(j)
                            buf(j) = ratiob * buf(j)
                        Next j
                        Xmodel(ip) = buf(1) + Xsect(isect)
                        Ymodel(ip) = buf(2) + Ysect(isect)
                        Zmodel(ip) = buf(3) + Zsect(isect)
                    Next ip
                Else
                    For ip = 1 To Npointb
                        xb = b3 * XL(ip) + b2 * XR(ip)
                        yb = b3 * YL(ip) + b2 * YR(ip)
                        xbb = xb * cosb - yb * sinb
                        ybb = xb * sinb + yb * cosb
                        For j = 1 To 3
                            buf(j) = xbb * CosXb(j) + ybb * CosYb(j)
                        Next j
                        Xmodel(ip) = buf(1) + Xsect(isect)
                        Ymodel(ip) = buf(2) + Ysect(isect)
                        Zmodel(ip) = buf(3) + Zsect(isect)
                    Next ip
                End If
            Else    '中間ﾒｯｼｭ面の場合
                nb = Npv
                ii = 0
                If KindSect < 2 Then
                    For ip = 1 To Npointb
                        If Jpoint(ip) = 0 Then
                            ii = ii + 1
                            xb = XL(ip) * cosb - YL(ip) * sinb
                            yb = XL(ip) * sinb + YL(ip) * cosb
                            For j = 1 To 3
                                buf(j) = xb * CosXb(j) + yb * CosYb(j)
                                buf(j) = ratiob * buf(j)
                            Next j
                            Xmodel(ii) = buf(1) + Xsect(isect)
                            Ymodel(ii) = buf(2) + Ysect(isect)
                            Zmodel(ii) = buf(3) + Zsect(isect)
                        End If
                    Next ip
                Else
                    For ip = 1 To Npointb
                        If Jpoint(ip) = 0 Then
                            ii = ii + 1
                            xb = b3 * XL(ip) + b2 * XR(ip)
                            yb = b3 * YL(ip) + b2 * YR(ip)
                            xbb = xb * cosb - yb * sinb
                            ybb = xb * sinb + yb * cosb
                            For j = 1 To 3
                                buf(j) = xbb * CosXb(j) + ybb * CosYb(j)
                            Next j
                            Xmodel(ii) = buf(1) + Xsect(isect)
                            Ymodel(ii) = buf(2) + Ysect(isect)
                            Zmodel(ii) = buf(3) + Zsect(isect)
                        End If
                    Next ip
                End If
            End If
            Call SectStore(nn, nb)  '断面の座標データ保存
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
            nn = nn + nb
        Next isect

    End Sub

    Private Sub MeshPlaneCalR()
        '各放射ﾒｯｼｭ面の座標計算
        Dim ic, ii, imax, isect, ip, nb, nn, nx As Integer
        Dim b1, b2, c1, s1, theta, theta0, xb, yb As Single
        Dim buf(3) As Single

        theta0 = Pai * AngleMesh / 180
        theta = Pai * (AngleMesh2 - AngleMesh) / 180
        nx = Npointb + Npadd
        If KindRad = 0 Then
            imax = Ns2 - 1
        Else
            imax = Ns2
        End If
        b1 = Ns2
        ic = 1  'ﾒｯｼｭ面区分（0:主ﾒｯｼｭ面、1:中間ﾒｯｼｭ面）
        nn = Npointb
        For isect = 1 To imax
            b2 = (isect / b1) * theta + theta0
            c1 = Math.Cos(b2)
            s1 = Math.Sin(b2)
            If ic = 0 Then
                ii = isect Mod 4
                If ii > 0 Then
                    nb = nx
                Else
                    nb = Npointb
                End If
                For ip = 1 To nb
                    xb = XL(ip)
                    yb = YL(ip)
                    Xmodel(ip) = xb * c1
                    Ymodel(ip) = xb * s1
                    Zmodel(ip) = yb
                Next ip
            Else
                nb = Npv
                ii = 0
                For ip = 1 To Npointb
                    If Jpoint(ip) = 0 Then
                        ii = ii + 1
                        xb = XL(ip)
                        yb = YL(ip)
                        Xmodel(ii) = xb * c1
                        Ymodel(ii) = xb * s1
                        Zmodel(ii) = yb
                    End If
                Next ip
            End If
            Call SectStore(nn, nb)  '断面の座標データ保存
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
            nn = nn + nb
        Next isect

    End Sub

    Private Sub NodeCount(ByRef kh As Integer)
        '面内の頂点節点の個数算出
        'kh･･･ｴﾗｰ有無（0：なし、-1：有り）
        Dim aa$
        Dim i, i1, i2, i3, ib, ic, ie, ii, ip, j, jj, k, kk, nb As Integer
        Dim kbuf(Npointb) As Integer

        kh = 0
        Npv = 0
        For ie = 1 To Nelemb
            For j = 1 To 7 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    Npv = Npv + 1
                    kbuf(ib) = 1
                    Jpoint(ib) = 0
                End If
            Next j
            For j = 2 To 8 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    kbuf(ib) = 1
                    Jpoint(ib) = 1
                End If
            Next j
        Next ie
        nb = 0
        For ip = 1 To Npointb
            If Jpoint(ip) = 0 Then
                nb = nb + 1
                NumNodeV(ip) = nb
            End If
        Next ip

        If KindBody = 1 And Ncenter > 0 Then  '中心穴なしの軸回転体の場合
            ReDim NLadd(Nelemb, 7)
            nb = 0
            For ie = 1 To Nelemb
                ic = 0
                For ii = 1 To 4
                    i1 = 2 * ii - 1
                    If NLelem(ie, i1) <= Ncenter Then
                        ic = 1
                        i3 = i1 + 2
                        If i3 > 8 Then
                            i3 = 1
                        End If
                        If NLelem(ie, i3) <= Ncenter Then
                            ic = 2
                            NLadd(ie, 0) = ii
                            nb = nb + 1
                            Exit For
                        End If
                    End If
                Next ii
                If ic = 1 Then
                    kh = -1
                    aa$ = "断面要素番号" + Str$(ie) + "は中心軸に辺がありません！"
                    MsgBox(aa$, 0, "データエラー")
                    Exit Sub
                End If
            Next ie
            For ie = 1 To Nelemb
                If NLadd(ie, 0) > 0 Then
                    ii = NLadd(ie, 0)
                    For k = 1 To 2
                        If k = 1 Then
                            j = 2 * ii + 2
                        Else
                            j = 2 * ii + 6
                        End If
                        If NLadd(ie, k + 5) = 0 Then
                            nb = nb + 2
                            If j > 8 Then
                                j = j - 8
                            End If
                            kk = NLelem(ie, j)
                            For i = ie + 1 To Nelemb
                                If NLadd(i, 0) > 0 Then
                                    ib = NLadd(i, 0)
                                    For jj = 1 To 2
                                        If jj = 1 Then
                                            i2 = 2 * ib + 2
                                        Else
                                            i2 = 2 * ib + 6
                                        End If
                                        If NLadd(i, jj + 5) = 0 Then
                                            If i2 > 8 Then
                                                i2 = i2 - 8
                                            End If
                                            i3 = NLelem(i, i2)
                                            If i3 = kk Then
                                                NLadd(ie, k + 5) = i
                                                NLadd(i, jj + 5) = ie
                                                Exit For
                                            End If
                                        End If
                                    Next jj
                                End If
                            Next i
                        End If
                    Next
                End If
            Next ie
            Npadd = nb
            ReDim XLadd(Npadd), YLadd(Npadd)
            Npadd = 0
            For ie = 1 To Nelemb
                If NLadd(ie, 0) > 0 Then
                    ii = NLadd(ie, 0)
                    For k = 1 To 2
                        i = NLadd(ie, k + 5)
                        If i >= 0 Then
                            If k = 1 Then
                                j = 2 * ii + 1
                            Else
                                j = 2 * ii + 5
                            End If
                            If j > 8 Then
                                j = j - 8
                            End If
                            i1 = NLelem(ie, j)
                            i2 = NLelem(ie, j + 1)
                            j = j + 2
                            If j > 8 Then
                                j = 1
                            End If
                            i3 = NLelem(ie, j)
                            Call AddPoint(i1, i2, i3) '追加節点の座標計算
                            NLadd(ie, 2 * k - 1) = Npadd - 1
                            NLadd(ie, 2 * k) = Npadd
                            NLadd(ie, k + 5) = -i
                            If i > 0 Then
                                ib = NLadd(i, 0)
                                For jj = 1 To 2
                                    If jj = 1 Then
                                        i1 = 2 * ib + 1
                                    Else
                                        i1 = 2 * ib + 5
                                    End If
                                    If i1 > 8 Then
                                        i1 = i1 - 8
                                    End If
                                    i2 = NLelem(i, i1)
                                    If i2 = i3 Then
                                        NLadd(i, 2 * jj - 1) = Npadd
                                        NLadd(i, 2 * jj) = Npadd - 1
                                        NLadd(i, jj + 5) = -ie
                                        Exit For
                                    End If
                                Next jj
                            End If
                        End If
                    Next k
                    j = 2 * ii + 2
                    If j > 8 Then
                        j = j - 8
                    End If
                    i1 = NLelem(ie, j)
                    j = j + 4
                    If j > 8 Then
                        j = j - 8
                    End If
                    i2 = NLelem(ie, j)
                    Npadd = Npadd + 1
                    NLadd(ie, 5) = Npadd
                    XLadd(Npadd) = 0.5 * (XL(i1) + XL(i2))
                    YLadd(Npadd) = 0.5 * (YL(i1) + YL(i2))
                End If
            Next ie
        End If

    End Sub

    Private Sub RightPlaneData()
        '右端断面のﾃﾞｰﾀ作成
        Dim aa$
        Dim ic, icc, ie, ip, j, j1, j2, k1, k2, kh, nb, nx As Integer

        kh = 0
        Try
            Call SfileInputU(Fadd$)    '断面ﾃﾞｰﾀﾌｧｲﾙの読み込み
        Catch ex As Exception
            kh = -1
        End Try
        If kh < 0 Then
            aa$ = "右端断面データファイルを読み込めません！"
            MsgBox(aa$, 0, "ファイルエラー")
            Me.Close()
        End If
        If Nelemb <> Nelem Or Npointb <> Npoint Then
            aa$ = "左端面と右端面のデータが合いません！"
            MsgBox(aa$, 0, "データエラー")
            End
        End If
        If KeLeft < 1 Or KeLeft > Nelem Then
            aa$ = "左端面の基準要素番号が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            End
        End If
        If KeRight < 1 Or KeRight > Nelem Then
            aa$ = "右端面の基準要素番号が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            End
        End If
        If KpLeft < 1 Or KpLeft > Npoint Then
            aa$ = "左端面の基準節点番号が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            End
        End If
        If KpRight < 1 Or KpRight > Npoint Then
            aa$ = "右端面の基準節点番号が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            End
        End If

        Dim n1ebuf(Nelem), nebuf(Nelem), npbuf(Npoint) As Integer
        For j = 1 To 8
            nb = NLelem(KeLeft, j)
            If nb = KpLeft Then
                j1 = j
                Exit For
            End If
        Next j
        If j1 = 0 Then
            aa$ = "左端面の基準要素内に基準節点がありません！"
            MsgBox(aa$, 0, "データエラー")
            End
        End If
        For j = 1 To 8
            nb = NNelem(KeRight, j)
            If nb = KpRight Then
                j2 = j
                Exit For
            End If
        Next j
        If j2 = 0 Then
            aa$ = "右端面の基準要素内に基準節点がありません！"
            MsgBox(aa$, 0, "データエラー")
            End
        End If

        j1 = j1 - 0
        j2 = j2 - 0
        For j = 1 To 8
            j1 = j1 + 1
            If j1 > 8 Then
                j1 = j1 - 8
            End If
            j2 = j2 + 1
            If j2 > 8 Then
                j2 = j2 - 8
            End If
            nb = NNelem(KeRight, j2)
            npbuf(nb) = NLelem(KeLeft, j1)
        Next j
        n1ebuf(KeLeft) = KeRight
        nebuf(KeRight) = KeLeft
        Do
            ic = 0
            For ie = 1 To Nelem
                If nebuf(ie) = 0 Then
                    icc = 0
                    For j = 2 To 8 Step 2
                        nb = NNelem(ie, j)
                        If npbuf(nb) > 0 Then
                            k2 = ie
                            j2 = j
                            icc = 1
                            Exit For
                        End If
                    Next j
                    If icc > 0 Then
                        ic = 1
                        Exit For
                    End If
                End If
            Next ie
            If ic = 0 Then
                Exit Do
            Else
                For ie = 1 To Nelem
                    If n1ebuf(ie) = 0 Then
                        icc = 0
                        For j = 2 To 8
                            nx = NLelem(ie, j)
                            If nx = npbuf(nb) Then
                                k1 = ie
                                j1 = j
                                icc = 1
                            End If
                        Next j
                        If icc > 0 Then
                            Exit For
                        End If
                    End If
                Next ie
                If icc = 0 Then
                    aa$ = "左端面と右端面のメッシュ構成が一致しません！"
                    MsgBox(aa$, 0, "データエラー")
                    End
                End If
                j1 = j1 - 0
                j2 = j2 - 0
                For j = 1 To 8
                    j1 = j1 + 1
                    If j1 > 8 Then
                        j1 = j1 - 8
                    End If
                    j2 = j2 + 1
                    If j2 > 8 Then
                        j2 = j2 - 8
                    End If
                    nb = NNelem(k2, j2)
                    npbuf(nb) = NLelem(k1, j1)
                Next j
                n1ebuf(k1) = k2
                nebuf(k2) = k1
            End If
        Loop

        For ie = 1 To Nelem
            For j = 1 To 8
                NRelem(ie, j) = NLelem(ie, j)
            Next j
        Next ie
        For ip = 1 To Npoint
            XR(npbuf(ip)) = X(ip) - XBR
            YR(npbuf(ip)) = Y(ip) - YBR
        Next ip

    End Sub

    Private Sub ReNumberR()
        '軸回転体の節点番号の再付番
        Dim ib, ibase, ic, ie, ip, isect, j, nb, npb, num As Integer
        Dim kbuf(Npoint), nbuf(Npoint) As Integer
        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single

        For ip = 1 To Npoint
            xbuf(ip) = Xdata(ip)
            ybuf(ip) = Ydata(ip)
            zbuf(ip) = Zdata(ip)
        Next ip

        num = 0
        For ie = 1 To Nelemb
            ibase = 0
            For isect = 1 To Nsect
                ic = 0
                ib = ibase + ie
                For j = 1 To 20
                    nb = NNelem(ib, j)
                    If kbuf(nb) = 0 Then
                        kbuf(nb) = 1
                        num = num + 1
                        nbuf(nb) = num
                    End If
                Next j
                ibase = ibase + Nelemb
            Next isect
        Next ie

        npb = Npoint
        Npoint = num
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)
        For ie = 1 To Nelem
            For j = 1 To 20
                nb = NNelem(ie, j)
                NNelem(ie, j) = nbuf(nb)
            Next j
        Next ie
        For ip = 1 To npb
            If nbuf(ip) > 0 Then
                nb = nbuf(ip)
                Xdata(nb) = xbuf(ip)
                Ydata(nb) = ybuf(ip)
                Zdata(nb) = zbuf(ip)
            End If
        Next ip

    End Sub

    Private Sub RightPlaneCalc()
        '右端面の座標計算
        Dim ip As Integer
        For ip = 1 To Npointb
            Xmodel(ip) = XR(ip) * CosRX(1) + YR(ip) * CosRY(1) + Xsect(Ns2)
            Ymodel(ip) = XR(ip) * CosRX(2) + YR(ip) * CosRY(2) + Ysect(Ns2)
            Zmodel(ip) = XR(ip) * CosRX(3) + YR(ip) * CosRY(3) + Zsect(Ns2)
        Next ip
        NRb = (Npointb + Npv) * Nsect   '右端面のﾍﾞｰｽ節点数
        Call SectStore(NRb, Npointb)  '断面の座標データ保存

    End Sub

    Private Sub SectStore(ByVal ib As Integer, ByVal nb As Integer)
        '断面の座標データ保存
        'ib･･･ﾍﾞｰｽ節点数
        'nb･･･節点数
        Dim ii, ip As Integer
        For ip = 1 To nb
            ii = ib + ip
            Xdata(ii) = Xmodel(ip)
            Ydata(ii) = Ymodel(ip)
            Zdata(ii) = Zmodel(ip)
        Next ip

    End Sub

    Private Sub StdAngle(ByVal kind As Integer, ByRef thetaX() As Single, ByRef thetaY() As Single)
        '断面基準軸の角度計算
        'kind･･･種別（1:左端面、2:右端面）
        'teataX(),thetaY･･･断面のXB軸、YB軸の全体XYZ軸との角度
        Dim j As Integer

        If kind = 1 Then
            For j = 1 To 3
                thetaX(j) = Math.Acos(CosLX(j))
                thetaY(j) = Math.Acos(CosLY(j))
            Next j
        Else
            For j = 1 To 3
                thetaX(j) = Math.Acos(CosRX(j))
                thetaY(j) = Math.Acos(CosRY(j))
            Next j
        End If

    End Sub

    Private Sub MeshAuz5M_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, fb$, titleb$
        Dim ix, kh As Integer

        fb$ = ""
        titleb$ = Title$
        Me.Show()

        Label2.Text = "計算中！ しばらくお待ちください。"

        Call LeftPlaneData() '左端断面のﾃﾞｰﾀ設定

        If KindBody = 0 Then    '柱状体の場合
            If KindSect <> 1 Then
                RatioSim = 1
            End If
            If KindSect = 2 Then
                Call RightPlaneData() '右端断面のﾃﾞｰﾀ作成
            End If
        End If

        Nelem = Nelemb * Nsect
        Call NodeCount(kh) '面内の頂点節点の個数算出
        If kh < 0 Then
            Me.Close()
        End If
        Npoint = Npointb * (Nsect + 1) + Npv * Nsect
        If KindBody > 0 And Ncenter > 0 Then    '軸回転体の中心穴なしの場合
            Npbase = Npoint
            Npoint = Npoint + Npadd * (Nsect / 2)
        End If
        ReDim NNelem(Nelem, 20), NumMat(Nelem)
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)

        Call LeftPlaneCalc() '左端面の座標計算

        If KindBody = 0 Then    '柱状体の場合
            Call MeshPlaneCalc() '各ﾒｯｼｭ面の座標計算
            Call ElemGene()     '六面体要素の作成
        Else    '軸回転体の場合
            If AngleMesh2 = AngleMesh + 360 Then
                KindRad = 0
            Else
                KindRad = 1
            End If
            Call MeshPlaneCalR() '各放射ﾒｯｼｭ面の座標計算
            Call ElemGeneR()    '軸回転体の六面体要素の作成
            If KindRad = 0 Or Ncenter > 0 Then
                Call ReNumberR()    '軸回転体の節点番号の再付番
            End If
        End If

        Title$ = titleb$
        Call DfilePrepA()   '構造ﾃﾞｰﾀﾌｧｲﾙ保存の前処理

        Call DataCheckS(kh)    '入力ﾃﾞｰﾀのｴﾗｰﾁｪｯｸ
        If kh < 0 Then
            aa$ = "生成したメッシュデータにエラーがありました！"
            MsgBox(aa$, 0, "メッシュ生成エラー")
        Else
            KdataChange5 = 2
            Label2.Text = "計算終了！"
            aa$ = "構造データファイルへ出力しますか？"
            Me.BringToFront()
            ix = MsgBox(aa$, 4, "計算終了確認")
            If ix = 6 Then
                If Fauz$ <> "" Then
                    Call FileName(Fauz$, fb$)
                    'ﾌｧｲﾙ名Fauz$から拡張子なしの部分fb$を取得
                    Fm$ = fb$ + ".au3"
                End If
                InOut = 1
                Dim frm As Form = New SolDDat6() '構造ﾃﾞｰﾀﾌｧｲﾙ出力
                frm.Show()
            End If
        End If

        Me.Close()

    End Sub
End Class
