'３次元の平面ﾒｯｼｭ利用の柱状体作成ﾌﾟﾛｸﾞﾗﾑ
Imports System.ComponentModel

Public Class MeshAuzN
    Dim Fx$         'ﾌｧｲﾙ名

    Dim KindPlate As Integer    '平行端面の区分（0:採用、1:不採用）
    Dim Nelemb As Integer       '断面の要素数
    Dim Npointb As Integer      '断面の節点数
    Dim Npv As Integer          '断面の頂点節点数
    Dim Ns2 As Integer          '両端面間の総ﾒｯｼｭ数（含中間節点ﾒｯｼｭ）

    Dim Hdist As Single         '垂直距離（負は手前）

    Dim Jpoint() As Integer     '節点ﾌﾗｯｸﾞ（0:頂点ﾌﾗｯｸﾞ、1:中間節点）
    Dim NLadd(,) As Integer     '端面要素の追加節点番号
    Dim NLelem(,) As Integer    '左端断面の要素ﾃﾞｰﾀ
    Dim NRelem(,) As Integer    '右端断面の要素ﾃﾞｰﾀ
    Dim NumMatL() As Integer    '左端断面要素の材料番号（右端面は自動的に同一）
    Dim NumNodeV() As Integer   '面内の頂点節点順位

    Dim XLdat(), YLdat(), ZLdat() As Single '左端面節点の全体座標
    Dim XMdat(), YMdat(), ZMdat() As Single  '中間断面における全体座標
    Dim XRdat(), YRdat(), ZRdat() As Single '右端面節点の全体座標

    Private Sub CondDisp()  '条件表示
        If KindPlate = 0 Then
            RadioButton1.Checked = True
            Button1.Text = "左端の断面ファイル名"
            Button2.Visible = True
            Label4.Visible = True
            TextBox4.Visible = True
            Label6.Visible = False
            TextBox5.Visible = False
        Else
            RadioButton2.Checked = True
            Button1.Text = "断面ファイル名"
            Label6.Visible = True
            TextBox5.Visible = True
            Button2.Visible = False
            TextBox4.Visible = False
            Label4.Visible = False
        End If

    End Sub

    Private Sub ElemGene()
        '六面体要素の作成
        Dim ie, ielem, isect, j, jj, nb0, nb1, nb2, nset As Integer
        Dim kbuf(8), kvbuf(8) As Integer
        ielem = 0
        nset = Npointb + Npv
        For isect = 1 To Nsect
            nb0 = nset * (isect - 1)
            nb1 = nb0 + Npointb
            nb2 = nb1 + Npv
            For ie = 1 To Nelemb
                For j = 1 To 8
                    kbuf(j) = NLelem(ie, j)
                    kvbuf(j) = NumNodeV(kbuf(j))
                Next j
                ielem = ielem + 1
                NumMat(ielem) = NumMatL(ie)
                For j = 1 To 8
                    NNelem(ielem, j) = kbuf(j) + nb0
                    NNelem(ielem, j + 12) = kbuf(j) + nb2
                Next j
                For j = 1 To 4
                    jj = 2 * j - 1
                    NNelem(ielem, j + 8) = kvbuf(jj) + nb1
                Next j
            Next ie
        Next isect

    End Sub

    Private Sub LeftPlaneData(ByVal fxx$)
        '左端断面のﾃﾞｰﾀ設定
        'fxx$･･･断面ﾌｧｲﾙ名
        Dim aa$
        Dim ie, ip, j, kh As Integer

        kh = 0
        Try
            Call SnFileInputU(fxx$)    '断面ﾃﾞｰﾀﾌｧｲﾙの読み込み
        Catch ex As Exception
            kh = -1
        End Try
        If kh < 0 Then
            aa$ = fxx$ + "ファイルを読み込めません！"
            MsgBox(aa$, 0, "ファイルエラー")
            Me.Close()
        End If
        ReDim Jpoint(Npoint), NumNodeV(Npoint)
        ReDim NLelem(Nelem, 8), NumMatL(Nelem)
        ReDim NRelem(Nelem, 8)
        ReDim XLdat(Npoint), YLdat(Npoint), ZLdat(Npoint)
        ReDim XRdat(Npoint), YRdat(Npoint), ZRdat(Npoint)
        ReDim Xmodel(Npoint), Ymodel(Npoint), Zmodel(Npoint)

        Ns2 = 2 * Nsect
        For ie = 1 To Nelem
            NumMatL(ie) = NumMat(ie)
            For j = 1 To 8
                NLelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie
        Nelemb = Nelem
        Npointb = Npoint

        For ip = 1 To Npoint
            XLdat(ip) = X(ip)
            YLdat(ip) = Y(ip)
            ZLdat(ip) = Z(ip)
        Next ip

        For ip = 1 To Npointb
            Xmodel(ip) = X(ip)
            Ymodel(ip) = Y(ip)
            Zmodel(ip) = Z(ip)
        Next ip

    End Sub

    Private Sub LeftPlaneGene()    '左端断面の生成
        Dim ie, ip, j, kb As Integer
        Dim b1, b2, b3, b4, xb, yb, zb As Single
        Dim planevec(3) As Single
        Dim xbufb(3), ybufb(3), zbuf(3) As Single

        Ns2 = 2 * Nsect
        For ie = 1 To Nelem
            NumMatL(ie) = NumMat(ie)
            For j = 1 To 8
                NLelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie

        xb = 0 : yb = 0 : zb = 0
        For j = 2 To 8 Step 2
            kb = NNelem(1, j)
            xb = xb + X(kb)
            yb = yb + Y(kb)
            zb = zb + Z(kb)
            Select Case j
                Case 2
                    xbufb(2) = X(kb)
                    ybufb(2) = Y(kb)
                    zbuf(2) = Z(kb)
                Case 4
                    xbufb(3) = X(kb)
                    ybufb(3) = Y(kb)
                    zbuf(3) = Z(kb)
            End Select
        Next j
        xbufb(1) = xb / 4
        ybufb(1) = yb / 4
        zbuf(1) = zb / 4
        '面の法線ﾍﾞｸﾄﾙの計算
        b1 = (ybufb(2) - ybufb(1)) * (zbuf(3) - zbuf(1))
        b1 = b1 - (zbuf(2) - zbuf(1)) * (ybufb(3) - ybufb(1))
        b2 = (zbuf(2) - zbuf(1)) * (xbufb(3) - xbufb(1))
        b2 = b2 - (xbufb(2) - xbufb(1)) * (zbuf(3) - zbuf(1))
        b3 = (xbufb(2) - xbufb(1)) * (ybufb(3) - ybufb(1))
        b3 = b3 - (ybufb(2) - ybufb(1)) * (xbufb(3) - xbufb(1))
        b4 = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
        planevec(1) = b1 / b4
        planevec(2) = b2 / b4
        planevec(3) = b3 / b4

        b1 = Hdist * planevec(1)
        b2 = Hdist * planevec(2)
        b3 = Hdist * planevec(3)

        For ip = 1 To Npoint
            XLdat(ip) = X(ip) - b1
            YLdat(ip) = Y(ip) - b2
            ZLdat(ip) = Z(ip) - b3
        Next ip

        For ip = 1 To Npointb
            Xmodel(ip) = X(ip)
            Ymodel(ip) = Y(ip)
            Zmodel(ip) = Z(ip)
        Next ip

    End Sub

    Private Sub MeshGene()
        'メッシュ生成
        Dim fb$, titleb$
        Dim kh As Integer

        fb$ = ""
        titleb$ = Title$

        Label2.Text = "計算中！ しばらくお待ちください。"

        If KindPlate = 0 Then
            Call LeftPlaneData(Faun$)   '左端断面のﾃﾞｰﾀ設定
            Call RightPlaneData(Fadd$, 1)   '右端断面のﾃﾞｰﾀ作成
        Else
            If Hdist < 0 Then
                Call RightPlaneData(Faun$, 0) '右端断面のﾃﾞｰﾀ作成
                Call LeftPlaneGene()  '左端断面の生成
            Else
                Call LeftPlaneData(Faun$)   '左端断面のﾃﾞｰﾀ設定
                Call RightPlaneGene() '右端断面の生成
            End If
        End If

        Nelem = Nelemb * Nsect
        Call NodeCount(kh) '面内の頂点節点の個数算出
        If kh < 0 Then
            Me.Close()
        End If
        Npoint = Npointb * (Nsect + 1) + Npv * Nsect
        ReDim NNelem(Nelem, 20), NumMat(Nelem)
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)

        KindElem = 0
        Call MeshPlaneCalc() '各ﾒｯｼｭ面の座標計算
        Call ElemGene()     '六面体要素の作成


    End Sub

    Private Sub MeshPlaneCalc()
        '各ﾒｯｼｭ面の座標計算2
        Dim ic, ii, imax, ip, isect, nb, nn As Integer
        Dim b1, b2, b3 As Single

        imax = Ns2 - 1
        b1 = Ns2

        For ip = 1 To Npointb
            Xdata(ip) = XLdat(ip)
            Ydata(ip) = YLdat(ip)
            Zdata(ip) = ZLdat(ip)
        Next ip

        ic = 1  'ﾒｯｼｭ面区分（0:主ﾒｯｼｭ面、1:中間ﾒｯｼｭ面）
        nn = Npointb

        For isect = 1 To Ns2
            b2 = isect / b1
            b3 = 1 - b2

            If ic = 0 Then  '主ﾒｯｼｭ面の場合
                nb = Npointb
                For ip = 1 To Npointb
                    Xmodel(ip) = b3 * XLdat(ip) + b2 * XRdat(ip)
                    Ymodel(ip) = b3 * YLdat(ip) + b2 * YRdat(ip)
                    Zmodel(ip) = b3 * ZLdat(ip) + b2 * ZRdat(ip)
                Next ip
            Else    '中間ﾒｯｼｭ面の場合
                nb = Npv
                ii = 0
                For ip = 1 To Npointb
                    If Jpoint(ip) = 0 Then
                        ii = ii + 1
                        Xmodel(ii) = b3 * XLdat(ip) + b2 * XRdat(ip)
                        Ymodel(ii) = b3 * YLdat(ip) + b2 * YRdat(ip)
                        Zmodel(ii) = b3 * ZLdat(ip) + b2 * ZRdat(ip)
                    End If
                Next ip
            End If
            Call SectStore(nn, nb)  '断面の座標データ保存
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
            nn = nn + nb
        Next isect

    End Sub

    Private Sub NodeCount(ByRef kh As Integer)
        '面内の頂点節点の個数算出
        'kh･･･ｴﾗｰ有無（0：なし、-1：有り）
        Dim ib, ie, ip, j, nb As Integer
        Dim kbuf(Npointb) As Integer

        kh = 0
        Npv = 0
        For ie = 1 To Nelemb
            For j = 1 To 7 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    Npv = Npv + 1
                    kbuf(ib) = 1
                    Jpoint(ib) = 0
                End If
            Next j
            For j = 2 To 8 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    kbuf(ib) = 1
                    Jpoint(ib) = 1
                End If
            Next j
        Next ie
        nb = 0
        For ip = 1 To Npointb
            If Jpoint(ip) = 0 Then
                nb = nb + 1
                NumNodeV(ip) = nb
            End If
        Next ip

    End Sub

    Private Sub RightPlaneData(ByVal fxx$, ByVal kind As Integer)
        '右端断面のﾃﾞｰﾀ作成
        'fxx$･･･断面ﾌｧｲﾙ名
        'kind･･･区分（0:初回、1:再度）
        Dim aa$
        Dim ie, ip, j, kh As Integer

        kh = 0
        Try
            Call SnFileInputU(fxx$)    '断面ﾃﾞｰﾀﾌｧｲﾙの読み込み
        Catch ex As Exception
            kh = -1
        End Try
        If kh < 0 Then
            aa$ = fxx$ + "ファイルを読み込めません！"
            MsgBox(aa$, 0, "ファイルエラー")
            Me.Close()
        End If
        If kind > 0 Then
            If Nelemb <> Nelem Or Npointb <> Npoint Then
                aa$ = "左端面と右端面のデータが合いません！"
                MsgBox(aa$, 0, "データエラー")
                End
            End If
        End If
        If kind = 0 Then
            ReDim Jpoint(Npoint), NumNodeV(Npoint)
            ReDim NLelem(Nelem, 8), NumMatL(Nelem)
            ReDim NRelem(Nelem, 8)
            ReDim XLdat(Npoint), YLdat(Npoint), ZLdat(Npoint)
            ReDim XRdat(Npoint), YRdat(Npoint), ZRdat(Npoint)
            ReDim Xmodel(Npoint), Ymodel(Npoint), Zmodel(Npoint)
            Nelemb = Nelem
            Npointb = Npoint
        End If

        For ie = 1 To Nelem
            For j = 1 To 8
                NRelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie
        For ip = 1 To Npoint
            XRdat(ip) = X(ip)
            YRdat(ip) = Y(ip)
            ZRdat(ip) = Z(ip)
        Next ip

    End Sub

    Private Sub RightPlaneGene()
        '右端断面の生成
        Dim ie, ip, j, kb As Integer
        Dim b1, b2, b3, b4, xb, yb, zb As Single
        Dim planevec(3) As Single
        Dim xbufb(3), ybufb(3), zbuf(3) As Single

        Ns2 = 2 * Nsect
        For ie = 1 To Nelem
            For j = 1 To 8
                NRelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie

        xb = 0 : yb = 0 : zb = 0
        For j = 2 To 8 Step 2
            kb = NNelem(1, j)
            xb = xb + X(kb)
            yb = yb + Y(kb)
            zb = zb + Z(kb)
            Select Case j
                Case 2
                    xbufb(2) = X(kb)
                    ybufb(2) = Y(kb)
                    zbuf(2) = Z(kb)
                Case 4
                    xbufb(3) = X(kb)
                    ybufb(3) = Y(kb)
                    zbuf(3) = Z(kb)
            End Select
        Next j
        xbufb(1) = xb / 4
        ybufb(1) = yb / 4
        zbuf(1) = zb / 4
        '面の法線ﾍﾞｸﾄﾙの計算
        b1 = (ybufb(2) - ybufb(1)) * (zbuf(3) - zbuf(1))
        b1 = b1 - (zbuf(2) - zbuf(1)) * (ybufb(3) - ybufb(1))
        b2 = (zbuf(2) - zbuf(1)) * (xbufb(3) - xbufb(1))
        b2 = b2 - (xbufb(2) - xbufb(1)) * (zbuf(3) - zbuf(1))
        b3 = (xbufb(2) - xbufb(1)) * (ybufb(3) - ybufb(1))
        b3 = b3 - (ybufb(2) - ybufb(1)) * (xbufb(3) - xbufb(1))
        b4 = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
        planevec(1) = b1 / b4
        planevec(2) = b2 / b4
        planevec(3) = b3 / b4

        b1 = Hdist * planevec(1)
        b2 = Hdist * planevec(2)
        b3 = Hdist * planevec(3)

        For ip = 1 To Npoint
            XRdat(ip) = X(ip) - b1
            YRdat(ip) = Y(ip) - b2
            ZRdat(ip) = Z(ip) - b3
        Next ip

    End Sub

    Private Sub SectStore(ByVal ib As Integer, ByVal nb As Integer)
        '断面の座標データ保存
        'ib･･･ﾍﾞｰｽ節点数
        'nb･･･節点数
        Dim ii, ip As Integer
        For ip = 1 To nb
            ii = ib + ip
            Xdata(ii) = Xmodel(ip)
            Ydata(ii) = Ymodel(ip)
            Zdata(ii) = Zmodel(ip)
        Next ip

    End Sub

    Private Sub MeshAuzN_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        If Faun$ = "" Then
            Call TmpFileIn() 'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        End If

        Fx$ = DirOpen$ + "\MeshAuzN.tmp"
        Try
            Dim sr As New IO.StreamReader(Fx$)
            KindPlate = sr.ReadLine
            Nsect = sr.ReadLine
            Hdist = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

        Nsect = 3
        TextBox1.Text = Title$
        TextBox2.Text = LTrim$(Str$(Nsect))
        TextBox3.Text = Faun$
        TextBox4.Text = Fadd$
        TextBox5.Text = Str(Hdist)

        Call CondDisp()  '条件表示

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        If Faun$ = "" Then
            Call TmpFileIn() 'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        End If

        KfileOK = 0
        OpenFileDialog1.Filter = "すべてのファイル(*.*)|*.*|データファイル(*.aun)|*.aun"
        OpenFileDialog1.FilterIndex = 2
        OpenFileDialog1.FileName = Faun$
        OpenFileDialog1.ShowDialog()
        If KfileOK > 0 Then
            Faun$ = OpenFileDialog1.FileName
            Try
                Dim sr As New IO.StreamReader(Faun$)
                sr.Close()
                TextBox3.Text = Faun$
            Catch
                KfileOK = 0
                MsgBox("指定されたデータファイルが開けません！", 0, "オープンエラー")
                Me.Close()
            End Try
        End If

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click

        KfileOK = 0
        OpenFileDialog1.Filter = "すべてのファイル(*.*)|*.*|データファイル(*.aun)|*.aun"
        OpenFileDialog1.FilterIndex = 2
        OpenFileDialog1.FileName = Fadd$
        OpenFileDialog1.ShowDialog()
        If KfileOK > 0 Then
            Fadd$ = OpenFileDialog1.FileName
            Try
                Dim sr As New IO.StreamReader(Fadd$)
                sr.Close()
                TextBox4.Text = Fadd$
            Catch
                KfileOK = 0
                MsgBox("指定されたデータファイルが開けません！", 0, "オープンエラー")
                Me.Close()
            End Try
        End If

    End Sub

    Private Sub Button3_Click(sender As Object, e As System.EventArgs) Handles Button3.Click
        Dim aa$, fb$, titleb$
        Dim ix, kh As Integer

        fb$ = ""
        Title$ = TextBox1.Text
        titleb$ = Title$
        Nsect = Val(TextBox2.Text)
        If Nsect < 1 Then
            Nsect = 1
        End If
        Hdist = Val(TextBox5.Text)

        Faun$ = TextBox3.Text
        Fadd$ = TextBox4.Text
        Call TmpFileOut() 'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み

        Dim sw As New IO.StreamWriter(Fx$)
        sw.WriteLine(KindPlate)
        sw.WriteLine(Nsect)
        sw.WriteLine(Hdist)
        sw.Close()

        Call MeshGene()     'メッシュ生成

        Call DfilePrepA()   '構造ﾃﾞｰﾀﾌｧｲﾙ保存の前処理
        If titleb$ <> "" Then
            Title$ = titleb$
        End If

        Call DataCheckS(kh)    '入力ﾃﾞｰﾀのｴﾗｰﾁｪｯｸ
        If kh < 0 Then
            aa$ = "生成したメッシュデータにエラーがありました！"
            MsgBox(aa$, 0, "メッシュ生成エラー")
        Else
            KdataChange5 = 2
            Label2.Text = "計算終了！"
            aa$ = "構造データファイルへ出力しますか？"
            Me.BringToFront()
            ix = MsgBox(aa$, 4, "計算終了確認")
            If ix = 6 Then
                If Fauz$ <> "" Then
                    Call FileName(Faun$, fb$)
                    'ﾌｧｲﾙ名Fauz$から拡張子なしの部分fb$を取得
                    Fm$ = fb$ + ".au3"
                End If
                InOut = 1
                Dim frm As Form = New SolDDat6() '構造ﾃﾞｰﾀﾌｧｲﾙ出力
                frm.Show()
            End If
        End If

        Me.Close()

    End Sub

    Private Sub Button4_Click(sender As Object, e As System.EventArgs) Handles Button4.Click
        Me.Close()

    End Sub

    Private Sub RadioButton1_Click(sender As Object, e As System.EventArgs) Handles RadioButton1.Click
        If KindPlate = 1 Then
            KindPlate = 0
            Call CondDisp()  '条件表示
        End If
    End Sub

    Private Sub RadioButton2_Click(sender As Object, e As System.EventArgs) Handles RadioButton2.Click
        If KindPlate = 0 Then
            KindPlate = 1
            Call CondDisp()  '条件表示
        End If
    End Sub

    Private Sub OpenFileDialog1_FileOk(sender As Object, e As CancelEventArgs) Handles OpenFileDialog1.FileOk
        KfileOK = 1

    End Sub
End Class