Public Class Plate3D1
    '３次元の四角形メッシュの生成

    Dim Fx$         'ﾌｧｲﾙ名

    Dim NPsecStd As Integer     '面の節点数
    Dim NumPstd As Integer      '辺の節点数

    Dim Mesh(2) As Integer      'メッシュ数m1、m2
    Dim NVert As Integer    '頂点数（=3）

    Dim XL1(), YL1(), ZL1() As Single   '左辺の節点座標
    Dim XL2(), YL2(), ZL2() As Single   '右辺の節点座標
    Dim Xvert(3), YVert(3), ZVert(3) As Single   '3頂点の座標

    Private Sub DataSize()
        'ﾃﾞｰﾀｻｲｽﾞの設定
        Dim nb As Integer

        NumPstd = 2 * Mesh(2) + 1
        NPsecStd = NumPstd * (Mesh(1) + 1) + (Mesh(2) + 1) * Mesh(1)
        ReDim X(NPsecStd), Y(NPsecStd), Z(NPsecStd)
        nb = Mesh(1) * Mesh(2)
        ReDim NNelem(nb, 8)
        ReDim XL1(NumPstd), YL1(NumPstd), ZL1(NumPstd)
        ReDim XL2(NumPstd), YL2(NumPstd), ZL2(NumPstd)

    End Sub

    Private Sub ElemGene()
        '四角形要素の作成
        Dim i, j, k, n0, n1, nbL, nbM, nunit As Integer
        Dim kbuf(8) As Integer

        n0 = 2 * Mesh(1) + 1
        n1 = Mesh(1) + 1
        nunit = n0 + n1
        For i = 1 To Mesh(2)
            nbL = nunit * (i - 1)
            nbM = nbL + n0
            For j = 1 To Mesh(1)
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = kbuf(1) + 1
                kbuf(3) = kbuf(2) + 1
                kbuf(4) = nbM + j + 1
                kbuf(5) = kbuf(3) + nunit
                kbuf(6) = kbuf(5) - 1
                kbuf(7) = kbuf(6) - 1
                kbuf(8) = kbuf(4) - 1
                For k = 1 To 8
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
        Next i

    End Sub

    Private Sub MeshGene()
        'メッシュ生成

        Call DataSize() 'ﾃﾞｰﾀｻｲｽﾞの設定
        Nelem = 0
        Npoint = 0

        PlaneLine()   '面の両辺のﾒｯｼｭ計算
        PlaneSect()   '面の節点計算
        Call ElemGene() '四角形要素の作成

    End Sub

    Private Sub PlaneLine()
        '面の両辺のﾒｯｼｭ計算
        Dim i, mb, nb As Integer
        Dim b1, b2, xb, yb, zb As Single

        mb = 2 * Mesh(2)
        nb = 0
        For i = 0 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            xb = b1 * Xvert(1) + b2 * Xvert(4)
            yb = b1 * YVert(1) + b2 * YVert(4)
            zb = b1 * ZVert(1) + b2 * ZVert(4)
            nb = nb + 1
            XL1(nb) = xb
            YL1(nb) = yb
            ZL1(nb) = zb
            xb = b1 * Xvert(2) + b2 * Xvert(3)
            yb = b1 * YVert(2) + b2 * YVert(3)
            zb = b1 * ZVert(2) + b2 * ZVert(3)
            XL2(nb) = xb
            YL2(nb) = yb
            ZL2(nb) = zb
        Next i

    End Sub

    Private Sub PlaneSect()
        '面の節点計算
        Dim i, ic, imax, j, jb As Integer
        Dim b1, b2, x1, x2, y1, y2, z1, z2 As Single

        imax = 2 * Mesh(2) + 1
        ic = 0
        For i = 1 To imax
            x1 = XL1(i) : x2 = XL2(i)
            y1 = YL1(i) : y2 = YL2(i)
            z1 = ZL1(i) : z2 = ZL2(i)
            If ic = 0 Then
                jb = 2 * Mesh(1)
            Else
                jb = Mesh(1)
            End If
            For j = 1 To jb + 1
                b1 = (j - 1.0) / jb
                b2 = 1 - b1
                Npoint = Npoint + 1
                X(Npoint) = b2 * x1 + b1 * x2
                Y(Npoint) = b2 * y1 + b1 * y2
                Z(Npoint) = b2 * z1 + b1 * z2
            Next j
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
        Next i

    End Sub

    Private Sub PlateCheck(ByRef kh As Integer)
        '平面ﾁｪｯｸ
        'kh･･･ｴﾗｰの有無（0:なし、-2:有り）
        Dim i As Integer
        Dim b1, b2, eps, h, rlen, xl, xu, yl, yu, zl, zu As Single
        Dim cbuf(4) As Single

        kh = 0
        xl = Xvert(1) : xu = xl
        yl = YVert(1) : yu = yl
        zl = ZVert(1) : zu = zl
        For i = 2 To 4
            If Xvert(i) < xl Then
                xl = Xvert(i)
            ElseIf Xvert(i) > xu Then
                xu = Xvert(i)
            End If
            If YVert(i) < yl Then
                yl = YVert(i)
            ElseIf YVert(i) > yu Then
                yu = YVert(i)
            End If
            If ZVert(i) < zl Then
                zl = ZVert(i)
            ElseIf ZVert(i) > zu Then
                zu = ZVert(i)
            End If
        Next i
        rlen = xu - xl
        b1 = yu - yl
        If b1 > rlen Then
            rlen = b1
        End If
        b1 = zu - zl
        If b1 > rlen Then
            rlen = b1
        End If
        eps = 0.0001 * rlen

        '3点を通る平面の式 c1*x+c2*y c3*z+c4=0
        b1 = (YVert(2) - YVert(1)) * (ZVert(3) - ZVert(1))
        b1 = b1 - (YVert(3) - YVert(1)) * (ZVert(2) - ZVert(1))
        cbuf(1) = b1
        cbuf(4) = -b1 * Xvert(1)
        b1 = (ZVert(2) - ZVert(1)) * (Xvert(3) - Xvert(1))
        b1 = b1 - (ZVert(3) - ZVert(1)) * (Xvert(2) - Xvert(1))
        cbuf(2) = b1
        cbuf(4) = cbuf(4) - b1 * YVert(1)
        b1 = (Xvert(2) - Xvert(1)) * (YVert(3) - YVert(1))
        b1 = b1 - (Xvert(3) - Xvert(1)) * (YVert(2) - YVert(1))
        cbuf(3) = b1
        cbuf(4) = cbuf(4) - b1 * ZVert(1)

        '頂点4から平面への垂線距離h
        b1 = cbuf(1) * Xvert(4) + cbuf(2) * YVert(4) + cbuf(3) * ZVert(4) + cbuf(4)
        b2 = Math.Sqrt(cbuf(1) ^ 2 + cbuf(2) ^ 2 + cbuf(3) ^ 2)
        h = Math.Abs(b1 / b2)

        If h > eps Then
            kh = -2
        End If

    End Sub

    Private Sub SpecSet(ByRef kh As Integer)
        '仕様セット
        Dim aa$
        Dim i, ix As Integer
        Xvert(1) = Val(TextBox1.Text)
        YVert(1) = Val(TextBox2.Text)
        ZVert(1) = Val(TextBox3.Text)
        Xvert(2) = Val(TextBox4.Text)
        YVert(2) = Val(TextBox5.Text)
        ZVert(2) = Val(TextBox6.Text)
        Xvert(3) = Val(TextBox7.Text)
        YVert(3) = Val(TextBox8.Text)
        ZVert(3) = Val(TextBox9.Text)
        Xvert(4) = Val(TextBox12.Text)
        YVert(4) = Val(TextBox13.Text)
        ZVert(4) = Val(TextBox14.Text)

        Mesh(1) = Val(TextBox15.Text)
        Mesh(2) = Val(TextBox16.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        For i = 1 To 2
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i

        'GoTo Skip10
        Call PlateCheck(kh)   '平面ﾁｪｯｸ
        If kh < 0 Then
            aa$ = "4点が同一平面上にありません！"
            aa$ = aa$ + Chr(13) + Chr(10) + "そのまま続けますか？"
            ix = MsgBox(aa$, MsgBoxStyle.YesNo, "データエラー")
            If ix = 6 Then
                kh = 1
            End If
            Exit Sub
        End If
Skip10:

        GoTo Skip20
        '同一平面にするため第3点Z座標の変更計算
        'Dim iter As Integer
        'Dim delta, z1, z2, zx As Single
        'z1 = ZVert(3) : z2 = z1
        'delta = ZVert(3) * 0.001
        'Do
        'iter = iter + 1
        'z1 = z1 + delta
        'ZVert(3) = z1
        'Call PlateCheck(kh)   '平面ﾁｪｯｸ
        'If kh = 0 Then
        'Exit Do
        'End If
        'z2 = z2 - delta
        'ZVert(3) = z2
        'Call PlateCheck(kh)   '平面ﾁｪｯｸ
        'If kh = 0 Then
        'Exit Do
        'End If
        'If iter > 1000 Then
        'Stop
        'End If
        'Loop
        'zx = ZVert(3)
        Stop
Skip20:

    End Sub

    Private Sub Plate3D2_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim i, icc, ii As Integer

        NVert = 4
        ReDim Xvert(NVert), YVert(NVert), ZVert(NVert)

        Fx$ = DirOpen$ + "\Plate3D1.tmp"
        Try
            ii = FreeFile()
            FileOpen(ii, Fx$, OpenMode.Input)
            icc = 1
            For i = 1 To 4
                Input(ii, Xvert(i))
                Input(ii, YVert(i))
                Input(ii, ZVert(i))
            Next i
            Input(ii, Mesh(1))
            Input(ii, Mesh(2))
        Catch
            '処理不要
        End Try
        If icc > 0 Then
            FileClose(ii)
        End If

        GoTo Skip1
        Xvert(1) = 0 : YVert(1) = 0 : ZVert(1) = 0.001
        Xvert(2) = 2 : YVert(2) = 0 : ZVert(2) = 0.001
        Xvert(3) = 2 : YVert(3) = 1 : ZVert(3) = 0.001
        Xvert(4) = 0 : YVert(4) = 1 : ZVert(4) = 0.001
Skip1:

        If Mesh(1) = 0 Then
            Mesh(1) = 10 : Mesh(2) = 10
        End If
        TextBox1.Text = Str(Xvert(1))
        TextBox2.Text = Str(YVert(1))
        TextBox3.Text = Str(ZVert(1))
        TextBox4.Text = Str(Xvert(2))
        TextBox5.Text = Str(YVert(2))
        TextBox6.Text = Str(ZVert(2))
        TextBox7.Text = Str(Xvert(3))
        TextBox8.Text = Str(YVert(3))
        TextBox9.Text = Str(ZVert(3))
        TextBox12.Text = Str(Xvert(4))
        TextBox13.Text = Str(YVert(4))
        TextBox14.Text = Str(ZVert(4))
        TextBox15.Text = Str(Mesh(1))
        TextBox16.Text = Str(Mesh(2))

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ii, ix, kh As Integer

        Call SpecSet(kh)  '仕様セット

        ii = FreeFile()
        FileOpen(ii, Fx$, OpenMode.Output)
        For i = 1 To 4
            WriteLine(ii, Xvert(i))
            WriteLine(ii, YVert(i))
            WriteLine(ii, ZVert(i))
        Next i
        WriteLine(ii, Mesh(1))
        WriteLine(ii, Mesh(2))
        FileClose(ii)

        If kh < 0 Then
            Exit Sub
        End If

        Call MeshGene()     'メッシュ生成

        Title$ = "空間の四角形のメッシュデータ"
        ReDim NumMat(Nelem)
        For i = 1 To Nelem
            NumMat(i) = 1
        Next i
        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            Title$ = "３次元の四角形メッシュ"
            InOut = 1
            Dim frm As Form = New MeshAun6()   '断面ﾃﾞｰﾀﾌｧｲﾙへの書き出し
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub

    Private Sub TextBox9_TextChanged(sender As System.Object, e As System.EventArgs) Handles TextBox9.TextChanged

    End Sub
End Class