Public Class Plate3D2
    '３次元の三角形メッシュの生成

    Dim Fx$         'ﾌｧｲﾙ名

    Dim NPsecStd As Integer     '面の節点数
    Dim NumPstd As Integer      '辺の節点数

    Dim Mesh(2) As Integer      'メッシュ数m1、m2
    Dim NVert As Integer    '頂点数（=3）

    Dim XL1(), YL1(), ZL1() As Single   '左辺の節点座標
    Dim XL2(), YL2(), ZL2() As Single   '右辺の節点座標
    Dim Xvert(3), YVert(3), ZVert(3) As Single   '3頂点の座標

    Private Sub DataSize()
        'ﾃﾞｰﾀｻｲｽﾞの設定
        Dim nb As Integer

        NumPstd = 2 * Mesh(2) + 1
        NPsecStd = NumPstd * (Mesh(1) + 1) + (Mesh(2) + 1) * Mesh(1)
        ReDim X(NPsecStd), Y(NPsecStd), Z(NPsecStd)
        nb = Mesh(1) * Mesh(2)
        ReDim NNelem(nb, 8)
        ReDim XL1(NumPstd), YL1(NumPstd), ZL1(NumPstd)
        ReDim XL2(NumPstd), YL2(NumPstd), ZL2(NumPstd)

    End Sub

    Private Sub ElemGene()
        '四角形要素の作成
        Dim i, j, jj, k, n0, n1, nbL, nbM, nunit As Integer
        Dim kbuf(8) As Integer

        n0 = 2 * Mesh(1) + 1
        n1 = Mesh(1) + 1
        nunit = n0 + n1
        For i = 1 To Mesh(2) - 1
            nbL = nunit * (i - 1)
            nbM = nbL + n0
            For j = 1 To Mesh(1)
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = kbuf(1) + 1
                kbuf(3) = kbuf(2) + 1
                kbuf(4) = nbM + j + 1
                kbuf(5) = kbuf(3) + nunit
                kbuf(6) = kbuf(5) - 1
                kbuf(7) = kbuf(6) - 1
                kbuf(8) = kbuf(4) - 1
                For k = 1 To 8
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
        Next i

        '最終ﾒｯｼｭ行（三角形2個で1個の要素生成）
        nbL = nunit * (Mesh(2) - 1)
        nbM = nbL + n0
        jj = nbM
        For j = 1 To Mesh(1) Step 2
            Nelem = Nelem + 1
            kbuf(1) = nbL + 2 * j - 1
            kbuf(2) = kbuf(1) + 1
            kbuf(3) = kbuf(2) + 1
            kbuf(4) = kbuf(3) + 1
            kbuf(5) = kbuf(4) + 1
            kbuf(6) = jj + 2
            kbuf(7) = Npoint
            kbuf(8) = jj + 1
            For k = 1 To 8
                NNelem(Nelem, k) = kbuf(k)
            Next k
            jj = jj + 1
        Next j

    End Sub

    Private Sub MeshGene()
        'メッシュ生成

        Call DataSize() 'ﾃﾞｰﾀｻｲｽﾞの設定
        Nelem = 0
        Npoint = 0

        PlaneLine()   '面の両辺のﾒｯｼｭ計算
        PlaneSect()   '面の節点計算
        Call ElemGene() '四角形要素の作成

    End Sub

    Private Sub PlaneLine()
        '面の両辺のﾒｯｼｭ計算
        Dim i, mb, nb As Integer
        Dim b1, b2, xb, yb, zb As Single

        mb = 2 * Mesh(2)
        nb = 0
        For i = 0 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            xb = b1 * Xvert(1) + b2 * Xvert(3)
            yb = b1 * YVert(1) + b2 * YVert(3)
            zb = b1 * ZVert(1) + b2 * ZVert(3)
            nb = nb + 1
            XL1(nb) = xb
            YL1(nb) = yb
            ZL1(nb) = zb
            xb = b1 * Xvert(2) + b2 * Xvert(3)
            yb = b1 * YVert(2) + b2 * YVert(3)
            zb = b1 * ZVert(2) + b2 * ZVert(3)
            XL2(nb) = xb
            YL2(nb) = yb
            ZL2(nb) = zb
        Next i

    End Sub

    Private Sub PlaneSect()
        '面の節点計算
        Dim i, ic, imax, j, jb As Integer
        Dim b1, b2, x1, x2, y1, y2, z1, z2 As Single

        imax = 2 * Mesh(2) - 1
        ic = 0
        For i = 1 To imax
            x1 = XL1(i) : x2 = XL2(i)
            y1 = YL1(i) : y2 = YL2(i)
            z1 = ZL1(i) : z2 = ZL2(i)
            If ic = 0 Then
                jb = 2 * Mesh(1)
            Else
                jb = Mesh(1)
            End If
            For j = 1 To jb + 1
                b1 = (j - 1.0) / jb
                b2 = 1 - b1
                Npoint = Npoint + 1
                X(Npoint) = b2 * x1 + b1 * x2
                Y(Npoint) = b2 * y1 + b1 * y2
                Z(Npoint) = b2 * z1 + b1 * z2
            Next j
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
        Next i

        i = imax + 1
        x1 = XL1(i) : x2 = XL2(i)
        y1 = YL1(i) : y2 = YL2(i)
        z1 = ZL1(i) : z2 = ZL2(i)
        jb = Mesh(1)
        For j = 1 To jb + 1 Step 2
            b1 = (j - 1.0) / jb
            b2 = 1 - b1
            Npoint = Npoint + 1
            X(Npoint) = b2 * x1 + b1 * x2
            Y(Npoint) = b2 * y1 + b1 * y2
            Z(Npoint) = b2 * z1 + b1 * z2
        Next j

        Npoint = Npoint + 1
        X(Npoint) = Xvert(3)
        Y(Npoint) = YVert(3)
        Z(Npoint) = ZVert(3)

    End Sub

    Private Sub SpecSet(ByRef kh As Integer)
        '仕様セット
        Dim aa$
        Dim i, ib As Integer

        Xvert(1) = Val(TextBox1.Text)
        YVert(1) = Val(TextBox2.Text)
        ZVert(1) = Val(TextBox3.Text)
        Xvert(2) = Val(TextBox4.Text)
        YVert(2) = Val(TextBox5.Text)
        ZVert(2) = Val(TextBox6.Text)
        Xvert(3) = Val(TextBox7.Text)
        YVert(3) = Val(TextBox8.Text)
        ZVert(3) = Val(TextBox9.Text)

        Mesh(1) = Val(TextBox10.Text)
        Mesh(2) = Val(TextBox11.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        For i = 1 To 2
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i
        ib = Mesh(1) Mod 2
        If ib > 0 Then
            aa$ = "分割数m1が偶数になっていません！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
        End If

    End Sub

    Private Sub Plate3D2_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim icc, ii As Integer

        NVert = 3
        ReDim Xvert(NVert), YVert(NVert), ZVert(NVert)

        Fx$ = DirOpen$ + "\Plate3D2.tmp"
        Try
            ii = FreeFile()
            FileOpen(ii, Fx$, OpenMode.Input)
            icc = 1
            Input(ii, Xvert(1))
            Input(ii, YVert(1))
            Input(ii, ZVert(1))
            Input(ii, Xvert(2))
            Input(ii, YVert(2))
            Input(ii, ZVert(2))
            Input(ii, Xvert(3))
            Input(ii, YVert(3))
            Input(ii, ZVert(3))
            Input(ii, Mesh(1))
            Input(ii, Mesh(2))
        Catch
            '処理不要
        End Try
        If icc > 0 Then
            FileClose(ii)
        End If

        GoTo Skip1
        Xvert(2) = 0 : YVert(2) = 0 : ZVert(2) = 0.6
        Xvert(1) = 2.45 : YVert(1) = 0.855 : ZVert(1) = 0
        Xvert(3) = 0 : YVert(3) = 0.855 : ZVert(3) = 0
Skip1:

        GoTo Skip2
        Xvert(3) = 2.45 : YVert(1) = 0.855 : ZVert(1) = 0
        Xvert(2) = 0 : YVert(2) = 0 : ZVert(2) = 0.6
        Xvert(1) = 2.45 : YVert(3) = 0 : ZVert(3) = 0
Skip2:

        If Mesh(1) = 0 Then
            Mesh(1) = 10 : Mesh(2) = 10
        End If

        TextBox1.Text = Str(Xvert(1))
        TextBox2.Text = Str(YVert(1))
        TextBox3.Text = Str(ZVert(1))
        TextBox4.Text = Str(Xvert(2))
        TextBox5.Text = Str(YVert(2))
        TextBox6.Text = Str(ZVert(2))
        TextBox7.Text = Str(Xvert(3))
        TextBox8.Text = Str(YVert(3))
        TextBox9.Text = Str(ZVert(3))
        TextBox10.Text = Str(Mesh(1))
        TextBox11.Text = Str(Mesh(2))

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ii, ix, kh As Integer

        Call SpecSet(kh)  '仕様セット

        ii = FreeFile()
        FileOpen(ii, Fx$, OpenMode.Output)
        WriteLine(ii, Xvert(1))
        WriteLine(ii, YVert(1))
        WriteLine(ii, ZVert(1))
        WriteLine(ii, Xvert(2))
        WriteLine(ii, YVert(2))
        WriteLine(ii, ZVert(2))
        WriteLine(ii, Xvert(3))
        WriteLine(ii, YVert(3))
        WriteLine(ii, ZVert(3))
        WriteLine(ii, Mesh(1))
        WriteLine(ii, Mesh(2))
        FileClose(ii)

        If kh < 0 Then
            Exit Sub
        End If

        Call MeshGene()     'メッシュ生成

        Title$ = "空間の三角形のメッシュデータ"
        ReDim NumMat(Nelem)
        For i = 1 To Nelem
            NumMat(i) = 1
        Next i
        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            Title$ = "３次元の三角形メッシュ"
            InOut = 1
            Dim frm As Form = New MeshAun6()   '断面ﾃﾞｰﾀﾌｧｲﾙへの書き出し
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub

    Private Sub TextBox9_TextChanged(sender As System.Object, e As System.EventArgs) Handles TextBox9.TextChanged

    End Sub
End Class