'横穴付き円筒の生成ﾌﾟﾛｸﾞﾗﾑ

Public Class SolDDat11
    Dim Fx$         'ﾌｧｲﾙ名

    Dim NPbaseL As Integer  '左面の節点ベース数
    Dim NPbaseM As Integer  '中間面の節点ベース数
    Dim NPbaseR As Integer  '右面の節点ベース数
    Dim NPsecStd As Integer '基準面の節点数
    Dim NPsecStM As Integer '基準中間面の節点数
    Dim NumCirc As Integer  '横穴の節点数
    Dim NumPstd As Integer  '基準面の周の節点数
    Dim NumPstM As Integer  '基準中間面の周の節点数
    Dim NumQ As Integer     '横穴分割数／４

    Dim Alpha As Single     '上部角度α（°）
    Dim Beta As Single      '下部角度β（°）
    Dim Dia As Single       '横穴の直径

    Dim Mesh(6) As Integer  'メッシュ数m1～m6

    Dim BL(2) As Single     '円筒長さb1,b2
    Dim Rad(2) As Single    '円筒の内側半径R1,R2
    Dim XcircIn(), YcircIn(), ZcircIn() As Single       '内周の横穴の座標
    Dim XcircOut(), YcircOut(), ZcircOut() As Single    '外周の横穴の座標
    Dim XM1(), YM1(), ZM1() As Single   '中間面内周の節点座標
    Dim XM2(), YM2(), ZM2() As Single   '中間面外周の節点座標
    Dim XR1(), YR1(), ZR1() As Single   '右面内周の節点座標
    Dim XR2(), YR2(), ZR2() As Single   '右面内周の節点座標

    Private Sub CircleSet()
        '横穴の設定
        Dim i As Integer
        Dim b1, b2, dist, h, rb As Single

        NumCirc = 2 * Mesh(6)
        ReDim XcircIn(NumCirc), YcircIn(NumCirc), ZcircIn(NumCirc)
        ReDim XcircOut(NumCirc), YcircOut(NumCirc), ZcircOut(NumCirc)
        rb = 0.5 * Dia
        For i = 1 To NumCirc
            b1 = Dpai * (i - 1) / NumCirc
            b2 = rb * Math.Cos(b1)
            h = rb * Math.Sin(b1)
            dist = Math.Sqrt(Rad(2) * Rad(2) - h * h)
            YcircOut(i) = -dist
            XcircOut(i) = BL(1) + b2
            ZcircOut(i) = h
            dist = Math.Sqrt(Rad(1) * Rad(1) - h * h)
            YcircIn(i) = -dist
            XcircIn(i) = XcircOut(i)
            ZcircIn(i) = ZcircOut(i)
        Next i

    End Sub

    Private Sub DataSet(ByRef kh As Integer)
        'ﾃﾞｰﾀの設定
        Dim aa$
        Dim i, ic As Integer
        Dim b1, b2, c0 As Single

        BL(1) = Val(TextBox1.Text)
        BL(2) = Val(TextBox2.Text)
        Rad(1) = Val(TextBox3.Text)
        Rad(2) = Val(TextBox4.Text)
        Dia = Val(TextBox5.Text)
        Alpha = Val(TextBox6.Text)
        Beta = Val(TextBox7.Text)
        Mesh(1) = Val(TextBox8.Text)
        Mesh(2) = Val(TextBox9.Text)
        Mesh(3) = Val(TextBox10.Text)
        Mesh(4) = Val(TextBox11.Text)
        Mesh(5) = Val(TextBox12.Text)
        Mesh(6) = Val(TextBox13.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        If BL(1) <= 0 Or BL(2) <= 0 Then
            aa$ = "円筒の長さが間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Rad(1) <= 0 Or Rad(2) <= 0 Then
            aa$ = "円筒の半径が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Dia <= 0 Then
            aa$ = "横穴の直径が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Alpha <= 0 Or Beta <= 0 Then
            aa$ = "上下部の角度が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Alpha > 90 Or Beta > 90 Then
            aa$ = "上下部の角度が90°を超えています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        For i = 1 To 6
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i
        ic = Mesh(6) Mod 4
        If ic > 0 Then
            aa$ = "横穴の分割数m6が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        NumQ = Mesh(6) / 4
        If Mesh(1) <= NumQ Or Mesh(2) <= NumQ Then
            aa$ = "円筒長さの分割数が少な過ぎます！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Mesh(3) <= NumQ Or Mesh(4) <= NumQ Then
            aa$ = "上下部角度の分割数が少な過ぎます！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        c0 = Pai / 180
        b1 = Rad(1) * Math.Sin(Alpha * c0)
        b2 = Rad(1) * Math.Sin(Beta * c0)
        If Math.Abs(b1) + Math.Abs(b2) < 1.2 * Dia Then
            aa$ = "横穴直径が大き過ぎます！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If

    End Sub

    Private Sub DataSize()
        'ﾃﾞｰﾀｻｲｽﾞの設定
        Dim mb, nb As Integer

        NumPstM = Mesh(3) + Mesh(4) + 1
        NumPstd = 2 * (Mesh(3) + Mesh(4)) + 1
        NPsecStd = NumPstd * (Mesh(5) + 1) + NumPstM * Mesh(5)
        NPsecStM = NumPstM * (Mesh(5) + 1)
        mb = Mesh(1) + Mesh(2)
        nb = (NPsecStd + NumPstd) * (mb + 1) + (NPsecStM + NumPstM) * mb
        ReDim Xdata(nb), Ydata(nb), Zdata(nb)
        nb = (Mesh(3) + Mesh(4)) * Mesh(5) * mb
        ReDim NNelem(nb, 20)

    End Sub

    Private Sub SolDDat11_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim icc, ii, k As Integer

        Fx$ = DirOpen$ + "\SolDDat11.tmp"
        Try
            ii = FreeFile()
            FileOpen(ii, Fx$, OpenMode.Input)
            icc = 1
            Input(ii, BL(1))
            Input(ii, BL(2))
            Input(ii, Rad(1))
            Input(ii, Rad(2))
            Input(ii, Dia)
            Input(ii, Alpha)
            Input(ii, Beta)
            For k = 1 To 6
                Input(ii, Mesh(k))
            Next k
        Catch
            '処理不要
        End Try
        If icc > 0 Then
            FileClose(ii)
        End If

        TextBox1.Text = Str(BL(1))
        TextBox2.Text = Str(BL(2))
        TextBox3.Text = Str(Rad(1))
        TextBox4.Text = Str(Rad(2))
        TextBox5.Text = Str(Dia)
        TextBox6.Text = Str(Alpha)
        TextBox7.Text = Str(Beta)
        TextBox8.Text = Str(Mesh(1))
        TextBox9.Text = Str(Mesh(2))
        TextBox10.Text = Str(Mesh(3))
        TextBox11.Text = Str(Mesh(4))
        TextBox12.Text = Str(Mesh(5))
        TextBox13.Text = Str(Mesh(6))

    End Sub

    Private Sub Debug1()
        '標準の周囲線のﾒｯｼｭ点を出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\SolDDat11debug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜外周のメッシュ点＞"
        WriteLine(ii, aa$)
        aa$ = "点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = 1 To NumPstd
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(XR2(i))
            aa$ = aa$ + "," + Str$(YR2(i))
            aa$ = aa$ + "," + Str$(ZR2(i))
            PrintLine(ii, aa$)
        Next i
        aa$ = "＜内周のメッシュ点＞"
        WriteLine(ii, aa$)
        aa$ = "点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = 1 To NumPstd
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(XR1(i))
            aa$ = aa$ + "," + Str$(YR1(i))
            aa$ = aa$ + "," + Str$(ZR1(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug2(ByVal kind As Integer)
        '標準の中間線のﾒｯｼｭ点を出力して停止
        'kind･･･上下分離の有無（0:なし、1:有り）
        Dim aa$, fxx$
        Dim i, i2, ii As Integer

        If kind = 0 Then
            i2 = NumPstM
        Else
            i2 = NumPstM + 1
        End If
        ii = FreeFile()
        fxx$ = DirOpen$ + "\SolDDat11debug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜外周のメッシュ点＞"
        WriteLine(ii, aa$)
        aa$ = "点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = 1 To i2
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(XM2(i))
            aa$ = aa$ + "," + Str$(YM2(i))
            aa$ = aa$ + "," + Str$(ZM2(i))
            PrintLine(ii, aa$)
        Next i
        aa$ = "＜内周のメッシュ点＞"
        WriteLine(ii, aa$)
        aa$ = "点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = 1 To i2
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(XM1(i))
            aa$ = aa$ + "," + Str$(YM1(i))
            aa$ = aa$ + "," + Str$(ZM1(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub ElemGene(ByVal kind As Integer)
        '六面体要素の作成
        'kind･･･種別（0:基本、1:左面のみ基本、2:各面とも上下分離有り、3:右面のみ基本）
        Dim i, j, k, n0, n1, nbL, nbLb, nbM, nbMb, nbR, nbRb, nunit As Integer
        Dim kbuf(20) As Integer

        n0 = 2 * Mesh(5) + 1
        n1 = Mesh(5) + 1
        nunit = n0 + n1
        For i = 1 To Mesh(4)
            nbL = NPbaseL + nunit * (i - 1)
            nbM = NPbaseM + n1 * (i - 1)
            nbR = NPbaseR + nunit * (i - 1)
            For j = 1 To Mesh(5)
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0 + j
                kbuf(3) = kbuf(1) + nunit
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1
                kbuf(11) = kbuf(10) + 1
                kbuf(12) = kbuf(9) + 1
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0 + j
                kbuf(15) = kbuf(13) + nunit
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = kbuf(16) + 1
                kbuf(18) = kbuf(14) + 1
                kbuf(19) = kbuf(13) + 2
                kbuf(20) = kbuf(13) + 1
                For k = 1 To 20
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
        Next i
        Select Case kind
            Case 0
                nbLb = NPbaseL + nunit * Mesh(4)
                nbMb = NPbaseM + n1 * Mesh(4)
                nbRb = NPbaseR + nunit * Mesh(4)
            Case 1
                nbLb = NPbaseL + nunit * Mesh(4)
                nbMb = NPbaseM + n1 * (Mesh(4) + 1)
                nbRb = NPbaseR + nunit * Mesh(4) + n0
            Case 2
                nbLb = NPbaseL + nunit * Mesh(4) + n0
                nbMb = NPbaseM + n1 * (Mesh(4) + 1)
                nbRb = NPbaseR + nunit * Mesh(4) + n0
            Case 3
                nbLb = NPbaseL + nunit * Mesh(4) + n0
                nbMb = NPbaseM + n1 * (Mesh(4) + 1)
                nbRb = NPbaseR + nunit * Mesh(4)
        End Select
        For i = 1 To Mesh(3)
            nbL = nbLb + nunit * (i - 1)
            nbM = nbMb + n1 * (i - 1)
            nbR = nbRb + nunit * (i - 1)
            For j = 1 To Mesh(5)
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0 + j
                kbuf(3) = kbuf(1) + nunit
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1
                kbuf(11) = kbuf(10) + 1
                kbuf(12) = kbuf(9) + 1
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0 + j
                kbuf(15) = kbuf(13) + nunit
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = kbuf(16) + 1
                kbuf(18) = kbuf(14) + 1
                kbuf(19) = kbuf(13) + 2
                kbuf(20) = kbuf(13) + 1
                For k = 1 To 20
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
        Next i

    End Sub

    Private Sub MeshGene()
        '要素ﾒｯｼｭの生成
        Dim i, i2, ib, kcs, kce, kind, mb, meshb As Integer
        Dim b1, b2, rlen, xmm, xsM, xsR, zmm As Single

        ReDim XR1(NumPstd + 1), YR1(NumPstd + 1), ZR1(NumPstd + 1)
        ReDim XR2(NumPstd + 1), YR2(NumPstd + 1), ZR2(NumPstd + 1)
        ReDim XM1(NumPstM + 1), YM1(NumPstM + 1), ZM1(NumPstM + 1)
        ReDim XM2(NumPstM + 1), YM2(NumPstM + 1), ZM2(NumPstM + 1)

        kcs = Mesh(1) - NumQ + 1
        kce = Mesh(1) + NumQ + 1
        Nelem = 0
        Npoint = 0
        meshb = Mesh(1) + Mesh(2)
        rlen = BL(1) + BL(2)

        i2 = meshb     '正規
        'i2 = 6        'テスト

        For i = 1 To i2
            xsR = rlen * i / meshb
            xsM = 0.5 * rlen * (2 * i - 1) / meshb

            '左面の設定
            If i = 1 Then
                Call RPlaneLine(0, 0, 0, 0)   '右面の周囲線のﾒｯｼｭ計算
                Call RPlaneSect(0)   '右面の節点計算
            End If
            NPbaseL = NPbaseR

            '中間面の設定
            If i < kcs Then
                b1 = BL(1) - 0.5 * Dia
                b2 = b1 / (kcs - 1) / 2
                xmm = (2 * i - 1) * b2
                zmm = 0
                kind = 0
            ElseIf kcs <= i And i < kce Then
                ib = i - kcs
                mb = Mesh(6) / 2 - ib
                ib = 2 * mb
                xmm = XcircOut(ib)
                zmm = ZcircOut(ib)
                kind = 1
            Else
                b1 = BL(1) + 0.5 * Dia
                b2 = (rlen - b1) / (meshb + 1 - kce) / 2
                xmm = b1 + (2 * (i - kce) + 1) * b2
                zmm = 0
                kind = 0
            End If
            Call MPlaneLine(kind, xsM, xmm, zmm)   '中間面の周囲線のﾒｯｼｭ計算
            Call MPlaneSect(kind)   '中間面の節点計算

            '右面の設定
            If i < kcs Then
                b1 = BL(1) - 0.5 * Dia
                b2 = b1 / (kcs - 1)
                xmm = i * b2
                zmm = 0
                kind = 0
            ElseIf kcs <= i And i + 1 < kce Then
                ib = i - kcs
                mb = Mesh(6) / 2 - ib
                ib = 2 * mb - 1
                xmm = XcircOut(ib)
                zmm = ZcircOut(ib)
                kind = 1
            Else
                b1 = BL(1) + 0.5 * Dia
                b2 = (rlen - b1) / (meshb + 1 - kce)
                xmm = b1 + (i - kce + 1) * b2
                zmm = 0
                kind = 0
            End If
            Call RPlaneLine(kind, xsR, xmm, zmm)   '右面の周囲線のﾒｯｼｭ計算
            Call RPlaneSect(kind)   '右面の節点計算

            If i < kcs Or kce <= i Then
                kind = 0
            ElseIf i = kcs Then
                kind = 1
            ElseIf i + 1 < kce Then
                kind = 2
            Else
                kind = 3
            End If
            Call ElemGene(kind) '六面体要素の作成

        Next i

    End Sub

    Private Sub MPlaneLine(ByVal kind As Integer, ByVal xsM As Single, _
        ByVal xmm As Single, ByVal zmm As Single)
        '中間面の周囲線のﾒｯｼｭ計算
        'kind･･･上下分離の有無（0:なし、1:有り）
        'xsM･･･基準X座標
        'xmm･･･上下境界点のX座標
        'zmm･･･上下境界点のZ座標（絶対値）
        Dim i, i1, mb, nb As Integer
        Dim b1, b2, c0, cosb, sinb, xb, yb, zb, theta As Single
        Dim thetam(2) As Single

        c0 = Pai / 180
        If kind = 0 Then
            thetam(1) = 0
            thetam(2) = 0
        Else
            thetam(1) = Math.Asin(zmm / Rad(1))
            thetam(2) = Math.Asin(zmm / Rad(2))
        End If
        mb = Mesh(4)
        nb = 0
        For i = 0 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            theta = -(b1 * Beta * c0 + b2 * thetam(1))
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -Rad(1) * cosb
            zb = Rad(1) * sinb
            xb = b1 * xsM + b2 * xmm
            nb = nb + 1
            XM1(nb) = xb
            YM1(nb) = yb
            ZM1(nb) = zb
            theta = -(b1 * Beta * c0 + b2 * thetam(2))
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -Rad(2) * cosb
            zb = Rad(2) * sinb
            XM2(nb) = xb
            YM2(nb) = yb
            ZM2(nb) = zb
        Next i
        mb = Mesh(3)
        If kind = 0 Then
            i1 = 1
        Else
            i1 = 0
        End If
        For i = i1 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            theta = b2 * Alpha * c0 + b1 * thetam(1)
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -Rad(1) * cosb
            zb = Rad(1) * sinb
            xb = b2 * xsM + b1 * xmm
            nb = nb + 1
            XM1(nb) = xb
            YM1(nb) = yb
            ZM1(nb) = zb
            theta = b2 * Alpha * c0 + b1 * thetam(2)
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -Rad(2) * cosb
            zb = Rad(2) * sinb
            XM2(nb) = xb
            YM2(nb) = yb
            ZM2(nb) = zb
        Next i

    End Sub

    Private Sub MPlaneSect(ByVal kind As Integer)
        '中間面の節点計算
        'kind･･･上下分離の有無（0:なし、1:有り）
        Dim i, imax, j As Integer
        Dim b1, b2, x1, x2, y1, y2, z1, z2 As Single

        imax = Mesh(3) + Mesh(4) + 1
        If kind > 0 Then
            imax = imax + 1
        End If
        NPbaseM = Npoint
        For i = 1 To imax
            x1 = XM1(i) : x2 = XM2(i)
            y1 = YM1(i) : y2 = YM2(i)
            z1 = ZM1(i) : z2 = ZM2(i)
            For j = 1 To Mesh(5) + 1
                b1 = (j - 1.0) / Mesh(5)
                b2 = 1 - b1
                Npoint = Npoint + 1
                Xdata(Npoint) = b1 * x1 + b2 * x2
                Ydata(Npoint) = b1 * y1 + b2 * y2
                Zdata(Npoint) = b1 * z1 + b2 * z2
            Next j
        Next i

    End Sub

    Private Sub RPlaneLine(ByVal kind As Integer, ByVal xsR As Single, _
        ByVal xmm As Single, ByVal zmm As Single)
        '右面の周囲線のﾒｯｼｭ計算
        'kind･･･上下分離の有無（0:なし、1:有り）
        'xsR･･･基準X座標
        'xmm･･･上下境界点のX座標
        'zmm･･･上下境界点のZ座標（絶対値）
        Dim i, i1, mb, nb As Integer
        Dim b1, b2, c0, cosb, sinb, xb, yb, zb, theta As Single
        Dim thetam(2) As Single

        c0 = Pai / 180
        If kind = 0 Then
            thetam(1) = 0
            thetam(2) = 0
        Else
            thetam(1) = Math.Asin(zmm / Rad(1))
            thetam(2) = Math.Asin(zmm / Rad(2))
        End If
        mb = 2 * Mesh(4)
        nb = 0
        For i = 0 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            theta = -(b1 * Beta * c0 + b2 * thetam(1))
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -Rad(1) * cosb
            zb = Rad(1) * sinb
            xb = b1 * xsR + b2 * xmm
            nb = nb + 1
            XR1(nb) = xb
            YR1(nb) = yb
            ZR1(nb) = zb
            theta = -(b1 * Beta * c0 + b2 * thetam(2))
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -Rad(2) * cosb
            zb = Rad(2) * sinb
            XR2(nb) = xb
            YR2(nb) = yb
            ZR2(nb) = zb
        Next i
        mb = 2 * Mesh(3)
        If kind = 0 Then
            i1 = 1
        Else
            i1 = 0
        End If
        For i = i1 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            theta = b2 * Alpha * c0 + b1 * thetam(1)
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -Rad(1) * cosb
            zb = Rad(1) * sinb
            xb = b2 * xsR + b1 * xmm
            nb = nb + 1
            XR1(nb) = xb
            YR1(nb) = yb
            ZR1(nb) = zb
            theta = b2 * Alpha * c0 + b1 * thetam(2)
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -Rad(2) * cosb
            zb = Rad(2) * sinb
            XR2(nb) = xb
            YR2(nb) = yb
            ZR2(nb) = zb
        Next i

    End Sub

    Private Sub RPlaneSect(ByVal kind As Integer)
        '右面の節点計算
        'kind･･･上下分離の有無（0:なし、1:有り）
        Dim i, i1, i2, ic, imax, j, jb, k As Integer
        Dim b1, b2, x1, x2, y1, y2, z1, z2 As Single

        NPbaseR = Npoint
        If kind = 0 Then
            imax = 2 * (Mesh(3) + Mesh(4)) + 1
            ic = 0
            For i = 1 To imax
                x1 = XR1(i) : x2 = XR2(i)
                y1 = YR1(i) : y2 = YR2(i)
                z1 = ZR1(i) : z2 = ZR2(i)
                If ic = 0 Then
                    jb = 2 * Mesh(5)
                Else
                    jb = Mesh(5)
                End If
                For j = 1 To jb + 1
                    b1 = (j - 1.0) / jb
                    b2 = 1 - b1
                    Npoint = Npoint + 1
                    Xdata(Npoint) = b1 * x1 + b2 * x2
                    Ydata(Npoint) = b1 * y1 + b2 * y2
                    Zdata(Npoint) = b1 * z1 + b2 * z2
                Next j
                If ic = 0 Then
                    ic = 1
                Else
                    ic = 0
                End If
            Next i
        Else
            For k = 1 To 2
                If k = 1 Then
                    i1 = 1
                    i2 = 2 * Mesh(4) + 1
                Else
                    i1 = i2 + 1
                    i2 = i1 + 2 * Mesh(3)
                End If
                ic = 0
                For i = i1 To i2
                    x1 = XR1(i) : x2 = XR2(i)
                    y1 = YR1(i) : y2 = YR2(i)
                    z1 = ZR1(i) : z2 = ZR2(i)
                    If ic = 0 Then
                        jb = 2 * Mesh(5)
                    Else
                        jb = Mesh(5)
                    End If
                    For j = 1 To jb + 1
                        b1 = (j - 1.0) / jb
                        b2 = 1 - b1
                        Npoint = Npoint + 1
                        Xdata(Npoint) = b1 * x1 + b2 * x2
                        Ydata(Npoint) = b1 * y1 + b2 * y2
                        Zdata(Npoint) = b1 * z1 + b2 * z2
                    Next j
                    If ic = 0 Then
                        ic = 1
                    Else
                        ic = 0
                    End If
                Next i
            Next k
        End If

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ii, ix, k, kh As Integer
        Dim b1 As Single

        Call DataSet(kh)    'ﾃﾞｰﾀの設定
        ii = FreeFile()
        FileOpen(ii, Fx$, OpenMode.Output)
        WriteLine(ii, BL(1))
        WriteLine(ii, BL(2))
        WriteLine(ii, Rad(1))
        WriteLine(ii, Rad(2))
        WriteLine(ii, Dia)
        WriteLine(ii, Alpha)
        WriteLine(ii, Beta)
        For k = 1 To 6
            WriteLine(ii, Mesh(k))
        Next k
        FileClose(ii)

        If kh < 0 Then
            Exit Sub
        End If

        Call DataSize()     'ﾃﾞｰﾀｻｲｽﾞの設定
        Call CircleSet()    '横穴の設定
        Call MeshGene()     '要素ﾒｯｼｭの生成

        b1 = BL(1) + BL(2)
        aa$ = "横穴付き円筒（外半径" + LTrim(Str(Rad(2)))
        aa$ = aa$ + "×長さ" + LTrim(Str(b1))
        Title$ = aa$ + "、横穴φ" + LTrim(Str(Dia)) + "）"
        ReDim NumMat(Nelem)
        For i = 1 To Nelem
            NumMat(i) = 1
        Next i
        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6() '立体ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class