'円筒の生成ﾌﾟﾛｸﾞﾗﾑ
Public Class SolDDat11c
    Dim Fx$         'ﾌｧｲﾙ名

    Dim Nelemb As Integer       '断面の要素数
    Dim Npointb As Integer      '断面の節点数
    Dim NPsecStd As Integer     '面の節点数
    Dim Npv As Integer          '断面の頂点節点数
    Dim Ns2 As Integer          '両端面間の総ﾒｯｼｭ数（含中間節点ﾒｯｼｭ）
    Dim NumPstd As Integer      '辺の節点数

    Dim Alpha As Single         '角度α（°）

    Dim Jpoint() As Integer     '節点ﾌﾗｯｸﾞ（0:頂点ﾌﾗｯｸﾞ、1:中間節点）
    Dim Mesh(3) As Integer      'メッシュ数m1～m3
    Dim NLelem(,) As Integer    '左端断面の要素ﾃﾞｰﾀ
    Dim NumNodeV() As Integer   '面内の頂点節点順位

    Dim CosXb(3), CosYb(3) As Single  '断面X,Y軸の全体X,Y,Z軸に対する方向余弦
    Dim Rlen(3) As Single       '長さL,R1,R2
    Dim XL(), YL() As Single    '左端断面における節点座標
    Dim XL1(), YL1() As Single  '左辺の節点座標
    Dim XL2(), YL2() As Single  '右辺の節点座標
    Dim XLdat(), YLdat(), ZLdat() As Single '左端面節点の全体座標

    Private Sub DataSet(ByRef kh As Integer)
        'ﾃﾞｰﾀの設定
        Dim aa$
        Dim i As Integer

        Rlen(1) = Val(TextBox1.Text)
        Rlen(2) = Val(TextBox2.Text)
        Rlen(3) = Val(TextBox3.Text)
        Alpha = Val(TextBox4.Text)
        Mesh(1) = Val(TextBox5.Text)
        Mesh(2) = Val(TextBox6.Text)
        Mesh(3) = Val(TextBox7.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        If Rlen(1) <= 0 Or Rlen(2) <= 0 Or Rlen(3) <= 0 Then
            aa$ = "寸法が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Alpha <= 0 Or Alpha > 360 Then
            aa$ = "角度が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        For i = 1 To 3
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i

    End Sub

    Private Sub DataSizeS()
        '断面のﾃﾞｰﾀｻｲｽﾞの設定
        Dim nb As Integer

        If Alpha < 360 Then
            NumPstd = 2 * Mesh(2) + 1
            NPsecStd = NumPstd * (Mesh(3) + 1) + (Mesh(2) + 1) * Mesh(3)
        Else
            NumPstd = 2 * Mesh(2)
            NPsecStd = NumPstd * (Mesh(3) + 1) + Mesh(2) * Mesh(3)
        End If
        ReDim X(NPsecStd), Y(NPsecStd)
        nb = Mesh(2) * Mesh(3)
        ReDim NNelem(nb, 8)

    End Sub

    Private Sub ElemGene()
        '六面体要素の作成
        Dim ie, ielem, isect, j, jj, nb0, nb1, nb2, nset As Integer
        Dim kbuf(8), kvbuf(8) As Integer
        ielem = 0
        nset = Npointb + Npv
        For isect = 1 To Nsect
            nb0 = nset * (isect - 1)
            nb1 = nb0 + Npointb
            nb2 = nb1 + Npv
            For ie = 1 To Nelemb
                For j = 1 To 8
                    kbuf(j) = NLelem(ie, j)
                    kvbuf(j) = NumNodeV(kbuf(j))
                Next j
                ielem = ielem + 1
                For j = 1 To 8
                    NNelem(ielem, j) = kbuf(j) + nb0
                    NNelem(ielem, j + 12) = kbuf(j) + nb2
                Next j
                For j = 1 To 4
                    jj = 2 * j - 1
                    NNelem(ielem, j + 8) = kvbuf(jj) + nb1
                Next j
            Next ie
        Next isect

    End Sub

    Private Sub ElemGeneS()
        '四角形要素の作成
        Dim i, imax, j, k, n0, n1, nbL, nunit As Integer
        Dim kbuf(8) As Integer

        If Alpha < 360 Then
            imax = Mesh(2)
        Else
            imax = Mesh(2) - 1
        End If

        n0 = 2 * Mesh(3) + 1
        n1 = Mesh(3) + 1
        nunit = n0 + n1
        For i = 1 To imax
            nbL = nunit * (i - 1)
            For j = 1 To Mesh(3)
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0 + j
                kbuf(3) = kbuf(1) + nunit
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                For k = 1 To 8
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
        Next i

        If Alpha = 360 Then
            i = Mesh(2)
            nbL = nunit * (i - 1)
            For j = 1 To Mesh(3)
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0 + j
                kbuf(3) = 2 * j - 1
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                For k = 1 To 8
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
        End If

    End Sub

    Private Sub LeftPlaneCalc1()
        '左端面の座標計算
        Dim ip As Integer

        For ip = 1 To Npointb
            Xmodel(ip) = XL(ip) * CosLX(1) + YL(ip) * CosLY(1) + Xsect(0)
            Ymodel(ip) = XL(ip) * CosLX(2) + YL(ip) * CosLY(2) + Ysect(0)
            Zmodel(ip) = XL(ip) * CosLX(3) + YL(ip) * CosLY(3) + Zsect(0)
        Next ip
        Call SectStore(0, Npointb)  '断面の座標データ保存

    End Sub

    Private Sub LeftPlaneData1()
        '左端断面のﾃﾞｰﾀ設定
        Dim ie, ip, j As Integer
        ReDim Jpoint(Npoint), NumNodeV(Npoint)
        ReDim NLelem(Nelem, 8), XL(Npoint), YL(Npoint)
        ReDim XLdat(Npoint), YLdat(Npoint), ZLdat(Npoint)
        ReDim Xmodel(Npoint), Ymodel(Npoint), Zmodel(Npoint)

        Ns2 = 2 * Nsect
        For ie = 1 To Nelem
            For j = 1 To 8
                NLelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie
        For ip = 1 To Npoint
            XL(ip) = X(ip)
            YL(ip) = Y(ip)
        Next ip
        Nelemb = Nelem
        Npointb = Npoint

    End Sub

    Private Sub MeshGeneS()
        '断面のﾒｯｼｭ生成
        Dim kround As Integer
        ReDim XL1(NumPstd), YL1(NumPstd)
        ReDim XL2(NumPstd), YL2(NumPstd)

        Nelem = 0
        Npoint = 0

        Call PlaneLine()   '面の両辺のﾒｯｼｭ計算
        Call PlaneSect()   '面の節点計算

        Call ElemGeneS() '四角形要素の作成

        If Alpha = 360 Then
            kround = 1
        Else
            kround = 0
        End If
        Call ReNumberEP(1, kround, Mesh(2), Mesh(3))  '要素･節点番号の付番改良

        KindSect = 0
        KindConnect = 0
        Nsect = Mesh(1)

        Ns2 = 2 * Nsect
        ReDim Xsect(Ns2), Ysect(Ns2), Zsect(Ns2)
        CosLX(1) = 0 : CosLX(2) = -1 : CosLX(3) = 0
        CosLY(1) = 0 : CosLY(2) = 0 : CosLY(3) = 1

        Xsect(0) = 0 : Ysect(0) = 0 : Zsect(0) = 0
        Xsect(Ns2) = Rlen(1) : Ysect(Ns2) = 0 : Zsect(Ns2) = 0

    End Sub

    Private Sub MeshPlaneCalc()
        '各ﾒｯｼｭ面の座標計算2
        Dim ic, ii, imax, ip, isect, j, kcos, nb, nn As Integer
        Dim b1, b2, b3, cosb, sinb As Single
        Dim xb, yb As Single
        Dim buf(3) As Single
        Dim thetaXBL(3), thetaXBR(3), thetaYBL(3), thetaYBR(3) As Single

        imax = Ns2 - 1
        b1 = Ns2
        kcos = 0     '両端面の方向余弦が同一に仮設定

        ic = 1  'ﾒｯｼｭ面区分（0:主ﾒｯｼｭ面、1:中間ﾒｯｼｭ面）
        nn = Npointb
        If KindConnect = 0 Then     '両端面の直線接続の場合
            For isect = 1 To imax
                b2 = isect / b1
                b3 = 1 - b2
                Xsect(isect) = b3 * Xsect(0) + b2 * Xsect(Ns2)
                Ysect(isect) = b3 * Ysect(0) + b2 * Ysect(Ns2)
                Zsect(isect) = b3 * Zsect(0) + b2 * Zsect(Ns2)
            Next isect
        End If
        cosb = 1
        sinb = 0
        For isect = 1 To Ns2
            b2 = isect / b1
            b3 = 1 - b2
            For j = 1 To 3
                CosXb(j) = CosLX(j)
                CosYb(j) = CosLY(j)
            Next j

            If ic = 0 Then  '主ﾒｯｼｭ面の場合
                nb = Npointb
                For ip = 1 To Npointb
                    xb = XL(ip) * cosb - YL(ip) * sinb
                    yb = XL(ip) * sinb + YL(ip) * cosb
                    For j = 1 To 3
                        buf(j) = xb * CosXb(j) + yb * CosYb(j)
                    Next j
                    Xmodel(ip) = buf(1) + Xsect(isect)
                    Ymodel(ip) = buf(2) + Ysect(isect)
                    Zmodel(ip) = buf(3) + Zsect(isect)
                Next ip
            Else    '中間ﾒｯｼｭ面の場合
                nb = Npv
                ii = 0
                For ip = 1 To Npointb
                    If Jpoint(ip) = 0 Then
                        ii = ii + 1
                        xb = XL(ip) * cosb - YL(ip) * sinb
                        yb = XL(ip) * sinb + YL(ip) * cosb
                        For j = 1 To 3
                            buf(j) = xb * CosXb(j) + yb * CosYb(j)
                        Next j
                        Xmodel(ii) = buf(1) + Xsect(isect)
                        Ymodel(ii) = buf(2) + Ysect(isect)
                        Zmodel(ii) = buf(3) + Zsect(isect)
                    End If
                Next ip
            End If
            Call SectStore(nn, nb)  '断面の座標データ保存
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
            nn = nn + nb
        Next isect

    End Sub

    Private Sub NodeCount1()
        '面内の節点のﾁｪｯｸ
        Dim ib, ie, ip, j, nb As Integer
        Dim kbuf(Npointb) As Integer

        Npv = 0
        For ie = 1 To Nelemb
            For j = 1 To 7 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    Npv = Npv + 1
                    kbuf(ib) = 1
                    Jpoint(ib) = 0
                End If
            Next j
            For j = 2 To 8 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    kbuf(ib) = 1
                    Jpoint(ib) = 1
                End If
            Next j
        Next ie
        nb = 0
        For ip = 1 To Npointb
            If Jpoint(ip) = 0 Then
                nb = nb + 1
                NumNodeV(ip) = nb
            End If
        Next ip

    End Sub

    Private Sub PlaneLine()
        '面の両辺のﾒｯｼｭ計算
        Dim i, imax, mb, nb As Integer
        Dim angle, b1, b2, cosb, sinb, theta, xb, yb As Single

        mb = 2 * Mesh(2)
        If Alpha < 360 Then
            angle = Alpha * Pai / 180
            imax = mb + 1
        Else
            angle = Dpai
            imax = mb
        End If

        nb = 0
        For i = 1 To imax
            b2 = (i - 1.0) / mb
            b1 = 1 - b2
            theta = angle * b2
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            xb = Rlen(2) * cosb
            yb = Rlen(2) * sinb
            nb = nb + 1
            XL1(nb) = xb
            YL1(nb) = yb
            xb = Rlen(3) * cosb
            yb = Rlen(3) * sinb
            XL2(nb) = xb
            YL2(nb) = yb
        Next i

    End Sub

    Private Sub PlaneSect()
        '面の節点計算
        Dim i, ic, imax, j, jb, mb As Integer
        Dim b1, b2, x1, x2, y1, y2 As Single

        mb = 2 * Mesh(2)
        If Alpha < 360 Then
            imax = mb + 1
        Else
            imax = mb
        End If

        ic = 0
        For i = 1 To imax
            x1 = XL1(i) : x2 = XL2(i)
            y1 = YL1(i) : y2 = YL2(i)
            If ic = 0 Then
                jb = 2 * Mesh(3)
            Else
                jb = Mesh(3)
            End If
            For j = 1 To jb + 1
                b1 = (j - 1.0) / jb
                b2 = 1 - b1
                Npoint = Npoint + 1
                X(Npoint) = b1 * x1 + b2 * x2
                Y(Npoint) = b1 * y1 + b2 * y2
            Next j
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
        Next i

    End Sub

    Private Sub SectStore(ByVal ib As Integer, ByVal nb As Integer)
        '断面の座標データ保存
        'ib･･･ﾍﾞｰｽ節点数
        'nb･･･節点数
        Dim ii, ip As Integer
        For ip = 1 To nb
            ii = ib + ip
            Xdata(ii) = Xmodel(ip)
            Ydata(ii) = Ymodel(ip)
            Zdata(ii) = Zmodel(ip)
        Next ip

    End Sub

    Private Sub SolDDat11c_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim icc, ii, k As Integer

        Fx$ = DirOpen$ + "\SolDDat11c.tmp"
        Try
            ii = FreeFile()
            FileOpen(ii, Fx$, OpenMode.Input)
            icc = 1
            For k = 1 To 3
                Input(ii, Rlen(k))
            Next k
            Input(ii, Alpha)
            Input(ii, Mesh(1))
            Input(ii, Mesh(2))
            Input(ii, Mesh(3))
        Catch
            '処理不要
        End Try
        If icc > 0 Then
            FileClose(ii)
        End If

        TextBox1.Text = Str(Rlen(1))
        TextBox2.Text = Str(Rlen(2))
        TextBox3.Text = Str(Rlen(3))
        TextBox4.Text = Str(Alpha)
        TextBox5.Text = Str(Mesh(1))
        TextBox6.Text = Str(Mesh(2))
        TextBox7.Text = Str(Mesh(3))

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ii, ix, k, kh As Integer

        Call DataSet(kh)    'ﾃﾞｰﾀの設定
        ii = FreeFile()
        FileOpen(ii, Fx$, OpenMode.Output)
        For k = 1 To 3
            WriteLine(ii, Rlen(k))
        Next k
        WriteLine(ii, Alpha)
        WriteLine(ii, Mesh(1))
        WriteLine(ii, Mesh(2))
        WriteLine(ii, Mesh(3))
        FileClose(ii)

        If kh < 0 Then
            Exit Sub
        End If

        Call DataSizeS()    '断面のﾃﾞｰﾀｻｲｽﾞの設定

        Call MeshGeneS()    '断面のﾒｯｼｭ生成

        Call LeftPlaneData1() '左端断面のﾃﾞｰﾀ設定

        Nelem = Nelemb * Nsect
        Call NodeCount1() '面内の節点のﾁｪｯｸ

        Npoint = Npointb * (Nsect + 1) + Npv * Nsect
        ReDim NNelem(Nelem, 20), NumMat(Nelem)
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)

        Call LeftPlaneCalc1() '左端面の座標計算

        Call MeshPlaneCalc() '各ﾒｯｼｭ面の座標計算
        Call ElemGene()     '六面体要素の作成

        aa$ = "円筒（外半径" + LTrim(Str(Rlen(3)))
        Title$ = aa$ + "×長さ" + LTrim(Str(Rlen(1))) + "）"
        Call DfilePrepA()   '構造ﾃﾞｰﾀﾌｧｲﾙ保存の前処理

        ReDim NumMat(Nelem)
        For i = 1 To Nelem
            NumMat(i) = 1
        Next i
        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6() '立体ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class