'横穴付き円柱の生成ﾌﾟﾛｸﾞﾗﾑ

Public Class SolDDat11d
    Dim Fx$         'ﾌｧｲﾙ名

    Dim NPbaseL As Integer  '左面の節点ベース数
    Dim NPbaseL2 As Integer '左面後半の節点ベース数
    Dim NPbaseM As Integer  '中間面の節点ベース数
    Dim NPbaseM2 As Integer '中間面後半の節点ベース数
    Dim NPbaseR As Integer  '右面の節点ベース数
    Dim NPbaseR2 As Integer '右面後半の節点ベース数
    Dim NPsecStd As Integer '基準面の節点数
    Dim NPsecStM As Integer '基準中間面の節点数
    Dim NumCirc As Integer  '横穴の節点数
    Dim NumPstd As Integer  '基準面の周の節点数
    Dim NumPstM As Integer  '基準中間面の周の節点数
    Dim NumQ As Integer     '横穴分割数／４

    Dim Alpha As Single     '上部角度α（°）
    Dim Beta As Single      '下部角度β（°）
    Dim Dia As Single       '横穴の直径
    Dim RadC As Single      '円柱の半径R

    Dim Kcirc(2) As Integer '下上境界点の横穴メッシュ番号
    Dim Mesh(6) As Integer  'メッシュ数m1～m6

    Dim BL(2) As Single     '円柱長さb1,b2
    Dim XcircIn(), YcircIn(), ZcircIn() As Single       '内周の横穴の座標
    Dim XcircOut(), YcircOut(), ZcircOut() As Single    '外周の横穴の座標
    Dim XM2(), YM2(), ZM2() As Single   '中間面外周の節点座標
    Dim XR2(), YR2(), ZR2() As Single   '右面内周の節点座標

    Private Sub CircleSet()
        '横穴の設定
        Dim i As Integer
        Dim b1, b2, b3, c0, dist, h, rb As Single
        Dim cotb(2) As Single

        c0 = Pai / 180
        cotb(1) = 1 / Math.Tan(c0 * Alpha)
        cotb(2) = 1 / Math.Tan(c0 * Beta)

        NumCirc = 2 * Mesh(6)
        ReDim XcircIn(NumCirc), YcircIn(NumCirc), ZcircIn(NumCirc)
        ReDim XcircOut(NumCirc), YcircOut(NumCirc), ZcircOut(NumCirc)
        rb = 0.5 * Dia
        For i = 1 To NumCirc
            b1 = Dpai * (i - 1) / NumCirc
            b2 = rb * Math.Cos(b1)
            h = rb * Math.Sin(b1)
            dist = Math.Sqrt(RadC * RadC - h * h)
            YcircOut(i) = -dist
            XcircOut(i) = BL(1) + b2
            ZcircOut(i) = h
            b3 = Math.Abs(b1 - Pai)
            If b1 = 0 Or b3 < 0.001 Then
                dist = RadC
            ElseIf h > 0 Then
                dist = Math.Abs(h * cotb(1))
            Else
                dist = Math.Abs(h * cotb(2))
            End If
            If YcircOut(i) < 0 Then
                dist = -dist
            End If
            YcircIn(i) = dist
            XcircIn(i) = XcircOut(i)
            ZcircIn(i) = ZcircOut(i)
        Next i

    End Sub

    Private Sub DataSet(ByRef kh As Integer)
        'ﾃﾞｰﾀの設定
        Dim aa$
        Dim i, ic As Integer
        Dim b1, b2, b3, c0 As Single

        BL(1) = Val(TextBox1.Text)
        BL(2) = Val(TextBox2.Text)
        RadC = Val(TextBox3.Text)
        Dia = Val(TextBox5.Text)
        Alpha = Val(TextBox6.Text)
        Beta = Val(TextBox7.Text)
        Mesh(1) = Val(TextBox8.Text)
        Mesh(2) = Val(TextBox9.Text)
        Mesh(3) = Val(TextBox10.Text)
        Mesh(4) = Val(TextBox11.Text)
        Mesh(5) = Val(TextBox12.Text)
        Mesh(6) = Val(TextBox13.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        If BL(1) <= 0 Or BL(2) <= 0 Then
            aa$ = "円柱の長さが間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If RadC <= 0 Then
            aa$ = "円柱の半径が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Dia <= 0 Then
            aa$ = "横穴の直径が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Alpha <= 0 Or Beta <= 0 Then
            aa$ = "上下部の角度が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Alpha > 180 Or Beta > 180 Then
            aa$ = "上下部の角度の和が180°を超えています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        NumQ = Mesh(6) / 4
        For i = 1 To 6
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
            If i = 3 Or i = 4 Then
                If Mesh(i) <= NumQ Then
                    aa$ = "上下部角度の分割数が少な過ぎます！"
                    MsgBox(aa$, 0, "データエラー")
                    kh = -1
                    Exit Sub
                End If
                ic = Mesh(i) Mod 2
                If ic > 0 Then
                    aa$ = "上下部角度の分割数が間違っています！"
                    MsgBox(aa$, 0, "データエラー")
                    kh = -1
                    Exit Sub
                End If
            End If
        Next i
        ic = Mesh(6) Mod 4
        If ic > 0 Then
            aa$ = "横穴の分割数m6が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Mesh(1) <= NumQ Or Mesh(2) <= NumQ Then
            aa$ = "円筒長さの分割数が少な過ぎます！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If

        c0 = Pai / 180
        b1 = RadC * Math.Sin(Alpha * c0)
        b2 = RadC * Math.Sin(Beta * c0)
        b3 = 0.6 * Dia
        If Math.Abs(b1) < b3 Or Math.Abs(b2) < b3 Then
            aa$ = "横穴直径が大き過ぎます！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If

    End Sub

    Private Sub DataSize()
        'ﾃﾞｰﾀｻｲｽﾞの設定
        Dim mb, nb As Integer

        NumPstM = Mesh(3) + Mesh(4) + 1
        NumPstd = 2 * (Mesh(3) + Mesh(4)) + 1
        NPsecStd = NumPstd * (Mesh(5) + 1) + NumPstM * Mesh(5)
        NPsecStM = NumPstM * (Mesh(5) + 1)
        mb = Mesh(1) + Mesh(2)
        nb = (NPsecStd + NumPstd) * (mb + 1) + (NPsecStM + NumPstM) * mb
        ReDim Xdata(nb), Ydata(nb), Zdata(nb)
        nb = (Mesh(3) + Mesh(4)) * Mesh(5) * mb
        ReDim NNelem(nb, 20)

    End Sub

    Private Sub SolDDat11d_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim icc, ii, k As Integer

        Fx$ = DirOpen$ + "\SolDDat11d.tmp"
        Try
            ii = FreeFile()
            FileOpen(ii, Fx$, OpenMode.Input)
            icc = 1
            Input(ii, BL(1))
            Input(ii, BL(2))
            Input(ii, RadC)
            Input(ii, Dia)
            Input(ii, Alpha)
            Input(ii, Beta)
            For k = 1 To 6
                Input(ii, Mesh(k))
            Next k
        Catch
            '処理不要
        End Try
        If icc > 0 Then
            FileClose(ii)
        End If

        TextBox1.Text = Str(BL(1))
        TextBox2.Text = Str(BL(2))
        TextBox3.Text = Str(RadC)
        TextBox5.Text = Str(Dia)
        TextBox6.Text = Str(Alpha)
        TextBox7.Text = Str(Beta)
        TextBox8.Text = Str(Mesh(1))
        TextBox9.Text = Str(Mesh(2))
        TextBox10.Text = Str(Mesh(3))
        TextBox11.Text = Str(Mesh(4))
        TextBox12.Text = Str(Mesh(5))
        TextBox13.Text = Str(Mesh(6))

    End Sub

    Private Sub Debug1()
        '右面の周囲線のﾒｯｼｭ点を出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\SolDDat11d-debug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜右面外周のメッシュ点＞"
        WriteLine(ii, aa$)
        aa$ = "点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = 1 To NumPstd
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(XR2(i))
            aa$ = aa$ + "," + Str$(YR2(i))
            aa$ = aa$ + "," + Str$(ZR2(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug2()
        '中間面と右面の周囲線のﾒｯｼｭ点を出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\SolDDat11d-debug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜中間面外周のメッシュ点＞"
        WriteLine(ii, aa$)
        aa$ = "点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = 1 To NumPstM
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(XM2(i))
            aa$ = aa$ + "," + Str$(YM2(i))
            aa$ = aa$ + "," + Str$(ZM2(i))
            PrintLine(ii, aa$)
        Next i
        aa$ = "＜右面外周のメッシュ点＞"
        WriteLine(ii, aa$)
        aa$ = "点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = 1 To NumPstd
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(XR2(i))
            aa$ = aa$ + "," + Str$(YR2(i))
            aa$ = aa$ + "," + Str$(ZR2(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug3()
        '中間面と右面の節点を出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\SolDDat11d-debug3.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜中間面の節点＞"
        WriteLine(ii, aa$)
        aa$ = "節点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = NPbaseM + 1 To NPbaseR
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(Xdata(i))
            aa$ = aa$ + "," + Str$(Ydata(i))
            aa$ = aa$ + "," + Str$(Zdata(i))
            PrintLine(ii, aa$)
        Next i
        aa$ = "＜右面の節点＞"
        WriteLine(ii, aa$)
        aa$ = "節点番号、Ｘ、Ｙ、Ｚ"
        WriteLine(ii, aa$)
        For i = NPbaseR + 1 To Npoint
            aa$ = Str$(i)
            aa$ = aa$ + "," + Str$(Xdata(i))
            aa$ = aa$ + "," + Str$(Ydata(i))
            aa$ = aa$ + "," + Str$(Zdata(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub ElemGene(ByVal kind As Integer)
        '六面体要素の作成
        'kind･･･種別（0:基本、1:左面のみ基本、2:各面とも上下分離有り、3:右面のみ基本）
        Dim i, ib, j, k, kcentL, kcentM, kcentR, ks, n0, n0c, n0x, n1, n1m, n1x As Integer
        Dim nbL, nbLb, nbM, nbMb, nbR, nbRb, nunit, nunitc, nunitx As Integer
        Dim kbuf(20) As Integer

        n0 = 2 * Mesh(5)
        n0c = n0 + 2
        n1 = Mesh(5)
        n1m = n1 + 1
        nunit = n0 + n1
        nunitc = n0c + n1
        ks = 0
        For i = 1 To Mesh(4)
            ib = Int((i - 1) / 2)
            nbL = NPbaseL + 1 + (nunit + nunitc) * ib
            nbM = NPbaseM + 1 + (n1 + n1m) * ib
            nbR = NPbaseR + 1 + (nunit + nunitc) * ib
            If ks = 0 Then
                n0x = n0
                n1x = n1
                nunitx = nunit
            Else
                nbL = nbL + nunit
                nbM = nbM + n1
                nbR = nbR + nunit
                n0x = n0c
                n1x = n1m
                nunitx = nunitc
            End If
            For j = 1 To Mesh(5) - 1
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1x
                kbuf(11) = kbuf(10) + 1
                kbuf(12) = kbuf(9) + 1
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0x + j
                kbuf(15) = kbuf(13) + nunitx
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = kbuf(16) + 1
                kbuf(18) = kbuf(14) + 1
                kbuf(19) = kbuf(13) + 2
                kbuf(20) = kbuf(13) + 1
                For k = 1 To 20
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
            j = Mesh(5)
            Nelem = Nelem + 1
            If ks = 0 Then
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(5) + 1
                kbuf(7) = NPbaseL + 1
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1x
                kbuf(11) = kbuf(10) + 1
                kbuf(12) = NPbaseM + 1
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0x + j
                kbuf(15) = kbuf(13) + nunitx
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = kbuf(16) + 1
                kbuf(18) = kbuf(17) + 1
                kbuf(19) = NPbaseR + 1
                kbuf(20) = kbuf(13) + 1
            Else
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = NPbaseL + 1
                kbuf(6) = kbuf(1) + 3
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1x
                kbuf(11) = NPbaseM + 1
                kbuf(12) = kbuf(9) + 1
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0x + j
                kbuf(15) = kbuf(13) + nunitx
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = NPbaseR + 1
                kbuf(18) = kbuf(13) + 3
                kbuf(19) = kbuf(13) + 2
                kbuf(20) = kbuf(13) + 1
            End If
            For k = 1 To 20
                NNelem(Nelem, k) = kbuf(k)
            Next k
            If ks = 0 Then
                ks = 1
            Else
                ks = 0
            End If
        Next i

        Select Case kind
            Case 0
                kcentL = NPbaseL + 1
                kcentM = NPbaseM + 1
                kcentR = NPbaseR + 1
                nbLb = NPbaseL2
                nbMb = NPbaseM2
                nbRb = NPbaseR2
            Case 1
                kcentL = NPbaseL + 1
                kcentM = NPbaseM2 + 1
                kcentR = NPbaseR2 + 1
                nbLb = NPbaseL2
                nbMb = NPbaseM2 + 1
                nbRb = NPbaseR2 + 1
            Case 2
                kcentL = NPbaseL2 + 1
                kcentM = NPbaseM2 + 1
                kcentR = NPbaseR2 + 1
                nbLb = NPbaseL2 + 1
                nbMb = NPbaseM2 + 1
                nbRb = NPbaseR2 + 1
            Case 3
                kcentL = NPbaseL2 + 1
                kcentM = NPbaseM2 + 1
                kcentR = NPbaseR + 1
                nbLb = NPbaseL2 + 1
                nbMb = NPbaseM2 + 1
                nbRb = NPbaseR2
        End Select
        ks = 0
        For i = 1 To Mesh(3)
            ib = Int((i - 1) / 2)
            nbL = nbLb + (nunit + nunitc) * ib
            nbM = nbMb + (n1 + n1m) * ib
            nbR = nbRb + (nunit + nunitc) * ib
            If ks = 0 Then
                n0x = n0
                n1x = n1
                nunitx = nunit
            Else
                nbL = nbL + nunit
                nbM = nbM + n1
                nbR = nbR + nunit
                n0x = n0c
                n1x = n1m
                nunitx = nunitc
            End If
            For j = 1 To Mesh(5) - 1
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1x
                kbuf(11) = kbuf(10) + 1
                kbuf(12) = kbuf(9) + 1
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0x + j
                kbuf(15) = kbuf(13) + nunitx
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = kbuf(16) + 1
                kbuf(18) = kbuf(14) + 1
                kbuf(19) = kbuf(13) + 2
                kbuf(20) = kbuf(13) + 1
                For k = 1 To 20
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
            j = Mesh(5)
            Nelem = Nelem + 1
            If ks = 0 Then
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(5) + 1
                kbuf(7) = kcentL
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1x
                kbuf(11) = kbuf(10) + 1
                kbuf(12) = kcentM
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0x + j
                kbuf(15) = kbuf(13) + nunitx
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = kbuf(16) + 1
                kbuf(18) = kbuf(17) + 1
                kbuf(19) = kcentR
                kbuf(20) = kbuf(13) + 1
            Else
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kcentL
                kbuf(6) = kbuf(1) + 3
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1x
                kbuf(11) = kcentM
                kbuf(12) = kbuf(9) + 1
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0x + j
                kbuf(15) = kbuf(13) + nunitx
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = kcentR
                kbuf(18) = kbuf(13) + 3
                kbuf(19) = kbuf(13) + 2
                kbuf(20) = kbuf(13) + 1
            End If
            For k = 1 To 20
                NNelem(Nelem, k) = kbuf(k)
            Next k
            If ks = 0 Then
                ks = 1
            Else
                ks = 0
            End If
        Next i

    End Sub

    Private Sub MeshGene()
        '要素ﾒｯｼｭの生成
        Dim i, i2, ib, j, kcs, kce, kind, mb, meshb As Integer
        Dim b1, b2, rlen, xmm, xsM, xsR, zmm As Single

        ReDim XR2(NumPstd + 1), YR2(NumPstd + 1), ZR2(NumPstd + 1)
        ReDim XM2(NumPstM + 1), YM2(NumPstM + 1), ZM2(NumPstM + 1)

        kcs = Mesh(1) - NumQ + 1
        kce = Mesh(1) + NumQ + 1
        Nelem = 0
        Npoint = 0
        meshb = Mesh(1) + Mesh(2)
        rlen = BL(1) + BL(2)

        i2 = meshb     '正規
        'i2 = 3        'テスト

        For i = 1 To i2
            xsR = rlen * i / meshb
            xsM = 0.5 * rlen * (2 * i - 1) / meshb

            '左面の設定
            If i = 1 Then
                Call RPlaneLine(kind, 0, 0, 0)   '右面の周囲線のﾒｯｼｭ計算
                Call RPlaneSect(kind, 0)   '右面の節点計算
            End If
            NPbaseL = NPbaseR
            NPbaseL2 = NPbaseR2

            '中間面の設定
            If i < kcs Then
                b1 = BL(1) - 0.5 * Dia
                b2 = b1 / (kcs - 1) / 2
                xmm = (2 * i - 1) * b2
                zmm = 0
                kind = 0
            ElseIf kcs <= i And i < kce Then
                ib = i - kcs
                mb = Mesh(6) / 2 - ib
                ib = 2 * mb
                xmm = XcircOut(ib)
                zmm = ZcircOut(ib)
                kind = 1
                Kcirc(2) = ib
                mb = Mesh(6) + 1
                j = mb - ib
                Kcirc(1) = mb + j
            Else
                b1 = BL(1) + 0.5 * Dia
                b2 = (rlen - b1) / (meshb + 1 - kce) / 2
                xmm = b1 + (2 * (i - kce) + 1) * b2
                zmm = 0
                kind = 0
            End If
            Call MPlaneLine(kind, xsM, xmm, zmm)   '中間面の周囲線のﾒｯｼｭ計算
            Call MPlaneSect(kind, xmm)   '中間面の節点計算

            '右面の設定
            If i < kcs Then
                b1 = BL(1) - 0.5 * Dia
                b2 = b1 / (kcs - 1)
                xmm = i * b2
                zmm = 0
                kind = 0
            ElseIf kcs <= i And i + 1 < kce Then
                ib = i - kcs
                mb = Mesh(6) / 2 - ib
                ib = 2 * mb - 1
                xmm = XcircOut(ib)
                zmm = ZcircOut(ib)
                kind = 1
                Kcirc(2) = ib
                mb = Mesh(6) + 1
                j = mb - ib
                Kcirc(1) = mb + j
            Else
                b1 = BL(1) + 0.5 * Dia
                b2 = (rlen - b1) / (meshb + 1 - kce)
                xmm = b1 + (i - kce + 1) * b2
                zmm = 0
                kind = 0
            End If
            Call RPlaneLine(kind, xsR, xmm, zmm)   '右面の周囲線のﾒｯｼｭ計算
            Call RPlaneSect(kind, xmm)   '右面の節点計算

            If i < kcs Or kce <= i Then
                kind = 0
            ElseIf i = kcs Then
                kind = 1
            ElseIf i + 1 < kce Then
                kind = 2
            Else
                kind = 3
            End If

            Call ElemGene(kind) '六面体要素の作成

        Next i

    End Sub

    Private Sub MPlaneLine(ByVal kind As Integer, ByVal xsM As Single, _
        ByVal xmm As Single, ByVal zmm As Single)
        '中間面の周囲線のﾒｯｼｭ計算
        'kind･･･上下分離の有無（0:なし、1:有り）
        'xsM･･･基準X座標
        'xmm･･･上下境界点のX座標
        'zmm･･･上下境界点のZ座標（絶対値）
        Dim i, i1, mb, nb As Integer
        Dim b1, b2, c0, cosb, sinb, xb, yb, zb, theta, thetam As Single

        c0 = Pai / 180
        If kind = 0 Then
            thetam = 0
        Else
            thetam = Math.Asin(zmm / RadC)
        End If
        mb = Mesh(4)
        nb = 0
        For i = 0 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            xb = b1 * xsM + b2 * xmm
            nb = nb + 1
            theta = -(b1 * Beta * c0 + b2 * thetam)
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -RadC * cosb
            zb = RadC * sinb
            XM2(nb) = xb
            YM2(nb) = yb
            ZM2(nb) = zb
        Next i
        mb = Mesh(3)
        If kind = 0 Then
            i1 = 1
        Else
            i1 = 0
        End If
        For i = i1 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            xb = b2 * xsM + b1 * xmm
            nb = nb + 1
            theta = b2 * Alpha * c0 + b1 * thetam
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -RadC * cosb
            zb = RadC * sinb
            XM2(nb) = xb
            YM2(nb) = yb
            ZM2(nb) = zb
        Next i

    End Sub

    Private Sub MPlaneSect(ByVal kind As Integer, ByVal xmm As Single)
        '中間面の節点計算
        'kind･･･上下分離の有無（0:なし、1:有り）
        'xmm･･･上下境界点のX座標
        Dim i, i1, i2, imax, j, k, ks As Integer
        Dim b1, b2, x1, x2, y1, y2, z1, z2 As Single

        NPbaseM = Npoint
        If kind = 0 Then
            imax = Mesh(3) + Mesh(4) + 1
            i1 = Mesh(4) + 1
            Npoint = Npoint + 1
            Xdata(Npoint) = xmm
            Ydata(Npoint) = 0
            Zdata(Npoint) = 0
            ks = 0
            For i = 1 To imax
                If i = i1 Then
                    NPbaseM2 = Npoint
                End If
                x1 = xmm : x2 = XM2(i)
                y2 = YM2(i)
                z2 = ZM2(i)
                For j = 1 To Mesh(5)
                    b1 = (j - 1.0) / Mesh(5)
                    b2 = 1 - b1
                    Npoint = Npoint + 1
                    Xdata(Npoint) = b1 * x1 + b2 * x2
                    Ydata(Npoint) = b2 * y2
                    Zdata(Npoint) = b2 * z2
                Next j
                If ks = 0 Then
                    ks = 1
                Else
                    b1 = (Mesh(5) - 0.5) / Mesh(5)
                    b2 = 1 - b1
                    Npoint = Npoint + 1
                    Xdata(Npoint) = b1 * x1 + b2 * x2
                    Ydata(Npoint) = b2 * y2
                    Zdata(Npoint) = b2 * z2
                    ks = 0
                End If
            Next i
        Else
            For k = 1 To 2
                If k = 1 Then
                    i1 = 1
                    i2 = Mesh(4) + 1
                Else
                    NPbaseM2 = Npoint
                    i1 = i2 + 1
                    i2 = i1 + Mesh(3)
                End If
                x1 = xmm
                y1 = YcircIn(Kcirc(k))
                z1 = ZcircIn(Kcirc(k))
                Npoint = Npoint + 1
                Xdata(Npoint) = x1
                Ydata(Npoint) = y1
                Zdata(Npoint) = z1
                ks = 0
                For i = i1 To i2
                    x2 = XM2(i)
                    y2 = YM2(i)
                    z2 = ZM2(i)
                    For j = 1 To Mesh(5)
                        b1 = (j - 1.0) / Mesh(5)
                        b2 = 1 - b1
                        Npoint = Npoint + 1
                        Xdata(Npoint) = b1 * x1 + b2 * x2
                        Ydata(Npoint) = b1 * y1 + b2 * y2
                        Zdata(Npoint) = b1 * z1 + b2 * z2
                    Next j
                    If ks = 0 Then
                        ks = 1
                    Else
                        Npoint = Npoint + 1
                        Xdata(Npoint) = 0.5 * (x1 + Xdata(Npoint - 1))
                        Ydata(Npoint) = 0.5 * (y1 + Ydata(Npoint - 1))
                        Zdata(Npoint) = 0.5 * (z1 + Zdata(Npoint - 1))
                        ks = 0
                    End If
                Next i
            Next k
        End If

    End Sub

    Private Sub RPlaneLine(ByVal kind As Integer, ByVal xsR As Single, _
        ByVal xmm As Single, ByVal zmm As Single)
        '右面の周囲線のﾒｯｼｭ計算
        'kind･･･上下分離の有無（0:なし、1:有り）
        'xsR･･･基準X座標
        'xmm･･･上下境界点のX座標
        'zmm･･･上下境界点のZ座標（絶対値）
        Dim i, i1, mb, nb As Integer
        Dim b1, b2, c0, cosb, sinb, xb, yb, zb, theta, thetam As Single

        c0 = Pai / 180
        If kind = 0 Then
            thetam = 0
        Else
            thetam = Math.Asin(zmm / RadC)
        End If
        mb = 2 * Mesh(4)
        nb = 0
        For i = 0 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            xb = b1 * xsR + b2 * xmm
            nb = nb + 1
            theta = -(b1 * Beta * c0 + b2 * thetam)
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -RadC * cosb
            zb = RadC * sinb
            XR2(nb) = xb
            YR2(nb) = yb
            ZR2(nb) = zb
        Next i
        mb = 2 * Mesh(3)
        If kind = 0 Then
            i1 = 1
        Else
            i1 = 0
        End If
        For i = i1 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            xb = b2 * xsR + b1 * xmm
            nb = nb + 1
            theta = b2 * Alpha * c0 + b1 * thetam
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            yb = -RadC * cosb
            zb = RadC * sinb
            XR2(nb) = xb
            YR2(nb) = yb
            ZR2(nb) = zb
        Next i

    End Sub

    Private Sub RPlaneSect(ByVal kind As Integer, ByVal xmm As Single)
        '右面の節点計算
        'kind･･･上下分離の有無（0:なし、1:有り）
        'xmm･･･上下境界点のX座標
        Dim i, i1, i2, ic, imax, j, jb, k, ks As Integer
        Dim b1, b2, x1, x2, y1, y2, z1, z2 As Single

        NPbaseR = Npoint
        If kind = 0 Then
            imax = 2 * (Mesh(3) + Mesh(4)) + 1
            i1 = 2 * Mesh(4) + 1
            Npoint = Npoint + 1
            Xdata(Npoint) = xmm
            Ydata(Npoint) = 0
            Zdata(Npoint) = 0
            ic = 0
            ks = 0
            For i = 1 To imax
                If i = i1 Then
                    NPbaseR2 = Npoint
                End If
                x1 = xmm : x2 = XR2(i)
                y2 = YR2(i)
                z2 = ZR2(i)
                If ic = 0 Then
                    jb = 2 * Mesh(5)
                Else
                    jb = Mesh(5)
                End If
                For j = 1 To jb
                    b1 = (j - 1.0) / jb
                    b2 = 1 - b1
                    Npoint = Npoint + 1
                    Xdata(Npoint) = b1 * x1 + b2 * x2
                    Ydata(Npoint) = b2 * y2
                    Zdata(Npoint) = b2 * z2
                Next j
                If ic = 0 Then
                    If ks = 0 Then
                        ks = 1
                    Else
                        Xdata(Npoint + 1) = Xdata(Npoint)
                        Ydata(Npoint + 1) = Ydata(Npoint)
                        Zdata(Npoint + 1) = Zdata(Npoint)
                        Xdata(Npoint) = 0.5 * (Xdata(Npoint) + Xdata(Npoint - 1))
                        Ydata(Npoint) = 0.5 * (Ydata(Npoint) + Ydata(Npoint - 1))
                        Zdata(Npoint) = 0.5 * (Zdata(Npoint) + Zdata(Npoint - 1))
                        Npoint = Npoint + 2
                        Xdata(Npoint) = 0.5 * (xmm + Xdata(Npoint - 1))
                        Ydata(Npoint) = 0.5 * Ydata(Npoint - 1)
                        Zdata(Npoint) = 0.5 * Zdata(Npoint - 1)
                        ks = 0
                    End If
                    ic = 1
                Else
                    ic = 0
                End If
            Next i
        Else
            For k = 1 To 2
                If k = 1 Then
                    i1 = 1
                    i2 = 2 * Mesh(4) + 1
                Else
                    NPbaseR2 = Npoint
                    i1 = i2 + 1
                    i2 = i1 + 2 * Mesh(3)
                End If
                x1 = xmm
                y1 = YcircIn(Kcirc(k))
                z1 = ZcircIn(Kcirc(k))
                Npoint = Npoint + 1
                Xdata(Npoint) = x1
                Ydata(Npoint) = y1
                Zdata(Npoint) = z1
                ic = 0
                ks = 0
                For i = i1 To i2
                    x2 = XR2(i)
                    y2 = YR2(i)
                    z2 = ZR2(i)
                    If ic = 0 Then
                        jb = 2 * Mesh(5)
                    Else
                        jb = Mesh(5)
                    End If
                    For j = 1 To jb
                        b1 = (j - 1.0) / jb
                        b2 = 1 - b1
                        Npoint = Npoint + 1
                        Xdata(Npoint) = b1 * x1 + b2 * x2
                        Ydata(Npoint) = b1 * y1 + b2 * y2
                        Zdata(Npoint) = b1 * z1 + b2 * z2
                    Next j
                    If ic = 0 Then
                        If ks = 0 Then
                            ks = 1
                        Else
                            Xdata(Npoint + 1) = Xdata(Npoint)
                            Ydata(Npoint + 1) = Ydata(Npoint)
                            Zdata(Npoint + 1) = Zdata(Npoint)
                            Xdata(Npoint) = 0.5 * (Xdata(Npoint) + Xdata(Npoint - 1))
                            Ydata(Npoint) = 0.5 * (Ydata(Npoint) + Ydata(Npoint - 1))
                            Zdata(Npoint) = 0.5 * (Zdata(Npoint) + Zdata(Npoint - 1))
                            Npoint = Npoint + 2
                            Xdata(Npoint) = 0.5 * (x1 + Xdata(Npoint - 1))
                            Ydata(Npoint) = 0.5 * (y1 + Ydata(Npoint - 1))
                            Zdata(Npoint) = 0.5 * (z1 + Zdata(Npoint - 1))
                            ks = 0
                        End If
                        ic = 1
                    Else
                        ic = 0
                    End If
                Next i
            Next k
        End If

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ii, ix, k, kh As Integer
        Dim b1 As Single

        Call DataSet(kh)    'ﾃﾞｰﾀの設定
        ii = FreeFile()
        FileOpen(ii, Fx$, OpenMode.Output)
        WriteLine(ii, BL(1))
        WriteLine(ii, BL(2))
        WriteLine(ii, RadC)
        WriteLine(ii, Dia)
        WriteLine(ii, Alpha)
        WriteLine(ii, Beta)
        For k = 1 To 6
            WriteLine(ii, Mesh(k))
        Next k
        FileClose(ii)

        If kh < 0 Then
            Exit Sub
        End If

        Call DataSize()     'ﾃﾞｰﾀｻｲｽﾞの設定
        Call CircleSet()    '横穴の設定
        Call MeshGene()     '要素ﾒｯｼｭの生成

        b1 = BL(1) + BL(2)
        aa$ = "横穴付き円柱（外半径" + LTrim(Str(RadC))
        aa$ = aa$ + "×長さ" + LTrim(Str(b1))
        Title$ = aa$ + "、横穴φ" + LTrim(Str(Dia)) + "）"
        ReDim NumMat(Nelem)
        For i = 1 To Nelem
            NumMat(i) = 1
        Next i
        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6() '立体ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class