'三角柱の生成ﾌﾟﾛｸﾞﾗﾑ
Public Class SolDDat11e
    Dim Fx$         'ﾌｧｲﾙ名

    Dim NPbaseL As Integer      '左面の節点ベース数
    Dim NPbaseM As Integer      '中間面の節点ベース数
    Dim NPbaseR As Integer      '右面の節点ベース数
    Dim NPsecStd As Integer     '基準面の節点数
    Dim NPsecStM As Integer     '中間面の節点数
    Dim NumPstd As Integer      '基準面の辺の節点数
    Dim NumPstM As Integer      '中間面の辺の節点数

    Dim Mesh(3) As Integer      'メッシュ数m1～m3

    Dim Rlen(4) As Single       '長さL,a～e
    Dim Yvert(3), Zvert(3) As Single    '4頂点の座標
    Dim XM1(), YM1(), ZM1() As Single   '中間面の左辺の節点座標
    Dim XM2(), YM2(), ZM2() As Single   '中間面の右辺の節点座標
    Dim XR1(), YR1(), ZR1() As Single   '右面の左辺の節点座標
    Dim XR2(), YR2(), ZR2() As Single   '右面の右辺の節点座標

    Private Sub DataSet(ByRef kh As Integer)
        'ﾃﾞｰﾀの設定
        Dim aa$
        Dim i, ib As Integer

        Rlen(1) = Val(TextBox1.Text)
        Rlen(2) = Val(TextBox2.Text)
        Rlen(3) = Val(TextBox3.Text)
        Rlen(4) = Val(TextBox4.Text)
        Mesh(1) = Val(TextBox5.Text)
        Mesh(2) = Val(TextBox6.Text)
        Mesh(3) = Val(TextBox7.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        For i = 1 To 4
            If i <> 3 Then
                If Rlen(i) <= 0 Then
                    aa$ = "寸法が間違っています！"
                    MsgBox(aa$, 0, "データエラー")
                    kh = -1
                    Exit Sub
                End If
            End If
        Next i
        For i = 1 To 3
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i
        ib = Mesh(2) Mod 2
        If ib > 0 Then
            aa$ = "分割数m2が偶数になっていません！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
        End If

    End Sub

    Private Sub DataSize()
        'ﾃﾞｰﾀｻｲｽﾞの設定
        Dim mb, nb As Integer

        NumPstM = Mesh(3) + 1
        NumPstd = 2 * Mesh(3) + 1
        NPsecStd = NumPstd * (Mesh(2) + 1) + NumPstM * Mesh(2)
        NPsecStM = NumPstM * (Mesh(2) + 1)
        mb = Mesh(1)
        nb = NPsecStd * (mb + 1) + NPsecStM * mb
        ReDim Xdata(nb), Ydata(nb), Zdata(nb)
        nb = Mesh(2) * Mesh(3) * mb
        ReDim NNelem(nb, 20)

    End Sub

    Private Sub ElemGene()
        '六面体要素の作成
        Dim i, j, jj, jL, jR, k, n0, n1, nbL, nbM, nbR, nunit As Integer
        Dim kbuf(20) As Integer

        n0 = 2 * Mesh(2) + 1
        n1 = Mesh(2) + 1
        nunit = n0 + n1
        For i = 1 To Mesh(3) - 1
            nbL = NPbaseL + nunit * (i - 1)
            nbM = NPbaseM + n1 * (i - 1)
            nbR = NPbaseR + nunit * (i - 1)
            For j = 1 To Mesh(2)
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0 + j
                kbuf(3) = kbuf(1) + nunit
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                kbuf(9) = nbM + j
                kbuf(10) = kbuf(9) + n1
                kbuf(11) = kbuf(10) + 1
                kbuf(12) = kbuf(9) + 1
                kbuf(13) = nbR + 2 * j - 1
                kbuf(14) = nbR + n0 + j
                kbuf(15) = kbuf(13) + nunit
                kbuf(16) = kbuf(15) + 1
                kbuf(17) = kbuf(16) + 1
                kbuf(18) = kbuf(14) + 1
                kbuf(19) = kbuf(13) + 2
                kbuf(20) = kbuf(13) + 1
                For k = 1 To 20
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
        Next i

        '最終段（三角形2個で1個の変則四角形断面）
        i = Mesh(3) - 1
        nbL = NPbaseL + nunit * i
        nbM = NPbaseM + n1 * i
        nbR = NPbaseR + nunit * i
        jj = nbM
        jL = nbL + n0
        jR = nbR + n0
        For j = 1 To Mesh(2) Step 2
            Nelem = Nelem + 1
            kbuf(1) = nbL + 2 * j - 1
            kbuf(2) = jL + 1
            kbuf(3) = NPbaseM
            kbuf(4) = jL + 2
            kbuf(5) = kbuf(1) + 4
            kbuf(6) = kbuf(5) - 1
            kbuf(7) = kbuf(6) - 1
            kbuf(8) = kbuf(7) - 1
            kbuf(9) = jj + 1
            kbuf(10) = NPbaseR
            kbuf(11) = jj + 3
            kbuf(12) = jj + 2
            kbuf(13) = nbR + 2 * j - 1
            kbuf(14) = jR + 1
            kbuf(15) = Npoint
            kbuf(16) = jR + 2
            kbuf(17) = kbuf(13) + 4
            kbuf(18) = kbuf(17) - 1
            kbuf(19) = kbuf(18) - 1
            kbuf(20) = kbuf(19) - 1
            For k = 1 To 20
                NNelem(Nelem, k) = kbuf(k)
            Next k
            jj = jj + 2
            jL = jL + 1
            jR = jR + 1
        Next j

    End Sub

    Private Sub MeshGene()
        '要素ﾒｯｼｭの生成
        Dim i, meshb As Integer
        Dim rlenb, xsM, xsR As Single

        ReDim XR1(NumPstd), YR1(NumPstd), ZR1(NumPstd)
        ReDim XR2(NumPstd), YR2(NumPstd), ZR2(NumPstd)
        ReDim XM1(NumPstM), YM1(NumPstM), ZM1(NumPstM)
        ReDim XM2(NumPstM), YM2(NumPstM), ZM2(NumPstM)

        Nelem = 0
        Npoint = 0
        meshb = Mesh(1)
        rlenb = Rlen(1)

        For i = 1 To Mesh(1)
            xsR = rlenb * i / meshb
            xsM = 0.5 * rlenb * (2 * i - 1) / meshb

            '左面の設定
            If i = 1 Then
                Call RPlaneLine(0)   '右面の両辺のﾒｯｼｭ計算
                Call RPlaneSect()   '右面の節点計算
            End If
            NPbaseL = NPbaseR

            '中間面の設定
            Call MPlaneLine(xsM)   '中間面の両辺のﾒｯｼｭ計算
            Call MPlaneSect()   '中間面の節点計算

            '右面の設定
            Call RPlaneLine(xsR)   '右面の両辺のﾒｯｼｭ計算
            Call RPlaneSect()   '右面の節点計算

            Call ElemGene() '六面体要素の作成

        Next i

    End Sub

    Private Sub MPlaneLine(ByVal xb As Single)
        '中間面の両辺のﾒｯｼｭ計算
        'xb･･･X座標
        Dim i, mb, nb As Integer
        Dim b1, b2, yb, zb As Single

        mb = Mesh(3)
        nb = 0
        For i = 0 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            yb = b1 * Yvert(3) + b2 * Yvert(2)
            zb = b1 * Zvert(3) + b2 * Zvert(2)
            nb = nb + 1
            XM1(nb) = xb
            YM1(nb) = yb
            ZM1(nb) = zb
            yb = b1 * Yvert(1) + b2 * Yvert(2)
            zb = b1 * Zvert(1) + b2 * Zvert(2)
            XM2(nb) = xb
            YM2(nb) = yb
            ZM2(nb) = zb
        Next i

    End Sub

    Private Sub MPlaneSect()
        '中間面の節点計算
        Dim i, imax, j As Integer
        Dim b1, b2, x1, x2, y1, y2, z1, z2 As Single

        NPbaseM = Npoint
        imax = Mesh(3)
        For i = 1 To imax
            x1 = XM1(i) : x2 = XM2(i)
            y1 = YM1(i) : y2 = YM2(i)
            z1 = ZM1(i) : z2 = ZM2(i)
            For j = 1 To Mesh(2) + 1
                b1 = (j - 1.0) / Mesh(2)
                b2 = 1 - b1
                Npoint = Npoint + 1
                Xdata(Npoint) = b1 * x1 + b2 * x2
                Ydata(Npoint) = b1 * y1 + b2 * y2
                Zdata(Npoint) = b1 * z1 + b2 * z2
            Next j
        Next i

        imax = imax + 1
        Npoint = Npoint + 1
        Xdata(Npoint) = XM1(i)
        Ydata(Npoint) = YM1(i)
        Zdata(Npoint) = ZM1(i)

    End Sub

    Private Sub RPlaneLine(ByVal xb As Single)
        '右面の両辺のﾒｯｼｭ計算
        'xb･･･X座標
        Dim i, mb, nb As Integer
        Dim b1, b2, yb, zb As Single

        mb = 2 * Mesh(3)
        nb = 0
        For i = 0 To mb
            b2 = 1.0 * i / mb
            b1 = 1 - b2
            yb = b1 * Yvert(3) + b2 * Yvert(2)
            zb = b1 * Zvert(3) + b2 * Zvert(2)
            nb = nb + 1
            XR1(nb) = xb
            YR1(nb) = yb
            ZR1(nb) = zb
            yb = b1 * Yvert(1) + b2 * Yvert(2)
            zb = b1 * Zvert(1) + b2 * Zvert(2)
            XR2(nb) = xb
            YR2(nb) = yb
            ZR2(nb) = zb
        Next i

    End Sub

    Private Sub RPlaneSect()
        '右面の節点計算
        Dim i, ic, imax, j, jb As Integer
        Dim b1, b2, x1, x2, y1, y2, z1, z2 As Single

        NPbaseR = Npoint
        imax = 2 * Mesh(3) - 1
        ic = 0
        For i = 1 To imax
            x1 = XR1(i) : x2 = XR2(i)
            y1 = YR1(i) : y2 = YR2(i)
            z1 = ZR1(i) : z2 = ZR2(i)
            If ic = 0 Then
                jb = 2 * Mesh(2)
            Else
                jb = Mesh(2)
            End If
            For j = 1 To jb + 1
                b1 = (j - 1.0) / jb
                b2 = 1 - b1
                Npoint = Npoint + 1
                Xdata(Npoint) = b1 * x1 + b2 * x2
                Ydata(Npoint) = b1 * y1 + b2 * y2
                Zdata(Npoint) = b1 * z1 + b2 * z2
            Next j
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
        Next i

        i = imax + 1
        x1 = XR1(i) : x2 = XR2(i)
        y1 = YR1(i) : y2 = YR2(i)
        z1 = ZR1(i) : z2 = ZR2(i)
        jb = Mesh(2)
        For j = 1 To jb + 1 Step 2
            b1 = (j - 1.0) / jb
            b2 = 1 - b1
            Npoint = Npoint + 1
            Xdata(Npoint) = b1 * x1 + b2 * x2
            Ydata(Npoint) = b1 * y1 + b2 * y2
            Zdata(Npoint) = b1 * z1 + b2 * z2
        Next j

        i = i + 1
        Npoint = Npoint + 1
        Xdata(Npoint) = XR1(i)
        Ydata(Npoint) = YR1(i)
        Zdata(Npoint) = ZR1(i)

    End Sub

    Private Sub VertSet()
        '点の設定

        Yvert(1) = 0 : Zvert(1) = 0
        Yvert(2) = Rlen(3) : Zvert(2) = Rlen(4)
        Yvert(3) = Rlen(2) : Zvert(3) = 0

    End Sub

    Private Sub SolDDat11e_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim icc, ii, k As Integer

        Fx$ = DirOpen$ + "\SolDDat11e.tmp"
        Try
            ii = FreeFile()
            FileOpen(ii, Fx$, OpenMode.Input)
            icc = 1
            For k = 1 To 4
                Input(ii, Rlen(k))
            Next k
            Input(ii, Mesh(1))
            Input(ii, Mesh(2))
            Input(ii, Mesh(3))
        Catch
            '処理不要
        End Try
        If icc > 0 Then
            FileClose(ii)
        End If

        TextBox1.Text = Str(Rlen(1))
        TextBox2.Text = Str(Rlen(2))
        TextBox3.Text = Str(Rlen(3))
        TextBox4.Text = Str(Rlen(4))
        TextBox5.Text = Str(Mesh(1))
        TextBox6.Text = Str(Mesh(2))
        TextBox7.Text = Str(Mesh(3))

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ii, ix, k, kh As Integer

        Call DataSet(kh)    'ﾃﾞｰﾀの設定
        ii = FreeFile()
        FileOpen(ii, Fx$, OpenMode.Output)
        For k = 1 To 4
            WriteLine(ii, Rlen(k))
        Next k
        WriteLine(ii, Mesh(1))
        WriteLine(ii, Mesh(2))
        WriteLine(ii, Mesh(3))
        FileClose(ii)

        If kh < 0 Then
            Exit Sub
        End If

        Call VertSet()      '三角形頂点の設定
        Call DataSize()     'ﾃﾞｰﾀｻｲｽﾞの設定
        Call MeshGene()     '要素ﾒｯｼｭの生成

        aa$ = "三角柱（底辺" + LTrim(Str(Rlen(2)))
        Title$ = aa$ + "×長さ" + LTrim(Str(Rlen(1))) + "）"
        ReDim NumMat(Nelem)
        For i = 1 To Nelem
            NumMat(i) = 1
        Next i
        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6() '立体ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class