'円断面のリングの生成ﾌﾟﾛｸﾞﾗﾑ
Public Class SolDDat11f
    Dim Fx$         'ﾌｧｲﾙ名

    Dim KindRad As Integer      '放射ﾒｯｼｭの種類（0:全周、1:部分周）
    Dim Nelemb As Integer       '断面の要素数
    Dim Npointb As Integer      '断面の節点数
    Dim NPsecStd As Integer     '基準面の節点数
    Dim Npv As Integer          '断面の頂点節点数
    Dim Ns2 As Integer          '両端面間の総ﾒｯｼｭ数（含中間節点ﾒｯｼｭ）
    Dim NumPstd As Integer      '辺の節点数

    Dim Alpha As Single         '角度α（°）

    Dim Jpoint() As Integer     '節点ﾌﾗｯｸﾞ（0:頂点ﾌﾗｯｸﾞ、1:中間節点）
    Dim Mesh(3) As Integer      'メッシュ数m1～m3
    Dim NLelem(,) As Integer    '左端断面の要素ﾃﾞｰﾀ
    Dim NumNodeV() As Integer   '面内の頂点節点順位

    Dim Rlen(2) As Single       '長さR,r
    Dim XL(), YL() As Single    '左端断面における節点座標
    Dim XL2(), YL2() As Single   '周の節点座標
    Dim XLdat(), YLdat(), ZLdat() As Single '左端面節点の全体座標

    Private Sub DataSet(ByRef kh As Integer)
        'ﾃﾞｰﾀの設定
        Dim aa$
        Dim i, ib As Integer

        Rlen(1) = Val(TextBox1.Text)
        Alpha = Val(TextBox2.Text)
        Rlen(2) = Val(TextBox3.Text)
        Mesh(1) = Val(TextBox4.Text)
        Mesh(2) = Val(TextBox5.Text)
        Mesh(3) = Val(TextBox6.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        If Rlen(1) <= 0 Or Rlen(2) <= 0 Then
            aa$ = "寸法が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Alpha <= 0 Or Alpha > 360 Then
            aa$ = "角度が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        For i = 1 To 3
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i
        ib = Mesh(2) Mod 2
        If ib <> 0 Then
            aa$ = "周の分割数が偶数になっていません！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If

    End Sub

    Private Sub DataSizeS()
        '断面のﾃﾞｰﾀｻｲｽﾞの設定
        Dim nb As Integer

        NumPstd = 2 * Mesh(2)
        NPsecStd = (NumPstd + Mesh(2)) * (Mesh(3) + 1)
        ReDim X(NPsecStd), Y(NPsecStd)
        nb = Mesh(2) * Mesh(3)
        ReDim NNelem(nb, 8)

    End Sub

    Private Sub ElemGeneR()
        '軸回転体の六面体要素の作成
        Dim ib, ic, ie, ielem, isect As Integer
        Dim j, jj, nb0, nb1, nb2, nset As Integer
        Dim kbuf(8), kvbuf(8) As Integer
        ielem = 0
        nset = Npointb + Npv
        For isect = 1 To Nsect
            ib = isect Mod 2
            nb0 = nset * (isect - 1)
            nb1 = nb0 + Npointb
            If KindRad = 0 And isect = Nsect Then
                nb2 = 0
            Else
                nb2 = nb1 + Npv
            End If
            For ie = 1 To Nelemb    '半断面の要素順に六面体要素を作成
                ic = 0
                For j = 1 To 8
                    kbuf(j) = NLelem(ie, j)
                    kvbuf(j) = NumNodeV(kbuf(j))
                Next j
                ielem = ielem + 1
                For j = 1 To 8
                    NNelem(ielem, j) = kbuf(j) + nb0
                    NNelem(ielem, j + 12) = kbuf(j) + nb2
                Next j
                For j = 1 To 4
                    jj = 2 * j - 1
                    NNelem(ielem, j + 8) = kvbuf(jj) + nb1
                Next j

            Next ie
        Next isect

    End Sub

    Private Sub ElemGeneS()
        '四角形要素の作成
        Dim i, ib, imax, j, k, ks As Integer
        Dim n0, n0c, n0x, n1, n1m, n1x, nbL, nunit, nunitc, nunitx As Integer
        Dim kbuf(8) As Integer

        imax = Mesh(2) - 1

        n0 = 2 * Mesh(3)
        n0c = n0 + 2
        n1 = Mesh(3)
        n1m = n1 + 1
        nunit = n0 + n1
        nunitc = n0c + n1
        ks = 0
        For i = 1 To imax
            ib = Int((i - 1) / 2)
            nbL = 1 + (nunit + nunitc) * ib
            If ks = 0 Then
                n0x = n0
                n1x = n1
                nunitx = nunit
            Else
                nbL = nbL + nunit
                n0x = n0c
                n1x = n1m
                nunitx = nunitc
            End If
            For j = 1 To Mesh(3) - 1
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                For k = 1 To 8
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
            j = Mesh(3)
            Nelem = Nelem + 1
            If ks = 0 Then
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(5) + 1
                kbuf(7) = 1
                kbuf(8) = kbuf(1) + 1
            Else
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0x + j
                kbuf(3) = kbuf(1) + nunitx
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = 1
                kbuf(6) = kbuf(1) + 3
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
            End If
            For k = 1 To 8
                NNelem(Nelem, k) = kbuf(k)
            Next k
            If ks = 0 Then
                ks = 1
            Else
                ks = 0
            End If
        Next i

        i = Mesh(2)
        ib = Int((i - 1) / 2)
        nbL = 1 + (nunit + nunitc) * ib
        n0x = n0c
        n1x = n1m
        nunitx = nunitc
        nbL = nbL + nunit
        For j = 1 To Mesh(3) - 1
            Nelem = Nelem + 1
            kbuf(1) = nbL + 2 * j - 1
            kbuf(2) = nbL + n0x + j
            kbuf(3) = 1 + 2 * j - 1
            kbuf(4) = kbuf(3) + 1
            kbuf(5) = kbuf(4) + 1
            kbuf(6) = kbuf(2) + 1
            kbuf(7) = kbuf(1) + 2
            kbuf(8) = kbuf(1) + 1
            For k = 1 To 8
                NNelem(Nelem, k) = kbuf(k)
            Next k
        Next j
        j = Mesh(3)
        Nelem = Nelem + 1
        kbuf(1) = nbL + 2 * j - 1
        kbuf(2) = nbL + n0x + j
        kbuf(3) = 1 + 2 * j - 1
        kbuf(4) = kbuf(3) + 1
        kbuf(5) = 1
        kbuf(6) = kbuf(1) + 3
        kbuf(7) = kbuf(1) + 2
        kbuf(8) = kbuf(1) + 1
        For k = 1 To 8
            NNelem(Nelem, k) = kbuf(k)
        Next k

    End Sub

    Private Sub LeftPlaneCalc2()
        '左端面の座標計算
        Dim ip As Integer
        Dim xb, yb As Single

        For ip = 1 To Npointb
            xb = XL(ip)
            yb = YL(ip)
            Xmodel(ip) = xb
            Ymodel(ip) = 0
            Zmodel(ip) = yb
        Next ip

        Call SectStore(0, Npointb)  '断面の座標データ保存

    End Sub

    Private Sub LeftPlaneData1()
        '左端断面のﾃﾞｰﾀ設定
        Dim ie, ip, j As Integer
        ReDim Jpoint(Npoint), NumNodeV(Npoint)
        ReDim NLelem(Nelem, 8), XL(Npoint), YL(Npoint)
        ReDim XLdat(Npoint), YLdat(Npoint), ZLdat(Npoint)
        ReDim Xmodel(Npoint), Ymodel(Npoint), Zmodel(Npoint)

        Ns2 = 2 * Nsect
        For ie = 1 To Nelem
            For j = 1 To 8
                NLelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie
        For ip = 1 To Npoint
            XL(ip) = X(ip) + Rlen(1)
            YL(ip) = Y(ip)
        Next ip
        Nelemb = Nelem
        Npointb = Npoint

    End Sub

    Private Sub MeshGeneS()
        '断面のﾒｯｼｭ成
        ReDim XL2(NumPstd), YL2(NumPstd)

        Nelem = 0
        Npoint = 0

        Call PlaneLine()   '周のﾒｯｼｭ計算
        Call PlaneSect()   '面の節点計算

        Call ElemGeneS() '四角形要素の作成

        Call ReNumberEP(0, 1, Mesh(2), Mesh(3))  '要素･節点番号の付番改良

        Nsect = Mesh(1)

    End Sub

    Private Sub MeshPlaneCalR()
        '各放射ﾒｯｼｭ面の座標計算
        Dim ic, ii, imax, isect, ip, nb, nn, nx As Integer
        Dim b1, b2, c1, s1, theta, xb, yb As Single
        Dim buf(3) As Single

        theta = Pai * Alpha / 180
        nx = Npointb
        If KindRad = 0 Then
            imax = Ns2 - 1
        Else
            imax = Ns2
        End If
        b1 = Ns2
        ic = 1  'ﾒｯｼｭ面区分（0:主ﾒｯｼｭ面、1:中間ﾒｯｼｭ面）
        nn = Npointb
        For isect = 1 To imax
            b2 = (isect / b1) * theta
            c1 = Math.Cos(b2)
            s1 = Math.Sin(b2)
            If ic = 0 Then
                ii = isect Mod 4
                If ii > 0 Then
                    nb = nx
                Else
                    nb = Npointb
                End If
                For ip = 1 To nb
                    xb = XL(ip)
                    yb = YL(ip)
                    Xmodel(ip) = xb * c1
                    Ymodel(ip) = xb * s1
                    Zmodel(ip) = yb
                Next ip
            Else
                nb = Npv
                ii = 0
                For ip = 1 To Npointb
                    If Jpoint(ip) = 0 Then
                        ii = ii + 1
                        xb = XL(ip)
                        yb = YL(ip)
                        Xmodel(ii) = xb * c1
                        Ymodel(ii) = xb * s1
                        Zmodel(ii) = yb
                    End If
                Next ip
            End If
            Call SectStore(nn, nb)  '断面の座標データ保存
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
            nn = nn + nb
        Next isect

    End Sub

    Private Sub NodeCount1()
        '面内の節点のﾁｪｯｸ
        Dim ib, ie, ip, j, nb As Integer
        Dim kbuf(Npointb) As Integer

        Npv = 0
        For ie = 1 To Nelemb
            For j = 1 To 7 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    Npv = Npv + 1
                    kbuf(ib) = 1
                    Jpoint(ib) = 0
                End If
            Next j
            For j = 2 To 8 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    kbuf(ib) = 1
                    Jpoint(ib) = 1
                End If
            Next j
        Next ie
        nb = 0
        For ip = 1 To Npointb
            If Jpoint(ip) = 0 Then
                nb = nb + 1
                NumNodeV(ip) = nb
            End If
        Next ip

    End Sub

    Private Sub PlaneLine()
        '周のﾒｯｼｭ計算
        Dim i, imax, mb, nb As Integer
        Dim angle, b1, b2, cosb, r2, sinb, theta, xb, yb As Single

        mb = 2 * Mesh(2)
        angle = Dpai
        imax = mb

        r2 = Rlen(2)
        nb = 0
        For i = 1 To imax
            b2 = (i - 1.0) / mb
            b1 = 1 - b2
            theta = angle * b2
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            nb = nb + 1
            xb = r2 * cosb
            yb = r2 * sinb
            XL2(nb) = xb
            YL2(nb) = yb
        Next i

    End Sub

    Private Sub PlaneSect()
        '面の節点計算
        Dim i, ic, imax, j, jb, ks, mb As Integer
        Dim b1, b2, x2, y2 As Single

        mb = 2 * Mesh(2)
        imax = mb

        Npoint = Npoint + 1
        X(Npoint) = 0
        Y(Npoint) = 0
        ic = 0
        ks = 0
        For i = 1 To imax
            x2 = XL2(i)
            y2 = YL2(i)
            If ic = 0 Then
                jb = 2 * Mesh(3)
            Else
                jb = Mesh(3)
            End If
            For j = 1 To jb
                b1 = (j - 1.0) / jb
                b2 = 1 - b1
                Npoint = Npoint + 1
                X(Npoint) = b2 * x2
                Y(Npoint) = b2 * y2
            Next j
            If ic = 0 Then
                If ks = 0 Then
                    ks = 1
                Else
                    X(Npoint + 1) = X(Npoint)
                    Y(Npoint + 1) = Y(Npoint)
                    X(Npoint) = 0.5 * (X(Npoint) + X(Npoint - 1))
                    Y(Npoint) = 0.5 * (Y(Npoint) + Y(Npoint - 1))
                    Npoint = Npoint + 2
                    X(Npoint) = 0.5 * X(Npoint - 1)
                    Y(Npoint) = 0.5 * Y(Npoint - 1)
                    ks = 0
                End If
                ic = 1
            Else
                ic = 0
            End If
        Next i

    End Sub

    Private Sub SectStore(ByVal ib As Integer, ByVal nb As Integer)
        '断面の座標データ保存
        'ib･･･ﾍﾞｰｽ節点数
        'nb･･･節点数
        Dim ii, ip As Integer
        For ip = 1 To nb
            ii = ib + ip
            Xdata(ii) = Xmodel(ip)
            Ydata(ii) = Ymodel(ip)
            Zdata(ii) = Zmodel(ip)
        Next ip

    End Sub

    Private Sub SolDDat11f_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim icc, ii As Integer

        Fx$ = DirOpen$ + "\SolDDat11f.tmp"
        Try
            ii = FreeFile()
            FileOpen(ii, Fx$, OpenMode.Input)
            icc = 1
            Input(ii, Rlen(1))
            Input(ii, Alpha)
            Input(ii, Rlen(2))
            Input(ii, Mesh(1))
            Input(ii, Mesh(2))
            Input(ii, Mesh(3))
        Catch
            '処理不要
        End Try
        If icc > 0 Then
            FileClose(ii)
        End If

        TextBox1.Text = Str(Rlen(1))
        TextBox2.Text = Str(Alpha)
        TextBox3.Text = Str(Rlen(2))
        TextBox4.Text = Str(Mesh(1))
        TextBox5.Text = Str(Mesh(2))
        TextBox6.Text = Str(Mesh(3))

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ii, ix, kh As Integer

        Call DataSet(kh)    'ﾃﾞｰﾀの設定
        ii = FreeFile()
        FileOpen(ii, Fx$, OpenMode.Output)
        WriteLine(ii, Rlen(1))
        WriteLine(ii, Alpha)
        WriteLine(ii, Rlen(2))
        WriteLine(ii, Mesh(1))
        WriteLine(ii, Mesh(2))
        WriteLine(ii, Mesh(3))
        FileClose(ii)

        If kh < 0 Then
            Exit Sub
        End If

        Call DataSizeS()    '断面のﾃﾞｰﾀｻｲｽﾞの設定

        Call MeshGeneS()    '断面のﾒｯｼｭ生成

        Call LeftPlaneData1() '左端断面のﾃﾞｰﾀ設定

        Nelem = Nelemb * Nsect
        Call NodeCount1() '面内の節点のﾁｪｯｸ

        Npoint = Npointb * (Nsect + 1) + Npv * Nsect
        ReDim NNelem(Nelem, 20), NumMat(Nelem)
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)

        Call LeftPlaneCalc2() '左端面の座標計算

        If Alpha = 360 Then
            KindRad = 0
        Else
            KindRad = 1
        End If
        Call MeshPlaneCalR() '各放射ﾒｯｼｭ面の座標計算
        Call ElemGeneR()    '軸回転体の六面体要素の作成

        aa$ = "円断面のリング（リング半径" + LTrim(Str(Rlen(1)))
        aa$ = aa$ + "×角度（°）" + LTrim(Str(Alpha))
        Title$ = aa$ + "×円半径" + LTrim(Str(Rlen(2))) + "）"

        Call DfilePrepA()   '構造ﾃﾞｰﾀﾌｧｲﾙ保存の前処理

        ReDim NumMat(Nelem)
        For i = 1 To Nelem
            NumMat(i) = 1
        Next i
        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6() '立体ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class