'円筒断面のリングの生成ﾌﾟﾛｸﾞﾗﾑ
Public Class SolDDat11g
    Dim Fx$         'ﾌｧｲﾙ名

    Dim KindRad As Integer      '放射ﾒｯｼｭの種類（0:全周、1:部分周）
    Dim Nelemb As Integer       '断面の要素数
    Dim Npointb As Integer      '断面の節点数
    Dim NPbaseL As Integer      '左面の節点ベース数
    Dim NPbaseM As Integer      '中間面の節点ベース数
    Dim NPbaseR As Integer      '右面の節点ベース数
    Dim NPsecStd As Integer     '基準面の節点数
    Dim NPsecStM As Integer     '中間面の節点数
    Dim Npv As Integer          '断面の頂点節点数
    Dim Ns2 As Integer          '両端面間の総ﾒｯｼｭ数（含中間節点ﾒｯｼｭ）
    Dim NumPstd As Integer      '基準面の周の節点数
    Dim NumPstM As Integer      '中間面の周の節点数

    Dim Alpha As Single         '角度α（°）

    Dim Jpoint() As Integer     '節点ﾌﾗｯｸﾞ（0:頂点ﾌﾗｯｸﾞ、1:中間節点）
    Dim Mesh(3) As Integer      'メッシュ数m1～m3
    Dim NLelem(,) As Integer    '左端断面の要素ﾃﾞｰﾀ
    Dim NumNodeV() As Integer   '面内の頂点節点順位

    Dim Rlen(3) As Single       '長さR,r1,r2
    Dim XL(), YL() As Single    '左端断面における節点座標
    Dim XL1(), YL1() As Single  '左辺の節点座標
    Dim XL2(), YL2() As Single  '右辺の節点座標
    Dim XLdat(), YLdat(), ZLdat() As Single '左端面節点の全体座標

    Dim XM1(), YM1(), ZM1() As Single   '中間面内周の節点座標
    Dim XM2(), YM2(), ZM2() As Single   '中間面外周の節点座標
    Dim XR1(), YR1(), ZR1() As Single   '右面内周の節点座標
    Dim XR2(), YR2(), ZR2() As Single   '右面外周の節点座標

    Private Sub DataSet(ByRef kh As Integer)
        'ﾃﾞｰﾀの設定
        Dim aa$
        Dim i As Integer

        Rlen(1) = Val(TextBox1.Text)
        Alpha = Val(TextBox2.Text)
        Rlen(2) = Val(TextBox3.Text)
        Rlen(3) = Val(TextBox4.Text)
        Mesh(1) = Val(TextBox5.Text)
        Mesh(2) = Val(TextBox6.Text)
        Mesh(3) = Val(TextBox7.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        If Rlen(1) <= 0 Or Rlen(2) <= 0 Or Rlen(3) <= 0 Then
            aa$ = "寸法が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        If Alpha <= 0 Or Alpha > 360 Then
            aa$ = "角度が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If
        For i = 1 To 3
            If Mesh(i) <= 0 Then
                aa$ = "分割数が間違っています！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i

    End Sub

    Private Sub DataSizeS()
        '断面のﾃﾞｰﾀｻｲｽﾞの設定
        Dim nb As Integer

        If Alpha < 360 Then
            NumPstd = 2 * Mesh(2) + 1
            NPsecStd = NumPstd * (Mesh(3) + 1) + (Mesh(2) + 1) * Mesh(3)
        Else
            NumPstd = 2 * Mesh(2)
            NPsecStd = NumPstd * (Mesh(3) + 1) + Mesh(2) * Mesh(3)
        End If
        ReDim X(NPsecStd), Y(NPsecStd)
        nb = Mesh(2) * Mesh(3)
        ReDim NNelem(nb, 8)

    End Sub

    Private Sub ElemGeneR()
        '軸回転体の六面体要素の作成
        Dim ib, ic, ie, ielem, isect As Integer
        Dim j, jj, nb0, nb1, nb2, nset As Integer
        Dim kbuf(8), kvbuf(8) As Integer
        ielem = 0
        nset = Npointb + Npv
        For isect = 1 To Nsect
            ib = isect Mod 2
            nb0 = nset * (isect - 1)
            nb1 = nb0 + Npointb
            If KindRad = 0 And isect = Nsect Then
                nb2 = 0
            Else
                nb2 = nb1 + Npv
            End If
            For ie = 1 To Nelemb    '半断面の要素順に六面体要素を作成
                ic = 0
                For j = 1 To 8
                    kbuf(j) = NLelem(ie, j)
                    kvbuf(j) = NumNodeV(kbuf(j))
                Next j
                ielem = ielem + 1
                For j = 1 To 8
                    NNelem(ielem, j) = kbuf(j) + nb0
                    NNelem(ielem, j + 12) = kbuf(j) + nb2
                Next j
                For j = 1 To 4
                    jj = 2 * j - 1
                    NNelem(ielem, j + 8) = kvbuf(jj) + nb1
                Next j

            Next ie
        Next isect

    End Sub

    Private Sub ElemGeneS()
        '四角形要素の作成
        Dim i, imax, j, k, n0, n1, nbL, nunit As Integer
        Dim kbuf(8) As Integer

        imax = Mesh(2) - 1

        n0 = 2 * Mesh(3) + 1
        n1 = Mesh(3) + 1
        nunit = n0 + n1
        For i = 1 To imax
            nbL = nunit * (i - 1)
            For j = 1 To Mesh(3)
                Nelem = Nelem + 1
                kbuf(1) = nbL + 2 * j - 1
                kbuf(2) = nbL + n0 + j
                kbuf(3) = kbuf(1) + nunit
                kbuf(4) = kbuf(3) + 1
                kbuf(5) = kbuf(4) + 1
                kbuf(6) = kbuf(2) + 1
                kbuf(7) = kbuf(1) + 2
                kbuf(8) = kbuf(1) + 1
                For k = 1 To 8
                    NNelem(Nelem, k) = kbuf(k)
                Next k
            Next j
        Next i

        i = Mesh(2)
        nbL = nunit * (i - 1)
        For j = 1 To Mesh(3)
            Nelem = Nelem + 1
            kbuf(1) = nbL + 2 * j - 1
            kbuf(2) = nbL + n0 + j
            kbuf(3) = 2 * j - 1
            kbuf(4) = kbuf(3) + 1
            kbuf(5) = kbuf(4) + 1
            kbuf(6) = kbuf(2) + 1
            kbuf(7) = kbuf(1) + 2
            kbuf(8) = kbuf(1) + 1
            For k = 1 To 8
                NNelem(Nelem, k) = kbuf(k)
            Next k
        Next j

    End Sub

    Private Sub MeshPlaneCalR()
        '各放射ﾒｯｼｭ面の座標計算
        Dim ic, ii, imax, isect, ip, nb, nn, nx As Integer
        Dim b1, b2, c1, s1, theta, xb, yb As Single
        Dim buf(3) As Single

        theta = Pai * Alpha / 180
        nx = Npointb
        If KindRad = 0 Then
            imax = Ns2 - 1
        Else
            imax = Ns2
        End If
        b1 = Ns2
        ic = 1  'ﾒｯｼｭ面区分（0:主ﾒｯｼｭ面、1:中間ﾒｯｼｭ面）
        nn = Npointb
        For isect = 1 To imax
            b2 = (isect / b1) * theta
            c1 = Math.Cos(b2)
            s1 = Math.Sin(b2)
            If ic = 0 Then
                ii = isect Mod 4
                If ii > 0 Then
                    nb = nx
                Else
                    nb = Npointb
                End If
                For ip = 1 To nb
                    xb = XL(ip)
                    yb = YL(ip)
                    Xmodel(ip) = xb * c1
                    Ymodel(ip) = xb * s1
                    Zmodel(ip) = yb
                Next ip
            Else
                nb = Npv
                ii = 0
                For ip = 1 To Npointb
                    If Jpoint(ip) = 0 Then
                        ii = ii + 1
                        xb = XL(ip)
                        yb = YL(ip)
                        Xmodel(ii) = xb * c1
                        Ymodel(ii) = xb * s1
                        Zmodel(ii) = yb
                    End If
                Next ip
            End If
            Call SectStore(nn, nb)  '断面の座標データ保存
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
            nn = nn + nb
        Next isect

    End Sub

    Private Sub LeftPlaneCalc2()
        '左端面の座標計算
        Dim ip As Integer
        Dim xb, yb As Single

        For ip = 1 To Npointb
            xb = XL(ip)
            yb = YL(ip)
            Xmodel(ip) = xb
            Ymodel(ip) = 0
            Zmodel(ip) = yb
        Next ip

        Call SectStore(0, Npointb)  '断面の座標データ保存

    End Sub

    Private Sub LeftPlaneData1()
        '左端断面のﾃﾞｰﾀ設定
        Dim ie, ip, j As Integer
        ReDim Jpoint(Npoint), NumNodeV(Npoint)
        ReDim NLelem(Nelem, 8), XL(Npoint), YL(Npoint)
        ReDim XLdat(Npoint), YLdat(Npoint), ZLdat(Npoint)
        ReDim Xmodel(Npoint), Ymodel(Npoint), Zmodel(Npoint)

        Ns2 = 2 * Nsect
        For ie = 1 To Nelem
            For j = 1 To 8
                NLelem(ie, j) = NNelem(ie, j)
            Next j
        Next ie
        For ip = 1 To Npoint
            XL(ip) = X(ip) + Rlen(1)
            YL(ip) = Y(ip)
        Next ip
        Nelemb = Nelem
        Npointb = Npoint

    End Sub

    Private Sub MeshGeneS()
        '断面のﾒｯｼｭ生成
        Dim kround As Integer
        ReDim XL1(NumPstd), YL1(NumPstd)
        ReDim XL2(NumPstd), YL2(NumPstd)

        Nelem = 0
        Npoint = 0

        Call PlaneLine()   '面の両辺のﾒｯｼｭ計算
        Call PlaneSect()   '面の節点計算

        Call ElemGeneS() '四角形要素の作成

        If Alpha = 360 Then
            kround = 1
        Else
            kround = 0
        End If
        Call ReNumberEP(1, kround, Mesh(2), Mesh(3))  '要素･節点番号の付番改良

        KindSect = 0
        KindConnect = 0
        Nsect = Mesh(1)

        Ns2 = 2 * Nsect
        ReDim Xsect(Ns2), Ysect(Ns2), Zsect(Ns2)
        CosLX(1) = 0 : CosLX(2) = -1 : CosLX(3) = 0
        CosLY(1) = 0 : CosLY(2) = 0 : CosLY(3) = 1

        Xsect(0) = 0 : Ysect(0) = 0 : Zsect(0) = 0
        Xsect(Ns2) = Rlen(1) : Ysect(Ns2) = 0 : Zsect(Ns2) = 0

    End Sub

    Private Sub NodeCount1()
        '面内の節点のﾁｪｯｸ
        Dim ib, ie, ip, j, nb As Integer
        Dim kbuf(Npointb) As Integer

        Npv = 0
        For ie = 1 To Nelemb
            For j = 1 To 7 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    Npv = Npv + 1
                    kbuf(ib) = 1
                    Jpoint(ib) = 0
                End If
            Next j
            For j = 2 To 8 Step 2
                ib = NLelem(ie, j)
                If kbuf(ib) = 0 Then
                    kbuf(ib) = 1
                    Jpoint(ib) = 1
                End If
            Next j
        Next ie
        nb = 0
        For ip = 1 To Npointb
            If Jpoint(ip) = 0 Then
                nb = nb + 1
                NumNodeV(ip) = nb
            End If
        Next ip

    End Sub

    Private Sub PlaneLine()
        '面の両辺のﾒｯｼｭ計算
        Dim i, imax, mb, nb As Integer
        Dim angle, b1, b2, cosb, sinb, theta, xb, yb As Single

        mb = 2 * Mesh(2)
        angle = Dpai
        imax = mb

        nb = 0
        For i = 1 To imax
            b2 = (i - 1.0) / mb
            b1 = 1 - b2
            theta = angle * b2
            cosb = Math.Cos(theta)
            sinb = Math.Sin(theta)
            xb = Rlen(2) * cosb
            yb = Rlen(2) * sinb
            nb = nb + 1
            XL1(nb) = xb
            YL1(nb) = yb
            xb = Rlen(3) * cosb
            yb = Rlen(3) * sinb
            XL2(nb) = xb
            YL2(nb) = yb
        Next i

    End Sub

    Private Sub PlaneSect()
        '面の節点計算
        Dim i, ic, imax, j, jb, mb As Integer
        Dim b1, b2, x1, x2, y1, y2 As Single

        mb = 2 * Mesh(2)
        imax = mb

        ic = 0
        For i = 1 To imax
            x1 = XL1(i) : x2 = XL2(i)
            y1 = YL1(i) : y2 = YL2(i)
            If ic = 0 Then
                jb = 2 * Mesh(3)
            Else
                jb = Mesh(3)
            End If
            For j = 1 To jb + 1
                b1 = (j - 1.0) / jb
                b2 = 1 - b1
                Npoint = Npoint + 1
                X(Npoint) = b1 * x1 + b2 * x2
                Y(Npoint) = b1 * y1 + b2 * y2
            Next j
            If ic = 0 Then
                ic = 1
            Else
                ic = 0
            End If
        Next i

    End Sub

    Private Sub SectStore(ByVal ib As Integer, ByVal nb As Integer)
        '断面の座標データ保存
        'ib･･･ﾍﾞｰｽ節点数
        'nb･･･節点数
        Dim ii, ip As Integer
        For ip = 1 To nb
            ii = ib + ip
            Xdata(ii) = Xmodel(ip)
            Ydata(ii) = Ymodel(ip)
            Zdata(ii) = Zmodel(ip)
        Next ip

    End Sub

    Private Sub SolDDat11g_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim icc, ii As Integer

        Fx$ = DirOpen$ + "\SolDDat11g.tmp"
        Try
            ii = FreeFile()
            FileOpen(ii, Fx$, OpenMode.Input)
            icc = 1
            Input(ii, Rlen(1))
            Input(ii, Alpha)
            Input(ii, Rlen(2))
            Input(ii, Rlen(3))
            Input(ii, Mesh(1))
            Input(ii, Mesh(2))
            Input(ii, Mesh(3))
        Catch
            '処理不要
        End Try
        If icc > 0 Then
            FileClose(ii)
        End If

        TextBox1.Text = Str(Rlen(1))
        TextBox2.Text = Str(Alpha)
        TextBox3.Text = Str(Rlen(2))
        TextBox4.Text = Str(Rlen(3))
        TextBox5.Text = Str(Mesh(1))
        TextBox6.Text = Str(Mesh(2))
        TextBox7.Text = Str(Mesh(3))

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ii, ix, kh As Integer

        Call DataSet(kh)    'ﾃﾞｰﾀの設定
        ii = FreeFile()
        FileOpen(ii, Fx$, OpenMode.Output)
        WriteLine(ii, Rlen(1))
        WriteLine(ii, Alpha)
        WriteLine(ii, Rlen(2))
        WriteLine(ii, Rlen(3))
        WriteLine(ii, Mesh(1))
        WriteLine(ii, Mesh(2))
        WriteLine(ii, Mesh(3))
        FileClose(ii)

        If kh < 0 Then
            Exit Sub
        End If

        Call DataSizeS()    '断面のﾃﾞｰﾀｻｲｽﾞの設定

        Call MeshGeneS()    '断面のﾒｯｼｭ生成

        Call LeftPlaneData1() '左端断面のﾃﾞｰﾀ設定

        Nelem = Nelemb * Nsect
        Call NodeCount1() '面内の節点のﾁｪｯｸ

        Npoint = Npointb * (Nsect + 1) + Npv * Nsect
        ReDim NNelem(Nelem, 20), NumMat(Nelem)
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)

        Call LeftPlaneCalc2() '左端面の座標計算

        If Alpha = 360 Then
            KindRad = 0
        Else
            KindRad = 1
        End If
        Call MeshPlaneCalR() '各放射ﾒｯｼｭ面の座標計算
        Call ElemGeneR()    '軸回転体の六面体要素の作成

        aa$ = "円筒断面のリング（リング半径" + LTrim(Str(Rlen(1)))
        aa$ = aa$ + "×角度（°）" + LTrim(Str(Alpha))
        Title$ = aa$ + "×円筒半径" + LTrim(Str(Rlen(3))) + "）"

        Call DfilePrepA()   '構造ﾃﾞｰﾀﾌｧｲﾙ保存の前処理

        ReDim NumMat(Nelem)
        For i = 1 To Nelem
            NumMat(i) = 1
        Next i
        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6() '立体ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class