'円穴底のコーナーRの処理ﾌﾟﾛｸﾞﾗﾑ

Public Class SolDDat4

    Dim KindR As Integer        '円穴処理の区分（1:底のコーナーＲ、2:入口の面取りＲ）
    Dim KindSAxis As Integer    '円穴の軸方向（1:X軸、2:Y軸、3:Z軸）
    Dim Nplane As Integer       '円部の面の数（開始・終了面を含む）

    Dim EpsSA As Single         '座標の許容範囲
    Dim Rcircle As Single       '円穴の半径
    Dim Rcorner As Single       'コーナー・入口のＲ
    Dim Slope2 As Single        '傾斜２
    Dim VC1 As Single           '円中心の座標1（右手系）
    Dim VC2 As Single           '円中心の座標2（右手系）
    Dim Vstart As Single        '開始面の軸方向座標値

    Private Sub CondDisp()
        '条件表示
        If KindR = 1 Then
            RadioButton4.Checked = True
        Else
            RadioButton5.Checked = True
        End If
        Select Case KindSAxis
            Case 1
                RadioButton6.Checked = True
                Label11.Text = "開始面のＸ座標値"
                Label3.Text = "中心のＹ座標"
                Label7.Text = "中心のＺ座標"
            Case 2
                RadioButton7.Checked = True
                Label11.Text = "開始面のＹ座標値"
                Label3.Text = "中心のＺ座標"
                Label7.Text = "中心のＸ座標"
            Case 3
                RadioButton8.Checked = True
                Label11.Text = "開始面のＺ座標値"
                Label3.Text = "中心のＸ座標"
                Label7.Text = "中心のＹ座標"
        End Select
        TextBox5.Text = Str(Vstart)
        TextBox6.Text = Str(EpsSA)
        TextBox1.Text = Str(Rcircle)
        TextBox2.Text = Str(VC1)
        TextBox3.Text = Str(VC2)
        TextBox4.Text = Str(Rcorner)
        TextBox7.Text = Str(Nplane)

    End Sub

    Private Sub CornerRTreat(ByRef kh As Integer)
        'ｺｰﾅｰRの処理
        'kh･･･ｴﾗｰの有無(0:ない、-1:有り）
        Dim i, ic, icc, ie, ii, j, jj, k, km, kk, nb0, nb As Integer
        Dim b1, b3, r1, r2, rb As Single
        Dim kbuf(Npoint) As Integer
        ReDim KSelem(Nelem, 6)

        Call Elem3DPrep() '構造図作画準備
        Call InnerCheck2(KE1, KE2)    '内面ﾁｪｯｸ

        For ie = 1 To Nelem
            For ii = 1 To 6
                If KSelem(ie, ii) = 0 Then
                    Call SurfaceSet(ie, ii, KsurfPoint)  '面の設定
                    For j = 1 To 7 Step 2
                        k = KsurfPoint(j)
                        If kbuf(k) = 0 Then
                            Select Case KindSAxis
                                Case 1
                                    b1 = Xdata(k) - Vstart
                                Case 2
                                    b1 = Ydata(k) - Vstart
                                Case 3
                                    b1 = Zdata(k) - Vstart
                            End Select
                            If Math.Abs(b1) < EpsSA Then
                                Call RadiusCalc(k, b3) '半径の計算
                                If Math.Abs(b3 - Rcircle) < EpsSA Then
                                    kbuf(k) = 1
                                Else
                                    kbuf(k) = -1
                                End If
                            End If
                        End If
                    Next j
                End If
            Next ii
        Next ie
        r1 = Rcircle

        For i = 2 To Nplane
            For ie = 1 To Nelem
                For ii = 1 To 6
                    If KSelem(ie, ii) = 0 Then
                        Call SurfaceSet(ie, ii, KsurfPoint)  '面の設定
                        nb = 0
                        For j = 1 To 7 Step 2
                            k = KsurfPoint(j)
                            If kbuf(k) = i - 1 Then
                                nb = nb + 1
                            End If
                        Next j
                        If nb = 2 Then
                            icc = 0
                            For j = 1 To 7 Step 2
                                k = KsurfPoint(j)
                                jj = j + 2
                                If jj > 7 Then
                                    jj = 1
                                End If
                                kk = KsurfPoint(jj)
                                If kbuf(k) = i - 1 Then
                                    If kbuf(kk) = 0 Then
                                        Call RadiusCalc(kk, rb) '半径の計算
                                        ic = 0
                                        Select Case KindR
                                            Case 1
                                                If rb < r1 - EpsSA Then
                                                    ic = 1
                                                End If
                                            Case 2
                                                If rb > r1 + EpsSA Then
                                                    ic = 1
                                                End If
                                        End Select
                                        If ic > 0 Then
                                            icc = 1
                                            r2 = rb
                                            kbuf(kk) = i
                                            If i < Nplane Then  '頂点節点の計算
                                                Call VertexCalc(kh, k, kk)   '頂点の計算
                                                If kh < 0 Then
                                                    Exit Sub
                                                End If
                                            End If
                                        End If
                                    ElseIf kbuf(kk) = i Then
                                        icc = 1
                                    End If
                                ElseIf kbuf(kk) = i - 1 Then
                                    If kbuf(k) = 0 Then
                                        Call RadiusCalc(k, rb) '半径の計算
                                        ic = 0
                                        Select Case KindR
                                            Case 1
                                                If rb < r1 - EpsSA Then
                                                    ic = 1
                                                End If
                                            Case 2
                                                If rb > r1 + EpsSA Then
                                                    ic = 1
                                                End If
                                        End Select
                                        If ic > 0 Then
                                            icc = 1
                                            r2 = rb
                                            kbuf(k) = i
                                            If i < Nplane Then  '頂点節点の計算
                                                Call VertexCalc(kh, kk, k)   '頂点の計算
                                                If kh < 0 Then
                                                    Exit Sub
                                                End If
                                            End If
                                        End If
                                    ElseIf kbuf(k) = i Then
                                        icc = 1
                                    End If
                                End If
                            Next j
                            If icc = 0 Then
                                KSelem(ie, ii) = -1
                            End If
                        End If
                    End If
                Next ii
            Next ie
            r1 = r2

            For ie = 1 To Nelem
                For ii = 1 To 6
                    If KSelem(ie, ii) = 0 Then
                        Call SurfaceSet(ie, ii, KsurfPoint)  '面の設定
                        nb0 = 0
                        nb = 0
                        For j = 1 To 7 Step 2
                            k = KsurfPoint(j)
                            If kbuf(k) = i - 1 Then
                                nb = nb + 1
                            ElseIf kbuf(k) = i Then
                                nb0 = nb0 + 1
                            End If
                        Next j
                        If nb = 2 And nb0 = 2 Then
                            If i < Nplane Then
                                For j = 1 To 7 Step 2
                                    k = KsurfPoint(j)
                                    If kbuf(k) = i Then
                                        Call MidPointIn(ie, ii, k)     'R面外の中間節点の修正
                                    End If
                                Next j
                                For j = 1 To 7 Step 2
                                    k = KsurfPoint(j)
                                    jj = j + 2
                                    If jj > 7 Then
                                        jj = 1
                                    End If
                                    kk = KsurfPoint(jj)
                                    If kbuf(k) = i And kbuf(kk) = i Then
                                        km = KsurfPoint(j + 1)
                                        Call MidPointC(kh, k, kk, km)   '円周上中間点の計算
                                        Exit For
                                    End If
                                Next j
                            End If

                            For j = 1 To 7 Step 2
                                k = KsurfPoint(j)
                                km = KsurfPoint(j + 1)
                                If kbuf(km) = 0 Then
                                    jj = j + 2
                                    If jj > 7 Then
                                        jj = 1
                                    End If
                                    kk = KsurfPoint(jj)
                                    If kbuf(k) = i - 1 Then
                                        If kbuf(kk) = i Then
                                            Call MidPointR(kh, k, kk, km)   'R中間点の計算
                                            kbuf(km) = -1
                                            If kh < 0 Then
                                                Exit Sub
                                            End If
                                        End If
                                    ElseIf kbuf(kk) = i - 1 Then
                                        If kbuf(k) = i Then
                                            Call MidPointR(kh, kk, k, km)   'R中間点の計算
                                            kbuf(km) = -1
                                            If kh < 0 Then
                                                Exit Sub
                                            End If
                                        End If
                                    End If
                                End If
                            Next j
                        End If
                    End If
                Next ii
            Next ie
        Next i

    End Sub

    Private Sub MidPointC(ByRef kh As Integer, ByVal k As Integer, ByVal kk As Integer, _
    ByVal km As Integer)
        '円周上中間点の計算
        'kh･･･ｴﾗｰの有無(0:なし、-1:有り）
        'k,kk･･･頂点の節点番号
        'km･･･中間点の節点番号
        Dim aa$
        Dim b1, b2, b3, b4, rb, rbx, theta1, theta2, thetam As Single
        Dim x1, x2, y1, y2, z1, z2 As Single

        kh = 0
        aa$ = "円穴の中心位置が間違っています！"
        x1 = Xdata(k)
        x2 = Xdata(kk)
        y1 = Ydata(k)
        y2 = Ydata(kk)
        z1 = Zdata(k)
        z2 = Zdata(kk)
        Select Case KindSAxis
            Case 1
                b1 = y1 - VC1
                b2 = z1 - VC2
                b3 = y2 - VC1
                b4 = z2 - VC2
            Case 2
                b1 = z1 - VC1
                b2 = x1 - VC2
                b3 = z2 - VC1
                b4 = x2 - VC2
            Case 3
                b1 = x1 - VC1
                b2 = y1 - VC2
                b3 = x2 - VC1
                b4 = y2 - VC2
        End Select
        rb = Math.Sqrt(b1 * b1 + b2 * b2)
        rbx = Math.Sqrt(b3 * b3 + b4 * b4)
        If rb < EpsSA Or rbx < EpsSA Then
            kh = -1
            MsgBox(aa$, 0, "データエラー")
            Exit Sub
        End If
        Call AngleCalc(b1, b2, theta1)
        Call AngleCalc(b3, b4, theta2)
        If Math.Abs(theta2 - theta1) > Pai Then
            If theta1 < theta2 Then
                theta1 = theta1 + 2 * Pai
            Else
                theta2 = theta2 + 2 * Pai
            End If
        End If
        thetam = 0.5 * (theta1 + theta2)
        b3 = VC1 + rb * Math.Cos(thetam)
        b4 = VC2 + rb * Math.Sin(thetam)
        Select Case KindSAxis
            Case 1
                Xdata(km) = x1
                Ydata(km) = b3
                Zdata(km) = b4
            Case 2
                Ydata(km) = y1
                Zdata(km) = b3
                Xdata(km) = b4
            Case 3
                Zdata(km) = z1
                Xdata(km) = b3
                Ydata(km) = b4
        End Select

    End Sub

    Private Sub MidPointIn(ByVal ie As Integer, ByVal ii As Integer, ByVal kx As Integer)
        'R面外の中間節点の修正
        'ie,ii･･･要素番号、面番号
        'kx･･･頂点節点番号
        Dim i, ic, j, jj, k, kk, km As Integer
        Dim kbuf(Npoint), ksbuf(8) As Integer

        Call SurfaceSet(ie, ii, ksbuf)  '面の設定
        For j = 1 To 8
            kbuf(ksbuf(j)) = -1
        Next j

        For i = 1 To 6
            If i <> ii Then
                Call SurfaceSet(ie, i, ksbuf)  '面の設定
                ic = 0
                For j = 1 To 7 Step 2
                    If ksbuf(j) = kx Then
                        ic = 1
                        Exit For
                    End If
                Next j
                If ic > 0 Then
                    For j = 1 To 7 Step 2
                        k = ksbuf(j)
                        jj = j + 2
                        If jj > 7 Then
                            jj = 1
                        End If
                        kk = ksbuf(jj)
                        If k = kx Or kk = kx Then
                            km = ksbuf(j + 1)
                            If kbuf(km) = 0 Then
                                Xdata(km) = 0.5 * (Xdata(k) + Xdata(kk))
                                Ydata(km) = 0.5 * (Ydata(k) + Ydata(kk))
                                Zdata(km) = 0.5 * (Zdata(k) + Zdata(kk))
                                Exit Sub
                            End If
                        End If
                    Next j
                End If
            End If
        Next i

    End Sub

    Private Sub MidPointR(ByRef kh As Integer, ByVal k As Integer, ByVal kk As Integer, _
    ByVal km As Integer)
        'R中間点の計算
        'kh･･･ｴﾗｰの有無(0:なし、-1:有り）
        'k･･･開始側の節点番号
        'kk･･･終了側の節点番号
        'km･･･中間点の節点番号
        Dim aa$
        Dim ic As Integer
        Dim b1, b2, b3, b4, c1, rb, theta1, theta2, thetam As Single
        Dim x1, x2, y1, y2, z1, z2 As Single

        kh = 0
        aa$ = "円弧上の２点の高さ座標が同じです！"
        x1 = Xdata(k)
        x2 = Xdata(kk)
        y1 = Ydata(k)
        y2 = Ydata(kk)
        z1 = Zdata(k)
        z2 = Zdata(kk)
        Select Case KindR
            Case 1
                rb = Rcircle - Rcorner
            Case 2
                rb = Rcircle + Rcorner
        End Select

        ic = 0
        Select Case KindSAxis
            Case 1
                If x1 = x2 Then
                    ic = 1
                End If
            Case 2
                If y1 = y2 Then
                    ic = 1
                End If
            Case 3
                If z1 = z2 Then
                    ic = 1
                End If
        End Select
        If ic > 0 Then
            kh = -1
            MsgBox(aa$, 0, "データエラー")
            Exit Sub
        End If
        Select Case KindSAxis
            Case 1
                b1 = Math.Sqrt((y1 - VC1) ^ 2 + (z1 - VC2) ^ 2)
                b2 = x1 - Vstart
                b3 = Math.Sqrt((y2 - VC1) ^ 2 + (z2 - VC2) ^ 2)
                b4 = x2 - Vstart
            Case 2
                b1 = Math.Sqrt((z1 - VC1) ^ 2 + (x1 - VC2) ^ 2)
                b2 = y1 - Vstart
                b3 = Math.Sqrt((z2 - VC1) ^ 2 + (x2 - VC2) ^ 2)
                b4 = y2 - Vstart
            Case 3
                b1 = Math.Sqrt((x1 - VC1) ^ 2 + (y1 - VC2) ^ 2)
                b2 = z1 - Vstart
                b3 = Math.Sqrt((x2 - VC1) ^ 2 + (y2 - VC2) ^ 2)
                b4 = z2 - Vstart
        End Select
        If b4 > 0 Then
            c1 = 1.0
        Else
            c1 = -1.0
            b2 = -b2
            b4 = -b4
        End If
        Select Case KindR
            Case 1
                b1 = b1 - rb
                b3 = b3 - rb
            Case 2
                b1 = rb - b1
                b3 = rb - b3
        End Select
        Call AngleCalc(b1, b2, theta1)
        Call AngleCalc(b3, b4, theta2)
        If Math.Abs(theta2 - theta1) > Pai Then
            If theta1 < theta2 Then
                theta1 = theta1 + 2 * Pai
            Else
                theta2 = theta2 + 2 * Pai
            End If
        End If
        thetam = 0.5 * (theta1 + theta2)
        Select Case KindSAxis
            Case 1
                Xdata(km) = x1 + c1 * Rcorner * (Math.Sin(thetam) - Math.Sin(theta1))
            Case 2
                Ydata(km) = y1 + c1 * Rcorner * (Math.Sin(thetam) - Math.Sin(theta1))
            Case 3
                Zdata(km) = z1 + c1 * Rcorner * (Math.Sin(thetam) - Math.Sin(theta1))
        End Select
        b4 = Rcorner * Math.Cos(thetam)
        b1 = (b4 - b3) / (b1 - b3)
        b2 = 1.0 - b1
        Select Case KindSAxis
            Case 1
                Ydata(km) = b1 * y1 + b2 * y2
                Zdata(km) = b1 * z1 + b2 * z2
            Case 2
                Zdata(km) = b1 * z1 + b2 * z2
                Xdata(km) = b1 * x1 + b2 * x2
            Case 3
                Xdata(km) = b1 * x1 + b2 * x2
                Ydata(km) = b1 * y1 + b2 * y2
        End Select

    End Sub

    Private Sub RadiusCalc(ByVal kk As Integer, ByRef rb As Single)
        '半径の計算
        'kk･･･節点番号
        Dim b1, b2 As Single

        Select Case KindSAxis
            Case 1
                b1 = Ydata(kk) - VC1
                b2 = Zdata(kk) - VC2
            Case 2
                b1 = Zdata(kk) - VC1
                b2 = Xdata(kk) - VC2
            Case 3
                b1 = Xdata(kk) - VC1
                b2 = Ydata(kk) - VC2
        End Select
        rb = Math.Sqrt(b1 * b1 + b2 * b2)

    End Sub

    Private Sub VertexCalc(ByRef kh As Integer, ByVal k As Integer, ByVal kk As Integer)
        '頂点の計算
        'kh･･･ｴﾗｰの有無(0:ない、-1:有り）
        'k･･･ﾍﾞｰｽの節点番号
        'kk･･･修正の節点番号
        Dim aa$
        Dim b1, b2, b3, b4, rb, rbx, theta1, theta2, x1, x2, y1, y2, z1, z2 As Single

        kh = 0
        aa$ = "円穴の中心位置が間違っています！"
        x1 = Xdata(k)
        x2 = Xdata(kk)
        y1 = Ydata(k)
        y2 = Ydata(kk)
        z1 = Zdata(k)
        z2 = Zdata(kk)
        Select Case KindR
            Case 1
                rb = Rcircle - Rcorner
            Case 2
                rb = Rcircle + Rcorner
        End Select

        Select Case KindSAxis
            Case 1
                b1 = Math.Sqrt((y1 - VC1) ^ 2 + (z1 - VC2) ^ 2)
                b2 = x1 - Vstart
                b4 = x2 - Vstart
            Case 2
                b1 = Math.Sqrt((z1 - VC1) ^ 2 + (x1 - VC2) ^ 2)
                b2 = y1 - Vstart
                b4 = y2 - Vstart
            Case 3
                b1 = Math.Sqrt((x1 - VC1) ^ 2 + (y1 - VC2) ^ 2)
                b2 = z1 - Vstart
                b4 = z2 - Vstart
        End Select
        If b4 < 0 Then
            b2 = -b2
            b4 = -b4
        End If
        Select Case KindR
            Case 1
                b3 = b1 - rb
            Case 2
                b3 = rb - b1
        End Select
        If b3 < EpsSA Then
            kh = -1
            MsgBox(aa$, 0, "データエラー")
            Exit Sub
        End If
        Call AngleCalc(b3, b2, theta1)
        theta2 = Math.Asin(b4 / Rcorner)
        b2 = Rcorner * Math.Cos(theta2)
        Select Case KindR
            Case 1
                rbx = rb + b2
            Case 2
                rbx = rb - b2
        End Select
        b3 = rbx / b1

        Select Case KindSAxis
            Case 1
                Ydata(kk) = VC1 + b3 * (Ydata(k) - VC1)
                Zdata(kk) = VC2 + b3 * (Zdata(k) - VC2)
            Case 2
                Zdata(kk) = VC1 + b3 * (Zdata(k) - VC1)
                Xdata(kk) = VC2 + b3 * (Xdata(k) - VC2)
            Case 3
                Xdata(kk) = VC1 + b3 * (Xdata(k) - VC1)
                Ydata(kk) = VC2 + b3 * (Ydata(k) - VC2)
        End Select

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim ix, kh As Integer

        If RadioButton4.Checked = True Then
            KindR = 1
        Else
            KindR = 2
        End If
        If RadioButton6.Checked = True Then
            KindSAxis = 1
            Label11.Text = "開始面のＸ座標値"
            Label3.Text = "中心のＹ座標"
            Label7.Text = "中心のＺ座標"
        ElseIf RadioButton7.Checked = True Then
            KindSAxis = 2
            Label11.Text = "開始面のＹ座標値"
            Label3.Text = "中心のＺ座標"
            Label7.Text = "中心のＸ座標"
        Else
            KindSAxis = 3
            Label11.Text = "開始面のＺ座標値"
            Label3.Text = "中心のＸ座標"
            Label7.Text = "中心のＹ座標"
        End If

        Vstart = Val(TextBox5.Text)
        EpsSA = Val(TextBox6.Text)
        Rcircle = Val(TextBox1.Text)
        VC1 = Val(TextBox2.Text)
        VC2 = Val(TextBox3.Text)
        Rcorner = Val(TextBox4.Text)
        Nplane = Val(TextBox7.Text)

        Call CornerRTreat(kh)     'ｺｰﾅｰRの処理
        If kh < 0 Then
            Me.Close()
        End If

        KdataChange5 = 1

        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6() '立体ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub SolDDat4_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        KindR = 1
        KindSAxis = 3

        Call CondDisp()     '条件表示

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub

    Private Sub RadioButton6_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton6.Click
        If KindSAxis > 1 Then
            KindSAxis = 1
            Call CondDisp()     '条件表示
        End If
    End Sub

    Private Sub RadioButton7_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton7.Click
        If KindSAxis <> 2 Then
            KindSAxis = 2
            Call CondDisp()     '条件表示
        End If

    End Sub

    Private Sub RadioButton8_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton8.Click
        If KindSAxis < 3 Then
            KindSAxis = 3
            Call CondDisp()     '条件表示
        End If

    End Sub

    Private Sub RadioButton4_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton4.Click
        KindR = 1

    End Sub

    Private Sub RadioButton5_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton5.Click
        KindR = 2

    End Sub
End Class