'２分割の設定ﾌﾟﾛｸﾞﾗﾑ

Public Class SolDDat7

    Dim KindAxis As Integer     '指定座標軸（1:X軸、2:Y軸）
    Dim KindSide As Integer     '採用構造（1:プラス側、2:マイナス側）

    Dim DeltaV As Single        '指定誤差
    Dim Vstd As Single          '指定座標値

    Private Sub TwoDivide()
        '２分割処理（断面）
        Dim i, ic, ie, j, k, kk, nb, npb As Integer
        Dim b1, c1, c2 As Single
        Dim kbuf(Npoint), kebuf(Nelem) As Integer

        c1 = Vstd + DeltaV
        c2 = Vstd - DeltaV

        nb = 0
        For ie = 1 To Nelem
            ic = 0
            For j = 1 To 8
                kk = NNelem(ie, j)
                Select Case KindAxis
                    Case 1
                        b1 = X(kk)
                    Case 2
                        b1 = Y(kk)
                End Select
                Select Case KindSide
                    Case 1
                        If b1 < c2 Then
                            ic = -1
                            Exit For
                        End If
                    Case 2
                        If b1 > c1 Then
                            ic = -1
                            Exit For
                        End If
                End Select
            Next j
            If ic = 0 Then
                nb = nb + 1
                kebuf(ie) = nb
                For j = 1 To 8
                    kbuf(NNelem(ie, j)) = 1
                Next j
            End If
        Next ie

        npb = 0
        For i = 1 To Npoint
            If kbuf(i) > 0 Then
                npb = npb + 1
                kbuf(i) = npb
            End If
        Next i

        For ie = 1 To Nelem
            If kebuf(ie) > 0 Then
                kk = kebuf(ie)
                NumMat(kk) = NumMat(ie)
                For j = 1 To 8
                    NNelem(kk, j) = kbuf(NNelem(ie, j))
                Next j
            End If
        Next ie
        For i = 1 To Npoint
            If kbuf(i) > 0 Then
                k = kbuf(i)
                X(k) = X(i)
                Y(k) = Y(i)
            End If
        Next i

        Npoint = npb
        Nelem = nb

    End Sub

    Private Sub TwoDivide3()
        '２分割処理（立体）
        Dim i, ic, ie, j, k, kk, nb, npb As Integer
        Dim b1, c1, c2 As Single
        Dim kbuf(Npoint), kebuf(Nelem) As Integer

        c1 = Vstd + DeltaV
        c2 = Vstd - DeltaV

        nb = 0
        For ie = 1 To Nelem
            ic = 0
            For j = 1 To 20
                kk = NNelem(ie, j)
                Select Case KindAxis
                    Case 1
                        b1 = Xdata(kk)
                    Case 2
                        b1 = Ydata(kk)
                    Case 3
                        b1 = Zdata(kk)
                End Select
                Select Case KindSide
                    Case 1
                        If b1 < c2 Then
                            ic = -1
                            Exit For
                        End If
                    Case 2
                        If b1 > c1 Then
                            ic = -1
                            Exit For
                        End If
                End Select
            Next j
            If ic = 0 Then
                nb = nb + 1
                kebuf(ie) = nb
                For j = 1 To 20
                    kbuf(NNelem(ie, j)) = 1
                Next j
            End If
        Next ie

        npb = 0
        For i = 1 To Npoint
            If kbuf(i) > 0 Then
                npb = npb + 1
                kbuf(i) = npb
            End If
        Next i

        For ie = 1 To Nelem
            If kebuf(ie) > 0 Then
                kk = kebuf(ie)
                NumMat(kk) = NumMat(ie)
                For j = 1 To 20
                    NNelem(kk, j) = kbuf(NNelem(ie, j))
                Next j
            End If
        Next ie
        For i = 1 To Npoint
            If kbuf(i) > 0 Then
                k = kbuf(i)
                Xdata(k) = Xdata(i)
                Ydata(k) = Ydata(i)
                Zdata(k) = Zdata(i)
            End If
        Next i

        Npoint = npb
        Nelem = nb

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim ix As Integer

        If RadioButton1.Checked = True Then
            KindAxis = 1
        ElseIf RadioButton2.Checked = True Then
            KindAxis = 2
        ElseIf RadioButton5.Checked = True Then
            KindAxis = 3
        End If
        Vstd = Val(TextBox1.Text)
        DeltaV = Val(TextBox2.Text)
        If RadioButton3.Checked = True Then
            KindSide = 1
        ElseIf RadioButton4.Checked = True Then
            KindSide = 2
        End If

        Call TwoDivide3()    '２分割処理（立体）
        KdataChange5 = 1

        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New SolDDat6()  '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub SolDDat3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        KindAxis = 1
        RadioButton1.Checked = True
        RadioButton3.Checked = True
        Vstd = 0
        DeltaV = 0
        TextBox1.Text = Str(Vstd)
        TextBox2.Text = Str(DeltaV)

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class